![](https://raw.githubusercontent.com/mwouts/jupytext/main/docs/logo_large.png)

![CI](https://github.com/mwouts/jupytext/workflows/CI/badge.svg)
[![Documentation Status](https://readthedocs.org/projects/jupytext/badge/?version=latest)](https://jupytext.readthedocs.io/en/latest/?badge=latest)
[![codecov.io](https://codecov.io/github/mwouts/jupytext/coverage.svg?branch=master)](https://codecov.io/gh/mwouts/jupytext/branch/master)
[![Language grade: Python](https://img.shields.io/lgtm/grade/python/g/mwouts/jupytext.svg)](https://lgtm.com/projects/g/mwouts/jupytext/context:python)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![GitHub language count](https://img.shields.io/github/languages/count/mwouts/jupytext)](docs/languages.md)
[![Conda Version](https://img.shields.io/conda/vn/conda-forge/jupytext.svg)](https://anaconda.org/conda-forge/jupytext)
[![Pypi](https://img.shields.io/pypi/v/jupytext.svg)](https://pypi.python.org/pypi/jupytext)
[![pyversions](https://img.shields.io/pypi/pyversions/jupytext.svg)](https://pypi.python.org/pypi/jupytext)
[![Binder:notebook](https://img.shields.io/badge/binder-notebook-0172B2.svg)](https://mybinder.org/v2/gh/mwouts/jupytext/main?filepath=demo)
[![Binder:lab](https://img.shields.io/badge/binder-jupyterlab-0172B2.svg)](https://mybinder.org/v2/gh/mwouts/jupytext/main?urlpath=lab/tree/demo/get_started.ipynb)
[![](https://img.shields.io/badge/YouTube-JupyterCon%202020-red.svg)](https://www.youtube.com/watch?v=SDYdeVfMh48)

Have you always wished Jupyter notebooks were plain text documents? Wished you could edit them in your favorite IDE? And get clear and meaningful diffs when doing version control? Then... Jupytext may well be the tool you're looking for!

Jupytext is a plugin for Jupyter that can save Jupyter notebooks as either
- Markdown files (or [MyST Markdown](docs/formats.md#myst-markdown) files, or [R Markdown](docs/formats.md#r-markdown) or [Quarto](docs/formats.md#quarto) text notebooks)
- Scripts in [many languages](docs/languages.md).

## Use cases

Common [use cases](docs/examples.md) for Jupytext are:
- Doing version control on Jupyter Notebooks
- Editing, merging or refactoring notebooks in your favorite text editor
- Applying Q&A checks on notebooks.

## Install

You can install Jupytext with
- `pip install jupytext`
- or `conda install jupytext -c conda-forge`.

Please note that Jupytext includes an extension for Jupyter Lab. In the latest version of Jupytext, this extension is compatible with Jupyter Lab >= 3.0 only. If you use Jupyter Lab 2.x, please either stay with Jupytext 1.8.2, or install, on top of the latest pip or conda version of Jupytext, a version of the extension that is compatible with Jupyter Lab 2.x:
```
jupyter labextension install jupyterlab-jupytext@1.2.2  # For Jupyter Lab 2.x
```

Then, restart your Jupyter server (for more installation details, see the [install section](docs/install.md) in the documentation).

When Jupytext is installed, `.py` and `.md` files have a notebook icon. And you can really open and run these files as notebooks
<ul>
<details>
  <summary>With a click on the text file in Jupyter Notebook</summary>

[![](https://raw.githubusercontent.com/mwouts/jupytext-screenshots/master/JupytextDocumentation/TextNotebooks.png)](https://mybinder.org/v2/gh/mwouts/jupytext/main?filepath=demo)
(click on the image above to try this on [![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/mwouts/jupytext/main?filepath=demo))
</details>
<details>
<summary>With a click on the text file in JupyterLab</summary>
To do that, you will need to change the default viewer for text files supported by Jupytext by copy-pasting the following settings in `Document Manager` section:

```json
{
  "defaultViewers": {
    "markdown": "Jupytext Notebook",
    "jupytext-md": "Jupytext Notebook"
  }
}
```


Here is a screencast of the steps to follow:

[![](https://raw.githubusercontent.com/mwouts/jupytext/main/docs/jupyterlab_default_viewer.gif)](https://mybinder.org/v2/gh/mwouts/jupytext/master?urlpath=lab/tree/demo/get_started.ipynb)
(click on the image above to try this on [![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/mwouts/jupytext/master?urlpath=lab/tree/demo/get_started.ipynb))
</details><details>
  <summary>With a right click and <i>open with notebook</i> in Jupyter Lab</summary>

[![](https://raw.githubusercontent.com/mwouts/jupytext-screenshots/master/JupytextDocumentation/ContextMenuLab.png)](https://mybinder.org/v2/gh/mwouts/jupytext/main?urlpath=lab/tree/demo/get_started.ipynb)
(click on the image above to try this on [![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/mwouts/jupytext/main?urlpath=lab/tree/demo/get_started.ipynb))
</details>
</ul>

## Paired notebooks

The most convenient way to use Jupytext is probably through [paired notebooks](docs/paired-notebooks.md).

To pair a given `.ipynb` or text notebook to an additional notebook format, use either
<ul>
<details>
  <summary>the <i>"pair notebook with..."</i> commands in Jupyter Lab</summary>

[![](https://raw.githubusercontent.com/mwouts/jupytext/main/packages/labextension/jupytext_commands.png)](docs/install.md#jupytext-commands-in-jupyterlab)
</details>

<details>
  <summary>the <i>"pair notebook with..."</i> menu entries in Jupyter Notebook</summary>

[![](https://raw.githubusercontent.com/mwouts/jupytext/main/jupytext/nbextension/jupytext_menu.png)](docs/install.md#jupytext-menu-in-jupyter-notebook)
</details>

<details>
  <summary><code>jupytext</code> at the command line</summary>

with e.g.
```
jupytext --set-formats ipynb,py:percent notebook.ipynb
```
see the [documentation](docs/config.md#per-notebook-configuration).
</details>

<details>
  <summary>or a local or global <code>jupytext.toml</code> configuration file.</summary>

with e.g. the following content:
```
formats = "ipynb,py:percent"
```
see the [documentation](docs/config.md#configuring-paired-notebooks-globally).
</details>
</ul>

When you save a paired notebook in Jupyter, both the `.ipynb` file and the text version are updated on disk.

When a paired notebook is opened or _reloaded_ in Jupyter, the input cells are loaded from the text file, and combined with the output cells from the `.ipynb` file.

You can edit the text representation of the notebook in your favorite editor, and get the changes back in Jupyter by simply _reloading_ the notebook (Ctrl+R in Jupyter Notebook, <i>"reload notebook"</i> in Jupyter Lab). And the changes are propagated to the `.ipynb` file when you _save_ the notebook.

Alternatively, you can synchronise the two representations by running `jupytext --sync notebook.ipynb` at the command line.

## Which text format?

Jupytext implements many text [formats](docs/formats.md) for Jupyter Notebooks. If your notebook is mostly made of code, you will probably prefer to save it as a script:
-  Use the [percent format](docs/formats.md#the-percent-format), a format with explicit cell delimiters (`# %%`), supported by many IDE (Spyder, Hydrogen, VS Code, PyCharm and PTVS)
-  Or use the [light format](docs/formats.md#the-light-format), if you prefer to see fewer cell markers.

If your notebook contains more text than code, if you are writing a documentation or a book, you probably want to save your notebook as a Markdown document
- Use the [Jupytext Markdown format](docs/formats.md#jupytext-markdown) if you wish to render your notebook as a `.md` file (without its outputs) on GitHub
- Use the [MyST Markdown format](docs/formats.md#myst-markdown), a markdown flavor that “implements the best parts of reStructuredText”, if you wish to render your notebooks using Sphinx or [Jupyter Book](https://jupyterbook.org).
- Use the [R Markdown format](docs/formats.md#r-markdown) or the [Quarto format](docs/formats.md#quarto) if you want to open your Jupyter Notebooks in RStudio.

## More resources?

If you're new to Jupytext, you may want to start with the [FAQ](docs/faq.md) or with the [Tutorials](docs/tutorials.md), or with this short introduction to Jupytext: [![](https://img.shields.io/badge/YouTube-JupyterCon%202020-red.svg)](https://www.youtube.com/watch?v=SDYdeVfMh48).

# A Jupyter notebook extension for Jupytext

This extension adds a [Jupytext](https://github.com/mwouts/jupytext/blob/master/README.md) menu to Jupyter notebook. Use the menu to select the desired ipynb/text pairing for your notebook.

![Jupytext menu screenshot](jupytext_menu.png)

## Installation

The extension requires [Jupytext](https://github.com/mwouts/jupytext/blob/master/README.md). Please make sure that Jupytext is installed on you system, and that its contents manager is active, i.e. that Markdown files and scripts are displayed with a notebook icon.

Installing Jupytext activates the Jupytext Menu by default. If you want to install and activate it manually, use the following commands:

```bash
jupyter nbextension install --py jupytext
jupyter nbextension enable --py jupytext
```

Add `--user` to these commands if you want to activate the extension only for the current user.

## How to develop this extension

If you wish to develop this extension, install the javascript file locally with:

```bash
cd jupytext/nbextension
jupyter nbextension install index.js --symlink --user
jupyter nbextension enable index --user
```

Then, make the desired changes to `index.js` and reload the extension by simply refreshing the notebook (Ctrl+R). In case your OS does not allow symlinks, edit the copy of `index.js` that is actually used by Jupyter (refer to the output of `jupyter nbextension install --user index.js`).

![](https://github.com/mwouts/jupytext/blob/17aea37c612f33a4e27eeee4b81966f1506920fd/docs/images/logo_large.png?raw=true)

<!-- INDEX-START -->

[![CI](https://github.com/mwouts/jupytext/actions/workflows/ci.yml/badge.svg?branch=main)](https://github.com/mwouts/jupytext/actions)
[![Documentation Status](https://readthedocs.org/projects/jupytext/badge/?version=latest)](https://jupytext.readthedocs.io/en/latest/?badge=latest)
[![codecov.io](https://codecov.io/github/mwouts/jupytext/coverage.svg?branch=main)](https://codecov.io/gh/mwouts/jupytext/branch/main)
[![MIT License](https://img.shields.io/github/license/mwouts/jupytext)](LICENSE)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![GitHub language count](https://img.shields.io/github/languages/count/mwouts/jupytext)](docs/languages.md)
[![Conda Version](https://anaconda.org/conda-forge/jupytext/badges/version.svg)](https://anaconda.org/conda-forge/jupytext/)
[![Pypi](https://img.shields.io/pypi/v/jupytext.svg)](https://pypi.python.org/pypi/jupytext)
[![pyversions](https://img.shields.io/pypi/pyversions/jupytext.svg)](https://pypi.python.org/pypi/jupytext)
[![Binder:lab](https://img.shields.io/badge/binder-jupyterlab-0172B2.svg)](https://mybinder.org/v2/gh/mwouts/jupytext/main?urlpath=lab/tree/demo/get_started.ipynb)
[![Binder:notebook](https://img.shields.io/badge/binder-notebook-0172B2.svg)](https://mybinder.org/v2/gh/mwouts/jupytext/main?filepath=demo)
[![launch - renku](https://renkulab.io/renku-badge.svg)](https://renkulab.io/projects/best-practices/jupytext/sessions/new?autostart=1)
[![Jupyter Con 2020](https://img.shields.io/badge/YouTube-JupyterCon%202020-red.svg)](https://www.youtube.com/watch?v=SDYdeVfMh48)

# Jupytext

Have you always wished Jupyter notebooks were plain text documents? Wished you could edit them in your favorite IDE? And get clear and meaningful diffs when doing version control? Then, Jupytext may well be the tool you're looking for!

## Text Notebooks

A Python notebook encoded in the `py:percent` [format](https://github.com/mwouts/jupytext/blob/main/docs/formats-scripts.md#the-percent-format) has a `.py` extension and looks like this:

```
# %% [markdown]
# This is a markdown cell

# %%
def f(x):
  return 3*x+1
```

Only the notebook inputs (and optionally, the metadata) are included. Text notebooks are well suited for version control. You can also edit or refactor them in an IDE - the `.py` notebook above is a regular Python file.

We recommend the `percent` format for notebooks that mostly contain code. The `percent` format is available for Julia, Python, R and many other [languages](https://github.com/mwouts/jupytext/blob/main/docs/languages.md).

If your notebook is documentation-oriented, a [Markdown-based format](https://github.com/mwouts/jupytext/blob/main/docs/formats-markdown.md) (text notebooks with a `.md` extension) might be more appropriate. Depending on what you plan to do with your notebook, you might prefer the Myst Markdown format, which interoperates very well with Jupyter Book, or Quarto Markdown, or even Pandoc Markdown.

## Installation

Install Jupytext in the Python environment that you use for Jupyter. Use either

    pip install jupytext

or

    conda install jupytext -c conda-forge

Then, restart your Jupyter Lab server, and make sure Jupytext is activated in Jupyter:  `.py` and `.md` files have a Notebook icon, and you can open them as Notebooks with a right click in Jupyter Lab.

![Notebook icon on text notebooks](https://github.com/mwouts/jupytext/blob/64b4be818508760116f91bf156342cb4cf724d93/docs/images/jupyterlab_right_click.png?raw=true)

## Paired Notebooks

Text notebooks with a `.py` or `.md` extension are well suited for version control. They can be edited or authored conveniently in an IDE. You can open and run them as notebooks in Jupyter Lab with a right click. However, the notebook outputs are lost when the notebook is closed, as only the notebook inputs are saved in text notebooks.

A convenient alternative to text notebooks are [paired notebooks](https://github.com/mwouts/jupytext/blob/main/docs/paired-notebooks.md). These are a set of two files, say `.ipynb` and `.py`, that contain the same notebook, but in different formats.

You can edit the `.py` version of the paired notebook, and get the edits back in Jupyter by selecting _reload notebook from disk_. The outputs will be reloaded from the `.ipynb` file, if it exists. The `.ipynb` version will be updated or recreated the next time you save the notebook in Jupyter.

To pair a notebook in Jupyter Lab, use the command `Pair Notebook with percent Script` from the Command Palette:

![](https://github.com/mwouts/jupytext/blob/64b4be818508760116f91bf156342cb4cf724d93/docs/images/pair_commands.png?raw=true)

To pair all the notebooks in a certain directory, create a [configuration file](https://github.com/mwouts/jupytext/blob/main/docs/config.md) with this content:

```
# jupytext.toml at the root of your notebook directory
formats = "ipynb,py:percent"
```

## Command line

Jupytext is also available at the [command line](https://github.com/mwouts/jupytext/blob/main/docs/using-cli.md). You can

- pair a notebook with `jupytext --set-formats ipynb,py:percent notebook.ipynb`
- synchronize the paired files with `jupytext --sync notebook.py` (the inputs are loaded from the most recent paired file)
- convert a notebook in one format to another with `jupytext --to ipynb notebook.py` (use `-o` if you want a specific output file)
- pipe a notebook to a linter with e.g. `jupytext --pipe black notebook.ipynb`

## Sample use cases

### Notebooks under version control

This is a quick how-to:
- Open your `.ipynb` notebook in Jupyter and [pair](https://github.com/mwouts/jupytext/blob/main/docs/paired-notebooks.md) it to a `.py` notebook, using either the _pair_ command in Jupyter Lab, or a global [configuration file](https://github.com/mwouts/jupytext/blob/main/docs/config.md)
- Save the notebook - this creates a `.py` notebook
- Add this `.py` notebook to version control

You might exclude `.ipynb` files from version control (unless you want to see the outputs versioned!). Jupytext will recreate the `.ipynb` files locally when the users open and save the `.py` notebooks.

### Collaborating on notebooks with Git

Collaborating on Jupyter notebooks through Git becomes as easy as collaborating on text files.

Assume that you have your `.py` notebooks under version control (see above). Then,
- Your collaborator pulls the `.py` notebook
- They open it _as a notebook_ in Jupyter (right-click in Jupyter Lab)
- At that stage the notebook has no outputs. They run the notebook and save it. Outputs are regenerated, and a local `.ipynb` file is created
- They edit the notebook, and push the updated `notebook.py` file. The diff is nothing else than a standard diff on a Python script.
- You pull the updated `notebook.py` script, and refresh your browser. The input cells are updated based on the new content of `notebook.py`. The outputs are reloaded from your local `.ipynb` file. Finally, the kernel variables are untouched, so you have the option to run only the modified cells to get the new outputs.

### Editing or refactoring a notebook in an IDE

Once your notebook is [paired](https://github.com/mwouts/jupytext/blob/main/docs/paired-notebooks.md) with a `.py` file, you can easily edit or refactor the `.py` representation of the notebook in an IDE.

Once you are done editing the `.py` notebook, you will just have to _reload_ the notebook in Jupyter to get the latest edits there.

Note: It is simpler to close the `.ipynb` notebook in Jupyter when you edit the paired `.py` file. There is no obligation to do so; however, if you don't, you should be prepared to read carefully the pop-up messages. If Jupyter tries to save the notebook while the paired `.py` file has also been edited on disk since the last reload, a conflict will be detected and you will be asked to decide which version of the notebook (in memory or on disk) is the appropriate one.

## More resources

Read more about Jupytext in the [documentation](https://jupytext.readthedocs.io).

If you're new to Jupytext, you may want to start with the [FAQ](https://github.com/mwouts/jupytext/blob/main/docs/faq.md) or with the [Tutorials](https://github.com/mwouts/jupytext/blob/main/docs/tutorials.md).

There is also this short introduction to Jupytext: [![](https://img.shields.io/badge/YouTube-JupyterCon%202020-red.svg)](https://www.youtube.com/watch?v=SDYdeVfMh48).

# A JupyterLab extension for Jupytext

This extension adds a few [Jupytext](https://github.com/mwouts/jupytext) commands to the command palette. Use these to select the desired ipynb/text pairing for your notebook.

The latest version for this extension is [![npm version](https://badge.fury.io/js/jupyterlab-jupytext.svg)](https://badge.fury.io/js/jupyterlab-jupytext).

Most users do not need to install this extension, since it is already included in the latest [jupytext](https://github.com/mwouts/jupytext/), both on [![Pypi](https://img.shields.io/pypi/v/jupytext.svg)](https://pypi.python.org/pypi/jupytext) and
[![Conda Version](https://img.shields.io/conda/vn/conda-forge/jupytext.svg)](https://anaconda.org/conda-forge/jupytext).

![](https://raw.githubusercontent.com/mwouts/jupytext/main/packages/labextension/jupytext_commands.png)

## Installation

Please install [Jupytext](https://github.com/mwouts/jupytext/blob/main/README.md#installation) first. As mentioned above, both the `pip` and `conda` packages do include the latest version of the JupyterLab extension, so in most cases you don't need to specifically install this `npm` package.

In case you're not using JupyterLab 3.x, you will have to install an older version of the extension that is compatible with your version. Please first install `jupytext` using `pip` or `conda`, and then downgrade the extension to a version compatible with your version of Jupyter Lab with:
```bash
jupyter labextension install jupyterlab-jupytext@1.2.2  # for JupyterLab 2.x
jupyter labextension install jupyterlab-jupytext@1.1.1  # for JupyterLab 1.x
```

# How to develop this extension

We assume that you have activated the conda environment described in [CONTRIBUTING.md](https://github.com/mwouts/jupytext/blob/main/CONTRIBUTING.md).

Then you can rebuild the Jupytext python package (with `BUILD_JUPYTERLAB_EXTENSION=1 python setup.py sdist bdist_wheel`) and reinstall it (`pip install dist/jupytext-x.x.x-py3-none-any.whl`).

Alternatively, if you prefer to develop iteratively, you could install a development version of the extension with

```bash
BUILD_JUPYTERLAB_EXTENSION=1 jupyter labextension develop . --overwrite
```

Read more on this on the [JupyterLab documentation](https://jupyterlab.readthedocs.io/en/latest/extension/extension_dev.html#developing-a-prebuilt-extension).

# How to publish a new version of the extension on npm

Please note that the main purpose of updating the extension on [npm](https://www.npmjs.com) is to keep the npm documentation up-to-date, since the extension is made available within the Python package itself.

Make sure you have `nodejs>=12` installed, bump the version in `package.json`, and then:
```bash
# Go to the extension folder
cd packages/labextension

# Cleanup
rm -rf lib node_modules yarn.lock

# Install JupyterLab's plugin manager
jlpm install

# Package the extension
npm pack

# Test the extension locally
jupyter labextension install jupyterlab-jupytext-xxx.tgz

# Publish the package on npm with
npm publish --access=public
```

# -*- coding: utf-8 -*-
# From https://juliabyexample.helpmanual.io/

# function to calculate the volume of a sphere
function sphere_vol(r)
    # julia allows Unicode names (in UTF-8 encoding)
    # so either "pi" or the symbol π can be used
    return 4/3*pi*r^3
end

# functions can also be defined more succinctly
quadratic(a, sqr_term, b) = (-b + sqr_term) / 2a

# calculates x for 0 = a*x^2+b*x+c, arguments types can be defined in function definitions
function quadratic2(a::Float64, b::Float64, c::Float64)
    # unlike other languages 2a is equivalent to 2*a
    # a^2 is used instead of a**2 or pow(a,2)
    sqr_term = sqrt(b^2-4a*c)
    r1 = quadratic(a, sqr_term, b)
    r2 = quadratic(a, -sqr_term, b)
    # multiple values can be returned from a function using tuples
    # if the return keyword is omitted, the last term is returned
    r1, r2
end

vol = sphere_vol(3)
# @printf allows number formatting but does not automatically append the \n to statements, see below
@printf "volume = %0.3f\n" vol
#> volume = 113.097

quad1, quad2 = quadratic2(2.0, -2.0, -12.0)
println("result 1: ", quad1)
#> result 1: 3.0
println("result 2: ", quad2)
#> result 2: -2.0

# ---
# jupyter:
#   kernelspec:
#     display_name: Julia 1.1.1
#     language: julia
#     name: julia-1.1
# ---

# +
# IJulia rocks! So does Plotly. Check it out

using Plotly
api_key = "" # visit https://plot.ly/api to generate an API username and password
username = ""

Plotly.signin(username, api_key)

# +
# Following data taken from http://julialang.org/ frontpage 
benchmarks = ["fib", "parse_int", "quicksort3", "mandel", "pi_sum", "rand_mat_stat", "rand_mat_mul"]
platforms = ["Fortran", "Julia", "Python", "R", "Matlab", "Mathematica", "Javascript", "Go"]

data = {
        platforms[1] => [0.26, 5.03, 1.11, 0.86, 0.80, 0.64, 0.96],
        platforms[2] => [0.91, 1.60, 1.14, 0.85, 1.00, 1.66, 1.01],
        platforms[3] => [30.37, 13.95, 31.98, 14.19, 16.33, 13.52, 3.41 ],
        platforms[4] => [411.36, 59.40, 524.29, 106.97, 15.42, 10.84, 3.98  ],
        platforms[5] => [1992.00, 1463.16, 101.84, 64.58, 1.29, 6.61, 1.10   ],
        platforms[6] => [64.46, 29.54, 35.74, 6.07, 1.32, 4.52, 1.16 ],
        platforms[7] => [2.18, 2.43, 3.51, 3.49, 0.84, 3.28, 14.60],
        platforms[8] => [1.03, 4.79, 1.25, 2.36, 1.41, 8.12, 8.51]
        }

pdata = [ {"x"=>benchmarks,"y"=>data[k],"bardir"=>"h","type"=>"bar","name"=>k} for k = platforms ]

layout = {
          "title"=> "Julia benchmark comparison (smaller is better, C performance = 1.0)",
          "barmode"=> "group",
          "autosize"=> false,
          "width"=> 900,
          "height"=> 900,
          "titlefont"=>
          {
           "family"=> "Open Sans",
           "size"=> 18,
           "color"=> "rgb(84, 39, 143)"
           },
          "margin"=> {"l"=>160, "pad"=>0},
          "xaxis"=> {
                     "title"=> "Benchmark log-time",
                     "type"=> "log"
                     },
          "yaxis"=> {"title"=> "Benchmark Name"}
          }

response = Plotly.plot(pdata,["layout"=>layout])

# Embed in an iframe within IJulia
s = string("<iframe height='750' id='igraph' scrolling='no' seamless='seamless' src='",
            response["url"],
            "/700/700' width='750'></iframe>")
display("text/html", s)

# +
# checkout https://plot.ly/api/ for more Julia examples!
# But to show off some other Plotly features:
x = 1:1500
y1 = sin(2*pi*x/1500.) + rand(1500)-0.5
y2 = sin(2*pi*x/1500.)

fish = {"x"=>x,"y"=> y1,
	"type"=>"scatter","mode"=>"markers",
	"marker"=>{"color"=>"rgb(0, 0, 255)","opacity"=>0.5 } }

fit = {"x"=> x,"y"=> y2,
	"type"=>"scatter", "mode"=>"markers", "opacity"=>0.8,
	"marker"=>{"color"=>"rgb(255, 0, 0)"} }

layout = {"autosize"=> false,
    "width"=> 650, "height"=> 550,
    "title"=>"Fish School",
	"xaxis"=>{ "ticks"=> "",
        "gridcolor"=> "white",
        "zerolinecolor"=> "white",    
        "linecolor"=> "white",
        "autorange"=> false,
        "range"=>[0,1500] },
	"yaxis"=>{ "ticks"=> "",
        "gridcolor"=> "white",
        "zerolinecolor"=> "white",
		"linecolor"=> "white",
        "autorange"=> false,
        "range"=>[-2.2,2.2] },
	"plot_bgcolor"=> "rgb(245,245,247)",
    "showlegend"=> false,
    "hovermode"=> "closest"}

response = Plotly.plot([fish, fit],["layout"=>layout])
s = string("<iframe height='750' id='igraph' scrolling='no' seamless='seamless' src='",
            response["url"],
            "/700/700' width='750'></iframe>")
display("text/html", s)

#' The below derives from
#' https://github.com/yihui/knitr/blob/master/inst/examples/knitr-spin.R
#'
#' This is a special R script which can be used to generate a report. You can
#' write normal text in roxygen comments.
#'
#' First we set up some options (you do not have to do this):

#+ setup, include=FALSE
library(knitr)
opts_chunk$set(fig.path = 'figure/silk-')

#' The report begins here.

#+ test-a, cache=FALSE
# boring examples as usual
set.seed(123)
x = rnorm(5)
mean(x)

#' You can not use here the special syntax {{code}} to embed inline expressions, e.g.
{{mean(x) + 2}}
#' is the mean of x plus 2.
#' The code itself may contain braces, but these are not checked.  Thus,
#' perfectly valid (though very strange) R code such as `{{2 + 3}} - {{4 - 5}}`
#' can lead to errors because `2 + 3}} - {{4 - 5` will be treated as inline code.
#'
#' Now we continue writing the report. We can draw plots as well.

#+ test-b, fig.height=5, fig.width=5
par(mar = c(4, 4, .1, .1)); plot(x)

#' Actually you do not have to write chunk options, in which case knitr will use
#' default options. For example, the code below has no options attached:

var(x)
quantile(x)

#' And you can also write two chunks successively like this:

#+ test-chisq5
sum(x^2) # chi-square distribution with df 5
#+ test-chisq4
sum((x - mean(x))^2) # df is 4 now

#' Done. Call spin('knitr-spin.R') to make silk from sow's ear now and knit a
#' lovely purse.

# /* you can write comments between /* and */ like C comments (the preceding #
# is optional)
Sys.sleep(60)
# */

# /* there is no inline comment; you have to write block comments */

# ---
# jupyter:
#   kernelspec:
#     display_name: R
#     language: R
#     name: ir
# ---

# %% [markdown]
# This is a jupyter notebook that uses the IR kernel.

# %%
sum(1:10)

# %%
plot(cars)

# %%

# ---
# jupyter:
#   kernelspec:
#     display_name: R
#     language: R
#     name: ir
# ---

# This notebook was created with IRKernel 0.8.12, and is not completely valid, as the code cell below contains an unexpected 'source' entry. This did cause https://github.com/mwouts/jupytext/issues/234. Note that the problem is solved when one upgrades to IRKernel 1.0.0.

library("ggplot2")
ggplot(mtcars, aes(mpg)) + stat_ecdf()

# -*- coding: utf-8 -*-
# ---
# jupyter:
#   kernelspec:
#     display_name: Julia 1.1.1
#     language: julia
#     name: julia-1.1
# ---

# %%
# This notebook is a semi top-down explanation. This cell needs to be
# executed first so that the operators and helper functions are defined
# All of this is explained in the later half of the notebook

using Compose, Interact
Compose.set_default_graphic_size(2inch, 2inch)

points_f = [
    (.1, .1),
    (.9, .1),
    (.9, .2),
    (.2, .2),
    (.2, .4),
    (.6, .4),
    (.6, .5),
    (.2, .5),
    (.2, .9),
    (.1, .9),
    (.1, .1)
]

f = compose(context(), stroke("black"), line(points_f))

rot(pic) = compose(context(rotation=Rotation(-deg2rad(90))), pic)
flip(pic) = compose(context(mirror=Mirror(deg2rad(90), 0.5w, 0.5h)), pic)
above(m, n, p, q) =
    compose(context(),
            (context(0, 0, 1, m/(m+n)), p),
            (context(0, m/(m+n), 1, n/(m+n)), q))

above(p, q) = above(1, 1, p, q)

beside(m, n, p, q) =
    compose(context(),
            (context(0, 0, m/(m+n), 1), p),
            (context(m/(m+n), 0, n/(m+n), 1), q))

beside(p, q) = beside(1, 1, p, q)

over(p, q) = compose(context(),
                (context(), p), (context(), q))

rot45(pic) =
    compose(context(0, 0, 1/sqrt(2), 1/sqrt(2),
        rotation=Rotation(-deg2rad(45), 0w, 0h)), pic)

# Utility function to zoom out and look at the context
zoomout(pic) = compose(context(),
                (context(0.2, 0.2, 0.6, 0.6), pic),
                (context(0.2, 0.2, 0.6, 0.6), fill(nothing), stroke("black"), strokedash([0.5mm, 0.5mm]),
                    polygon([(0, 0), (1, 0), (1, 1), (0, 1)])))

function read_path(p_str)
    tokens = [try parsefloat(x) catch symbol(x) end for x in split(p_str, r"[\s,]+")]
    path(tokens)
end

fish = compose(context(units=UnitBox(260, 260)), stroke("black"),
            read_path(strip(readall("fish.path"))))

rotatable(pic) = @manipulate for θ=0:0.001:2π
    compose(context(rotation=Rotation(θ)), pic)
end

blank = compose(context())

fliprot45(pic) = rot45(compose(context(mirror=Mirror(deg2rad(-45))),pic))

# Hide this cell.
display(MIME("text/html"), """<script>
var cell = \$(".container .cell").eq(0), ia = cell.find(".input_area")
if (cell.find(".toggle-button").length == 0) {
ia.after(
    \$('<button class="toggle-button">Toggle hidden code</button>').click(
        function (){ ia.toggle() }
        )
    )
ia.hide()
}
</script>""")

# %% [markdown]
# # Functional Geometry
# *Functional Geometry* is a paper by Peter Henderson ([original (1982)](users.ecs.soton.ac.uk/peter/funcgeo.pdf), [revisited (2002)](https://cs.au.dk/~hosc/local/HOSC-15-4-pp349-365.pdf)) which deconstructs the MC Escher woodcut *Square Limit*
#
# ![Square Limit](http://i.imgur.com/LjRzmNM.png)

# %% [markdown]
# > A picture is an example of a complex object that can be described in terms of its parts.
# Yet a picture needs to be rendered on a printer or a screen by a device that expects to
# be given a sequence of commands. Programming that sequence of commands directly is
# much harder than having an application generate the commands automatically from the
# simpler, denotational description.

# %% [markdown]
# A `picture` is a *denotation* of something to draw.
#
# e.g. The value of f here denotes the picture of the letter F

# %% [markdown]
# Original at http://nbviewer.jupyter.org/github/shashi/ijulia-notebooks/blob/master/funcgeo/Functional%20Geometry.ipynb

# %% [markdown]
# ## In conclusion
#
# We described Escher's *Square Limit* from the description of its smaller parts, which in turn were described in terms of their smaller parts.
#
# This seemed simple because we chose to talk in terms of an *algebra* to describe pictures. The primitives `rot`, `flip`, `fliprot45`, `above`, `beside` and `over` fit the job perfectly.
#
# We were able to describe these primitives in terms of `compose` `contexts`, which the Compose library knows how to render.
#
# Denotation can be an easy way to describe a system as well as a practical implementation method.
#
# [Abstraction barriers](https://mitpress.mit.edu/sicp/full-text/sicp/book/node29.html) are useful tools that can reduce the cognitive overhead on the programmer. It entails creating layers consisting of functions which only use functions in the same layer or layers below in their own implementation. The layers in our language were:
#
#     ------------------[ squarelimit ]------------------
#     -------------[ quartet, cycle, nonet ]-------------
#     ---[ rot, flip, fliprot45, above, beside, over ]---
#     -------[ compose, context, line, path,... ]--------
#     
# Drawing this diagram out is a useful way to begin building any library.
#

#' ---
#' jupyter:
#'   kernelspec:
#'     display_name: R
#'     language: R
#'     name: ir
#' ---

#' This notebook was created with IRKernel 0.8.12, and is not completely valid, as the code cell below contains an unexpected 'source' entry. This did cause https://github.com/mwouts/jupytext/issues/234. Note that the problem is solved when one upgrades to IRKernel 1.0.0.

library("ggplot2")
ggplot(mtcars, aes(mpg)) + stat_ecdf()

/* --- */
/* jupyter: */
/*   kernelspec: */
/*     display_name: SAS */
/*     language: sas */
/*     name: sas */
/* --- */

/* %% [markdown] */
/* # SAS Notebooks with jupytext */

/* %% */
proc sql;
    select *
    from sashelp.cars (obs=10)
    ;
quit; 

/* %% */
%let name = "Jupytext";

/* %% */
%put &name;

/* %% */
/* Note when defining macros "%macro" cannot be the first line of text in the cell */
%macro test;
    data temp;
        set sashelp.cars;
        name = "testx";
    run; 
    proc print data = temp (obs=10);
    run; 
%mend test;

%test

pip check
IF %ERRORLEVEL% NEQ 0 exit /B 1
jupytext --help
IF %ERRORLEVEL% NEQ 0 exit /B 1
if exist %PREFIX%\\share\\jupyter\\labextensions\\jupyterlab-jupytext\\package.json (exit 0) else (exit 1)
IF %ERRORLEVEL% NEQ 0 exit /B 1
exit /B 0

# ---
# jupyter:
#   kernelspec:
#     display_name: Bash
#     language: bash
#     name: bash
# ---

# %%
ls

# %%
# https://coderwall.com/p/euwpig/a-better-git-log
git config --global alias.lg "log --color --graph --pretty=format:'%Cred%h%Creset -%C(yellow)%d%Creset %s %Cgreen(%cr) %C(bold blue)<%an>%Creset' --abbrev-commit"

# %%
git lg

# ---
# jupyter:
#   kernelspec:
#     display_name: PowerShell
#     language: PowerShell
#     name: powershell
# ---

# This is an extract from
# https://github.com/Jaykul/Jupyter-PowerShell/blob/master/LiterateDevOps.ipynb

# +
$imageUrl = 'https://upload.wikimedia.org/wikipedia/commons/2/2f/PowerShell_5.0_icon.png'
$ImageData = @{ "png" = (Invoke-WebRequest $imageUrl -UseBasicParsing).RawContentStream.GetBuffer() }
# $ImageData

Write-Jupyter -InputObject $ImageData -Metadata @{ "image/png" = @{ 'width' = 32 } }
Write-Jupyter -InputObject $ImageData -Metadata @{ "image/png" = @{ 'width' = 64 } }

# This file originates from
# https://github.com/MicrosoftDocs/PowerShell-Docs/blob/staging/build.ps1

param(
    [switch]$SkipCabs,
    [switch]$ShowProgress
)

# Turning off the progress display, by default
$global:ProgressPreference = 'SilentlyContinue'
if ($ShowProgress) { $ProgressPreference = 'Continue' }

[Net.ServicePointManager]::SecurityProtocol = [Net.ServicePointManager]::SecurityProtocol -bor [Net.SecurityProtocolType]::Tls12
$tempDir = [System.IO.Path]::GetTempPath()

# Pandoc source URL
$panDocVersion = "2.7.3"
$pandocSourceURL = "https://github.com/jgm/pandoc/releases/download/$panDocVersion/pandoc-$panDocVersion-windows-x86_64.zip"

$pandocDestinationPath = New-Item (Join-Path $tempDir "pandoc") -ItemType Directory -Force
$pandocZipPath = Join-Path $pandocDestinationPath "pandoc-$panDocVersion-windows-x86_64.zip"
Invoke-WebRequest -Uri $pandocSourceURL -OutFile $pandocZipPath

Expand-Archive -Path $pandocZipPath -DestinationPath $pandocDestinationPath -Force
$pandocExePath = Join-Path (Join-Path $pandocDestinationPath "pandoc-$panDocVersion-windows-x86_64") "pandoc.exe"

# Install ThreadJob if not available
$threadJob = Get-Module ThreadJob -ListAvailable
if ($null -eq $threadjob) {
    Install-Module ThreadJob -RequiredVersion 1.1.2 -Scope CurrentUser -Force
}

# Find the reference folder path w.r.t the script
$ReferenceDocset = Join-Path $PSScriptRoot 'reference'

# Go through all the directories in the reference folder
$jobs = [System.Collections.Generic.List[object]]::new()
$excludeList = 'module', 'media', 'docs-conceptual', 'mapping', 'bread', '7'
Get-ChildItem $ReferenceDocset -Directory -Exclude $excludeList | ForEach-Object -Process {
    $job = Start-ThreadJob -Name $_.Name -ArgumentList @($SkipCabs,$pandocExePath,$PSScriptRoot,$_) -ScriptBlock {
        param($SkipCabs, $pandocExePath, $WorkingDirectory, $DocSet)

        $tempDir = [System.IO.Path]::GetTempPath()
        $workingDir = Join-Path $tempDir $DocSet.Name
        $workingDir = New-Item -ItemType Directory -Path $workingDir -Force
        Set-Location $WorkingDir

        function Get-ContentWithoutHeader {
            param(
                $path
            )

            $doc = Get-Content $path -Encoding UTF8
            $start = $end = -1

            # search the first 30 lines for the Yaml header
            # no yaml header in our docset will ever be that long

            for ($x = 0; $x -lt 30; $x++) {
                if ($doc[$x] -eq '---') {
                    if ($start -eq -1) {
                        $start = $x
                    }
                    else {
                        if ($end -eq -1) {
                            $end = $x + 1
                            break
                        }
                    }
                }
            }
            if ($end -gt $start) {
                Write-Output ($doc[$end..$($doc.count)] -join "`r`n")
            }
            else {
                Write-Output ($doc -join "`r`n")
            }
        }

        $Version = $DocSet.Name
        Write-Verbose -Verbose "Version = $Version"

        $VersionFolder = $DocSet.FullName
        Write-Verbose -Verbose "VersionFolder = $VersionFolder"

        # For each of the directories, go through each module folder
        Get-ChildItem $VersionFolder -Directory | ForEach-Object -Process {
            $ModuleName = $_.Name
            Write-Verbose -Verbose "ModuleName = $ModuleName"

            $ModulePath = Join-Path $VersionFolder $ModuleName
            Write-Verbose -Verbose "ModulePath = $ModulePath"

            $LandingPage = Join-Path $ModulePath "$ModuleName.md"
            Write-Verbose -Verbose "LandingPage = $LandingPage"

            $MamlOutputFolder = Join-Path "$WorkingDirectory\maml" "$Version\$ModuleName"
            Write-Verbose -Verbose "MamlOutputFolder = $MamlOutputFolder"

            $CabOutputFolder = Join-Path "$WorkingDirectory\updatablehelp" "$Version\$ModuleName"
            Write-Verbose -Verbose "CabOutputFolder = $CabOutputFolder"

            if (-not (Test-Path $MamlOutputFolder)) {
                New-Item $MamlOutputFolder -ItemType Directory -Force > $null
            }

            # Process the about topics if any
            $AboutFolder = Join-Path $ModulePath "About"

            if (Test-Path $AboutFolder) {
                Write-Verbose -Verbose "AboutFolder = $AboutFolder"
                Get-ChildItem "$aboutfolder/about_*.md" | ForEach-Object {
                    $aboutFileFullName = $_.FullName
                    $aboutFileOutputName = "$($_.BaseName).help.txt"
                    $aboutFileOutputFullName = Join-Path $MamlOutputFolder $aboutFileOutputName

                    $pandocArgs = @(
                        "--from=gfm",
                        "--to=plain+multiline_tables",
                        "--columns=75",
                        "--output=$aboutFileOutputFullName",
                        "--quiet"
                    )

                    Get-ContentWithoutHeader $aboutFileFullName | & $pandocExePath $pandocArgs
                }
            }

            try {
                # For each module, create a single maml help file
                # Adding warningaction=stop to throw errors for all warnings, erroraction=stop to make them terminating errors
                New-ExternalHelp -Path $ModulePath -OutputPath $MamlOutputFolder -Force -WarningAction Stop -ErrorAction Stop

                # For each module, create update-help help files (cab and helpinfo.xml files)
                if (-not $SkipCabs) {
                    $cabInfo = New-ExternalHelpCab -CabFilesFolder $MamlOutputFolder -LandingPagePath $LandingPage -OutputFolder $CabOutputFolder

                    # Only output the cab fileinfo object
                    if ($cabInfo.Count -eq 8) { $cabInfo[-1].FullName }
                }
            }
            catch {
                Write-Error -Message "PlatyPS failure: $ModuleName -- $Version" -Exception $_
            }
        }

        Remove-Item $workingDir -Force -ErrorAction SilentlyContinue
    }
    Write-Verbose -Verbose "Started job for $($_.Name)"
    $jobs += $job
}

$null = $jobs | Wait-Job

# Variable to collect any errors in during processing
$allErrors = [System.Collections.Generic.List[string]]::new()
foreach ($job in $jobs) {
    Write-Verbose -Verbose "$($job.Name) output:"
    if ($job.Verbose.Count -gt 0) {
        foreach ($verboseMessage in $job.Verbose) {
            Write-Verbose -Verbose $verboseMessage
        }
    }

    if ($job.State -eq "Failed") {
        $allErrors += "$($job.Name) failed due to unhandled exception"
    }

    if ($job.Error.Count -gt 0) {
        $allErrors += "$($job.Name) failed with errors:"
        $allErrors += $job.Error.ReadAll()
    }
}

# If the above block, produced any errors, throw and fail the job
if ($allErrors.Count -gt 0) {
    $allErrors
    throw "There are errors during platyPS run!`nPlease fix your markdown to comply with the schema: https://github.com/PowerShell/platyPS/blob/master/platyPS.schema.md"
}

# Testing a Jupyter notebook with pytest

In this notebook we describe how to test a notebook with `jupytext`.

## Writing assertions and tests in a notebook

Our notebook defines a function that we wish to test. Our function is simply

```python
def f(x, n=5):
    return [x + i for i in range(n)] 
```

We can test the assertion in Jupyter with simply

```python
assert f(5) == [5,6,7,8,9]
```

Since the assertion above works, we don't get any message. It's more interesting to see what happens when an assertion fails. Remove one element of the list above and change the assertion to, say, 

    assert f(5) == [5,6,8,9]

When we run the above in Jupyter, we get

```stderr
---------------------------------------------------------------------------
AssertionError                            Traceback (most recent call last)
<ipython-input-3-1383ac5d204f> in <module>
----> 1 assert f(5) == [5,6,8,9]

AssertionError: 
```

Now if we run the notebook with `jupytext --check pytest 'Tests in a notebook.md'`, we get a more detailed description of the issue, thanks to `pytest`'s rewriting of assertions: 
```output
[jupytext] Reading Tests in a notebook.md
=========================== test session starts ===========================
platform win32 -- Python 3.7.5, pytest-5.2.2, py-1.8.0, pluggy-0.13.0
rootdir: C:\Users\Marco
collected 0 items / 1 errors

================================ ERRORS ===================================
_________ ERROR collecting Tests in a notebook vhs_lscr.py ________________
Tests in a notebook vhs_lscr.py:19: in <module>
    assert f(5) == [5,6,8,9]
E   assert [5, 6, 7, 8, 9] == [5, 6, 8, 9]
E    +  where [5, 6, 7, 8, 9] = <function f at 0x000002440A0D1798>(5)
!!!!!!!!!!!!! Interrupted: 1 errors during collection !!!!!!!!!!!!!!!!!!!!!
=========================== 1 error in 0.09s ==============================
```

Once all of our assertions pass, we can move them to a test function. In Jupyter the function is not evaluated - only when we run `jupytext --check pytest` on the notebook, the function is actually executed.

```python
def test_f():
    assert f(5) == [5,6,7,8,9]
```

## Going further

- [nbval](https://github.com/computationalmodelling/nbval) is a plugin for `pytest` that allows you to make sure that Jupyter notebooks run properly, and that their new outputs match the current ones. Use it as `pytest --nbval notebook.ipynb`.
- [ipytest](https://github.com/chmp/ipytest) defines a `%%run_pytest` cell magic that allows you to execute the tests in a cell directly in Jupyter.

---
jupyter:
  jupytext:
    cell_markers: region,endregion
    formats: ipynb,.pct.py:percent,.lgt.py:light,.spx.py:sphinx,md,Rmd,.pandoc.md:pandoc
    text_representation:
      extension: .Rmd
      format_name: rmarkdown
      format_version: '1.1'
      jupytext_version: 1.1.0
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

# A quick insight at world population

## Collecting population data

In the below we retrieve population data from the
[World Bank](http://www.worldbank.org/)
using the [wbdata](https://github.com/OliverSherouse/wbdata) python package

```{python}
import pandas as pd
import wbdata as wb

pd.options.display.max_rows = 6
pd.options.display.max_columns = 20
```

Corresponding indicator is found using search method - or, directly,
the World Bank site.

```{python}
wb.search_indicators('Population, total')  # SP.POP.TOTL
# wb.search_indicators('area')
# => https://data.worldbank.org/indicator is easier to use
```

Now we download the population data

```{python}
indicators = {'SP.POP.TOTL': 'Population, total',
              'AG.SRF.TOTL.K2': 'Surface area (sq. km)',
              'AG.LND.TOTL.K2': 'Land area (sq. km)',
              'AG.LND.ARBL.ZS': 'Arable land (% of land area)'}
data = wb.get_dataframe(indicators, convert_date=True).sort_index()
data
```

World is one of the countries

```{python}
data.loc['World']
```

Can we classify over continents?

```{python}
data.loc[(slice(None), '2017-01-01'), :]['Population, total'].dropna(
).sort_values().tail(60).index.get_level_values('country')
```

Extract zones manually (in order of increasing population)

```{python}
zones = ['North America', 'Middle East & North Africa',
         'Latin America & Caribbean', 'Europe & Central Asia',
         'Sub-Saharan Africa', 'South Asia',
         'East Asia & Pacific'][::-1]
```

And extract population information (and check total is right)

```{python}
population = data.loc[zones]['Population, total'].swaplevel().unstack()
population = population[zones]
assert all(data.loc['World']['Population, total'] == population.sum(axis=1))
```

## Stacked area plot with matplotlib

```{python}
import matplotlib.pyplot as plt
```

```{python}
plt.clf()
plt.figure(figsize=(10, 5), dpi=100)
plt.stackplot(population.index, population.values.T / 1e9)
plt.legend(population.columns, loc='upper left')
plt.ylabel('Population count (B)')
plt.show()
```

## Stacked bar plot with plotly

```{python}
import plotly.offline as offline
import plotly.graph_objs as go

offline.init_notebook_mode()
```

```{python}
data = [go.Scatter(x=population.index, y=population[zone], name=zone, stackgroup='World')
        for zone in zones]
fig = go.Figure(data=data,
                layout=go.Layout(title='World population'))
offline.iplot(fig)
```

# FAQ

## What is Jupytext?

Jupytext is a Python package that provides _two-way_ conversion between Jupyter notebooks and several other text-based formats like Markdown documents or scripts.

## Why would I want to convert my notebooks to text?

The text representation only contains the part of the notebook that you wrote (not the outputs). You get a cleaner diff history. Thanks to the _two-way_ conversion, you can also act on the text file and then propagate the changes to the original `.ipynb` file. Refactor your code or merge multiple contributions easily!

## How do I use Jupytext?

Open the notebook that you want to version control. _Pair_ the notebook to a script or a Markdown file using the [Jupytext Commands](install.md#jupytext-commands-in-jupyterlab) in JupyterLab.

Save the notebook, and you get two copies of the notebook: the original `*.ipynb` file, together with its paired text representation.

## Which Jupytext format do you recommend?

Notebooks that contain more text than code are best represented as Markdown documents. These are conveniently edited in IDEs and are also well rendered on GitHub.

Saving notebooks as scripts is an appropriate choice when you want to act on the code (refactor the code, import it in another script or notebook, etc). Use the `percent` format if you prefer to get explicit cell markers (compatible with VScode, PyCharm, Spyder, Hydrogen...). And if you prefer to get the minimal amount of cell markers, go for the `light` format.

## Can I see a sample of each format?

Go to [our demo folder](https://github.com/mwouts/jupytext/tree/main/demo) and see how our sample `World population` notebook is represented in each format.

## Can I edit the paired text file?

Yes! When you're done, reload the notebook in Jupyter. There, you will see the updated input cells combined with the matching output cells from the `.ipynb` file.

## Do I need to close my notebook in Jupyter?

Closing the notebook in Jupyter while you refactor it in another editor will help you avoid the message _Untitled.ipynb has changed on disk_. However, you don't really need to close the notebook. You can simply use _Reload Notebook from disk_ to load the latest edits once you're done with the other editor. When you reload the notebook, the kernel variables are preserved (and the outputs too if the notebook is paired to an `.ipynb` file), so you can continue your work where you left it.

## How do paired notebooks work?

The `.ipynb` file contains the full notebook. The paired text file only contains the input cells and selected metadata. When the notebook is loaded by Jupyter, input cells are loaded from the text file, while the output cells and the filtered metadata are restored using the `.ipynb` file. When the notebook is saved in Jupyter, the two files are updated to match the current content of the notebook.

## Can I create a notebook from a text file?

Certainly. Open your pre-existing scripts or Markdown files as notebooks with the _Open as Notebook_ menu in JupyterLab.

Output cells appear in the browser when you execute the notebook, but they are not written to the disk when you save the notebook.

The output cells are lost when you reload the notebook - if you want to avoid this, just _pair_ the text file to an `.ipynb` file.

If you want to convert text formats to notebooks programmatically, use one of
```shell
jupytext --to ipynb *.md                        # convert all .md files to notebooks with no outputs
jupytext --to ipynb --execute *.md              # convert all .md files to notebooks and execute them
jupytext --set-formats ipynb,md --execute *.md  # convert all .md files to paired notebooks and execute them
```

Conversions the other way use a similar format
```shell
jupytext --to md *.ipynb                         # convert all .ipynb files to .md files
```

## I want a specific cell to be commented out in the paired script

That's possible! See how to [activate or deactivate cells](advanced-options.md#active-and-inactive-cells).

## Which files should I version control?

Unless you want to version the outputs, you should version *only the text representation*. The paired `.ipynb` file can safely be deleted. It will be recreated locally the next time you open the notebook (from the text file) and save it.

Note that if you version both the `.md` and `.ipynb` files, you can configure `git diff` to [ignore the diffs on the `.ipynb` files](https://github.com/mwouts/jupytext/issues/251).

## I have modified a text file, but git reports no diff for the paired `.ipynb` file

The synchronization between the two files happens when you reload and *save* the notebook in Jupyter, or when you explicitly run `jupytext --sync`. If you want to force the synchronization on every commit, you could use `jupytext` as a [pre-commit hook](using-pre-commit.md).

## Jupyter warns me that the file has changed on disk

By default, Jupyter tries to save your notebooks every 2 minutes. If you have edited the text representation in another editor, it will detect that and ask you if you want to either overwrite, or _reload_ the notebook from disk.

You should simply click on _Reload_.

Note you can deactivate Jupyter's autosave function with the _Autosave Document_ setting in JupyterLab (search for _autosave_ in the _advanced settings editor_).

## When I reload, Jupyter warns me that my notebook has unsaved changes

That happens if you have edited both the notebook and the paired text file at the same time... If you know which version you want to keep, save it and reload the other. If you want to compare and merge both versions, backup the text file (with e.g. `git stash`), save the notebook, and merge the updated paired file with the backup (with e.g. `git stash pop`). Then, refresh the notebook in Jupyter.

## Jupyter complains that the `.ipynb` file is more recent than the text representation

This happens if you have edited the `.ipynb` file outside of Jupyter. This is a safeguard to avoid overwriting the notebook with an outdated text file.

In this case, a manual action is requested. Remove the paired `.md` or `.py` file if it is outdated, otherwise, edit and save it to update the file timestamp.

## Can I use Jupytext with JupyterHub, Binder, Nteract, Colab, Saturn or Azure?

Jupytext is compatible with JupyterHub (execute `pip install jupytext --user` to install it in user mode) and with Binder (add `jupytext` to the project requirements).

If you use another editor than Jupyter Lab, you probably can't get Jupytext there. However, you can still use Jupytext at the command line to manually sync the two representations of the notebook:
```shell
jupytext --set-formats ipynb,py:light notebook.ipynb   # Pair a notebook to a light script
jupytext --sync notebook.ipynb                         # Sync the two representations
```

## Can I re-write my git history to use text files instead of notebooks?

Indeed, you could substitute every `.ipynb` file in the project history with its Jupytext Markdown representation.

Technically this is available in just one command, which results in a complete rewrite of the history. Please experiment that in a branch, and think twice before pushing the result...
```shell
git filter-branch --tree-filter 'jupytext --to md */*.ipynb && rm -f */*.ipynb' HEAD
```

See the result and the cleaner diff history in the case of the [Python Data Science Handbook](https://github.com/mwouts/PythonDataScienceHandbook/tree/jupytext_no_ipynb).

---
jupyter:
  jupytext:
    text_representation:
      extension: .md
      format_name: markdown
      format_version: '1.2'
      jupytext_version: 1.5.0.rc3
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```python

```

# Installation

Installing Jupytext is as simple as
```bash
pip install jupytext
```
or
```bash
conda install jupytext -c conda-forge
```

You should run either one of these commands in the Python environment from which you launch Jupyter Lab. Once you have installed Jupytext, you need to restart Jupyter to be able to use Jupytext within Jupyter.

If the Python environment where the Jupyter server runs is read-only, for instance if your server is started using JupyterHub, you can still install Jupytext in user mode with:
```
/path_to_your_jupyter_environment/python -m pip install jupytext --user
```

Jupytext comes with a series of tools and plugin, which we will now briefly describe.

## Jupytext's contents manager

Jupytext provides a contents manager that let Jupyter open and save notebooks as text files. When Jupytext's content manager is active in Jupyter, scripts and Markdown documents have a notebook icon.

Jupytext's contents manager is activated automatically by Jupytext's server extension. When you start either `jupyter lab` or `jupyter notebook`, you should see a line that looks like:
```bash
[I 10:28:31.646 LabApp] [Jupytext Server Extension] Changing NotebookApp.contents_manager_class from LargeFileManager to jupytext.TextFileContentsManager
```

If you don't have the notebook icon on text documents after a fresh restart of your Jupyter server, please enable our server extension explicitly with
```
jupyter serverextension enable jupytext
```

When [`jupyter-fs>=1.0.0`](https://github.com/jpmorganchase/jupyter-fs) is being used along with `jupytext`, use `SyncMetaManager` as the contents manager for `jupyter-fs` as `jupytext` do not support async contents manager which is used in default `MetaManager` of `jupyter-fs`. The `jupyter-fs` config must be as follows:

```json
{
  "ServerApp": {
    "contents_manager_class": "jupyterfs.metamanager.SyncMetaManager",
  }
}
```
so that `jupytext` will create its own contents manager derived from `SyncMetaManager`.

## Jupytext commands in JupyterLab

Jupytext comes with a frontend extension for JupyterLab which provides pairing commands (accessible with View / Activate Command Palette, or Ctrl+Shift+C):

![](images/pair_commands.png)

The Jupytext extension for JupyterLab is bundled with Jupytext. It should be installed and enabled automatically. You can `enable` or `disable` it manually with either
```
jupyter labextension enable jupyterlab-jupytext
jupyter labextension disable jupyterlab-jupytext
```

From Jupytext 1.16.0 on, the version of the extension is compatible with JupyterLab 4.x only. If you wish to use Jupytext with JupyterLab 3.x or older, please
- install the `jupytext` package using `pip` or `conda`
- and then, install the last version of the `jupyterlab-jupytext` extension that is compatible with your version of JupyterLab, i.e.
```
jupyter labextension install jupyterlab-jupytext@1.3.11  # for JupyterLab 3.x
jupyter labextension install jupyterlab-jupytext@1.2.2  # for JupyterLab 2.x
jupyter labextension install jupyterlab-jupytext@1.1.1  # for JupyterLab 1.x
```

## Jupytext menu in Jupyter Notebook

In Jupyter Notebook 7 you can use the same pairing commands as in JupyterLab (see above).

In Jupyter Notebook **classic**, i.e. Jupyter Notebook 6.x and below, Jupytext used to provided an extension that added a Jupytext section in the File menu.

![](images/jupytext_menu.png)

That extension is available only for `jupytext<1.16`, and is automatically installed. If need be, you can install and activate it manually with
```
jupyter nbextension install --py jupytext [--user]
jupyter nbextension enable --py jupytext [--user]
```

See also [Issue #1095](https://github.com/mwouts/jupytext/issues/1095) where we discuss how to
add a Jupytext menu to Jupyter Lab and Notebook 7.x.

## Jupytext's command line interface

Jupytext provides a `jupytext` command in the terminal that you can use to pair, synchronize or convert notebooks in different formats.

The CLI is documented [here](using-cli.md).

Run `jupytext --version` to check which version of Jupytext is installed.

## Jupytext as a Python library

Jupytext is also available as a Python library. The `jupytext` package exposes the same `read`, `write`, `reads` and `writes` functions than `nbformat`, meaning that you can read and write notebooks within Python like this:

```
import jupytext

# read a notebook from a file
nb = jupytext.read("notebook.py")

# or from a string
nb = jupytext.reads(text, fmt="md:myst")

# write a notebook to a file in the 'py:percent' format
jupytext.write(nb, "notebook.py", fmt="py:percent")
```

In the above, `nb` is an instance of an `nbformat` `NotebookNode`. The notebook format is documented in the [nbformat documentation](https://nbformat.readthedocs.io).

# Contributing

Thanks for reading this! Contributions to this project are welcome, and there are many ways you can contribute

## Improve the documentation

You've spotted a typo, a paragraph that is not very clear, or an instruction that does not work? Please follow the _Fork me on Github_ link, edit the document, and submit a pull request.

## Report an issue

You have seen an issue with Jupytext, or you can't find your way in the documentation?
Please let us know, and provide enough information so that we can reproduce the problem.

## Propose enhancements

You want to submit an enhancement on Jupytext? Unless this is a small change, we usually prefer that you let us know beforehand: open an issue that describe the problem you want to solve.

## Add support for another language

A pull request for which you do not need to contact us in advance is the addition of a new language to Jupytext. In principle that should be easy - you would only have to:
- document the language extension and comment by adding one line to `_SCRIPT_EXTENSIONS` in `jupytext/languages.py`.
- add the language to `docs/languages.md`
- contribute a sample notebook in `tests/data/notebooks/inputs/ipynb_[language]`.
- run the tests suite (create a [development environment](developing.md), then execute `pytest` locally). The tests will generate various text representations corresponding to your notebook under  `tests/data/notebooks/outputs/`. Please verify that these files are valid scripts, and include them in your PR.

# Contributing to Jupytext

Thanks for reading this. Contributions to this project are welcome.
And there are many ways you can contribute...

## Spread the word

You like Jupytext? Probably your friends and colleagues will like it too. 
Show them what you've been able to do with: version control, collaboration on notebooks, refactoring of notebooks, notebooks integrated in library, notebook generated from Markdown documents...

By the way, we're also interested to know how you use Jupytext! There may well be applications we've not thought of!

## Improve the documentation

You think the documentation could be improved? You've spotted a typo, or you think you can rephrase a paragraph to make is easier to follow? Please follow the _Edit on Github_ link, edit the document, and submit a pull request.

## Report an issue

You have seen an issue with Jupytext, or you can't find your way in the [documentation](https://jupytext.readthedocs.io)?
Please let us know, and provide enough information so that we can reproduce the problem.

## Propose enhancements

You want to submit an enhancement on Jupytext? Unless this is a small change, we usually prefer that you let us know beforehand: open an issue that describe the problem you want to solve.

## Add support for another language

A pull request for which you do not need to contact us in advance is the addition of a new language to Jupytext. In principle that should be easy - you would only have to:
- document the language extension and comment by adding one line to `_SCRIPT_EXTENSIONS` in `languages.py`.
- contribute a sample notebook in `tests/notebooks/ipynb_[language]`.
- run the tests suite (with just `pytest`). The mirror tests will generate various text representations corresponding to your notebook under  `tests/notebooks/mirror/`. Please verify that these files are valid scripts, and commit them.

# How to setup a development environment for Jupytext

## Jupytext as a Python package

Most of Jupytext's code is written in Python. To develop the Python part of Jupytext, you should clone Jupytext, then create a dedicated Python env:
```
cd jupytext
conda create -n jupytext-dev jupyterlab pyyaml
conda activate jupytext-dev
pip install -r requirements-dev.txt
```

Tests are executed with `pytest`. Install `pytest-xdist` to allow running the tests in parallel:
```
pip install pytest-xdist
pytest -n 5
``` 

Build the `jupytext` package and install it with
```
python setup.py sdist bdist_wheel
pip install dist/jupytext-XXX.tar.gz
```

## Jupytext's extension for Jupyter Notebook

Our extension for Jupyter Notebook adds a Jupytext entry to Jupyter Notebook Menu. The code is found at `jupytext/nbextension/index.js`. Instructions to develop that extension are at `jupytext/nbextension/README.md`.

## Jupytext's extension for JupyterLab

Our extension for JupyterLab adds a series of Jupytext commands to JupyterLab. The code is in `packages/labextension`. See the `README.md` there for instructions on how to develop that extension.

## Jupytext's documentation

Install the documentation tools with
```
conda activate jupytext-dev
cd docs
pip install -r doc-requirements.txt
```
and build the HTML documentation locally with
```
make html
```

# Jupyter Collaboration

[Jupyter Collaboration](https://github.com/jupyterlab/jupyter-collaboration) is an official Jupyter extension that enables real-time collaboration in JupyterLab.

## Autoreload Feature

Beyond its collaboration features, Jupyter Collaboration also provides automatic file reloading. When the extension is installed, JupyterLab auto-reloads any file that gets modified on disk. This way, you can edit your notebook and text files outside of Jupyter, and the changes appear in Jupyter automatically without having to manually reload the document.

Note that Jupyter Collaboration also comes with an auto-save feature. By [default](https://github.com/jupyterlab/jupyter-collaboration/blob/67453e04dad30978d42fdef07040ae94cabe2bf0/projects/jupyter-server-ydoc/jupyter_server_ydoc/app.py#L45-L84), notebooks and text documents are saved one second after your last change.

## Collaborating on text notebooks

Currently, the real-time collaboration feature can be used:
- in the notebook editor when opening `.ipynb` notebooks
- in the text editor when opening `.py` or `.md` files

However, it does not yet work on `.py` and `.md` files opened as notebooks. If you want to collaborate on text notebooks, we recommend that you collaborate on paired notebooks (see [#1432](https://github.com/mwouts/jupytext/issues/1432)).

## Known issues

While using Jupytext and Jupyter Collaboration together mostly works, we have noticed a few side effects. Please review the list of [known issues](https://github.com/mwouts/jupytext/issues?q=state%3Aopen%20label%3A%22jupyter-collaboration%22) and make sure that you are comfortable with these.

# Jupytext's configuration file

Jupytext can use either `jupytext.toml` or `pyproject.toml` as its configuration file.

## Global pairing

To [pair](paired-notebooks.md) all the notebooks in the current folder and subfolders, all you need to do is to create a `jupytext.toml` file with this content:

```
# Pair ipynb notebooks to py:percent text notebooks
formats = "ipynb,py:percent"
```

With the above configuration, saving `notebook.ipynb` (or `notebook.py`) in Jupyter will have the effect to update both `notebook.ipynb` and `notebook.py` on disk.

You can use other text formats like `md`, `md:myst`, `Rmd` or `qmd`. The percent format is available for many languages. Use `auto:percent` to infer the file extension from the programmation language used in the notebook.

You can also configure Jupytext in a `pyproject.toml` config file rather than `jupytext.toml`. In that case, a sample configuration would be:
```
[tool.jupytext]
formats = "ipynb,py:percent"
```

## Pairing in subfolders

If you want to store your `.ipynb` notebooks in a `notebooks` folder, and their `.py` representation in a `scripts` folder, you can use this `jupytext.toml` configuration:
```
[formats]
"notebooks/" = "ipynb"
"scripts/" = "py:percent"
```

or this `pyproject.toml` configuration:
```
[tool.jupytext.formats]
"notebooks/" = "ipynb"
"scripts/" = "py:percent"
```

The `notebook/` prefix above is matched with the top-most parent folder of the matching name, not above the Jupytext configuration file.

## Global pairing vs individual pairing

Alternatively, notebooks can be paired individually using either the Jupytext commands in Jupyter Lab, or the command line interface:

```bash
jupytext --set-formats ipynb,py:percent notebook.ipynb
```

The individual pairing takes precedence over the global pairing. You can disable the global pairing for an individual notebook by setting formats to a single format:
```bash
jupytext --set-formats ipynb notebook.ipynb
```

Please note that, while Jupytext is Jupyter acts accordingly to both local or global Jupytext configuration files, the Jupyter commands in JupyterLab and the Jupytext menu in Jupyter only display the pairing information set in the notebooks itself and are not aware of the global configuration ([#177](https://github.com/mwouts/jupytext/issues/177)).

## Possible locations for the Jupytext configuration files

The Jupytext configuration file(s) should be either in the local or a parent directory, or in any directory listed in
```python
from jupytext.config import global_jupytext_configuration_directories
list(global_jupytext_configuration_directories())
```
which include `XDG_CONFIG_HOME` (defaults to `$HOME/.config`) and `XDG_CONFIG_DIR`.

The name for the configuration file can be any of `jupytext.config.JUPYTEXT_CONFIG_FILES`, i.e. `.jupytext` (in TOML),
`jupytext.toml`, `jupytext.yml`, `jupytext.yaml`, `jupytext.json` or `jupytext.py` (dot-files
like `.jupytext.toml` are accepted by the CLI version of Jupytext, but are not effective in Jupyter).

As mentionned above, you can also use your Python project's `pyproject.toml` file.

If you want to know, for a given directory, which configuration file is used by Jupytext, run this in a Python shell:
```python
from jupytext.config import find_jupytext_configuration_file
find_jupytext_configuration_file('.')
```

If you want to limit the search for a configuration file to a given parent directory, you can create an empty `.jupytext` configuration file in that directory. Alternatively, you can set the search boundaries with an environment variable `JUPYTEXT_CEILING_DIRECTORIES` - a colon-separated list of absolute paths.

If `JUPYTEXT_CEILING_DIRECTORIES` is defined, Jupytext will stop searching for configuration files when it meets one of these path. This can be helpful to avoid searching for configuration files on slow filesystems. It can also be useful if you don't want to use a global configuration - for instance, when running `pytest` on Jupytext, we use `JUPYTEXT_CEILING_DIRECTORIES="/tmp"`.

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```raw_mimetype="text/latex"
$1+1$
```

```raw_mimetype="text/restructuredtext"
:math:`1+1`
```

```raw_mimetype="text/html"
<b>Bold text<b>
```

```raw_mimetype="text/markdown"
**Bold text**
```

```raw_mimetype="text/x-python"
1 + 1
```

```
Not formatted
```

# Text notebooks

Jupytext can save Jupyter Notebooks as text files, with e.g. a `.py` or `.md`
extension. These text files only contain the inputs of your notebooks, as well
as [selected metadata](advanced-options.md#metadata-filtering).

Text notebooks are well suited for version control. They are standard text files
and you can easily edit or refactor them in the editor of your choice.

The outputs of the notebook are not stored on disk, unless you decide to
[pair](paired-notebooks.md) your text notebook to a regular `.ipynb` file.

## How to open a text notebook in Jupyter Lab

Once you have [installed](install.md) Jupytext, `.py` and `.md` files get a
notebook icon in Jupyter. And you can really open and run these files as
notebooks.

### With a right click

Right click on the text notebook, then select _Open With_ → _Notebook_:

![](images/jupyterlab_right_click.png)

Notes:

* you can achieve the same result if you use _Open With_ → _Jupytext Notebook_
* to open links to `.md` files in notebooks with the Notebook editor, you will
  need `jupyterlab>=3.6.0`.

### With a double click

Right clicking and the _Open With_ submenu allows you to choose among several
ways to open a file (several **viewers**, in Jupyter Lab jargon); and when you
double click instead, you open the file using **its default viewer**.

The default viewer for text notebooks is by default configured to be the
**Editor** (which means: text editor); if you'd prefer to have the text files
open as a notebook instead, you have the option to **redefine the default
viewer**, which is something defined for each document type.

Since version 1.15.1, `jupytext` comes with a helper command that allows you to
do this from the command line; and essentially you would just need to run

```bash
jupytext-config set-default-viewer
```

See also [the last section below](#more-on-default-viewers) for alternative
means to change and inspect the default viewers configuration

## How to open a text notebook in Jupyter notebook (nb7)

As of July 2023, Jupyter Notebook now comes as version 7.x - and is known in short as nb7

nb7 being built on top of Jupyter Lab, the principles described above apply as
well in this context; which means that

* you can always right-click a file and select *Open With* → *Notebook*;
* and if you have properly defined the default viewers as described above, you
  can also double-click a file to open it as a notebook.


## How to open a text notebook in Jupyter Notebook (classic)

Previous releases of Jupyter Notebook, i.e. up to version 6, were known as notebook classic

By default, notebook classic opens scripts and Markdown documents as notebooks.
If you want to open them with the text editor, select the document and click on
_edit_:

![](https://github.com/mwouts/jupytext-screenshots/raw/master/JupytextDocumentation/OpenAsText.png)


## How to decide which extensions are notebooks

By default, Jupytext will classify documents with a `.py`, `.R`, `.jl`, `.md`,
`.Rmd`, `.qmd` extension (and more!) as notebooks. If you prefer to limit the
notebook type to certain extensions, you can add a `notebook_extensions` option
to your [Jupytext config file (`jupytext.toml`)](config.md) configuration file
with, for instance, the following value:
```
notebook_extensions = "ipynb,md,qmd,Rmd"
```


## More on default viewers

### `jupytext-config`

This command has more options than the one shown above; in particular:

* you can use `jupytext-config` to set only some of the default viewers; for
  example, if you want to have your `.py` and `.md` files open as a notebook
  when you double-click them e.g.
  `jupytext-config set-default-viewer python markdown`
* you can use `jupytext-config` to inspect the current configuration, e.g.
  `jupytext-config list-default-viewer`
* you can use `jupytext-config unset-default-viewer python` to remove some of the settings

Here's an example of a session, starting from the default config of Jupyter Lab
```bash
# starting from the default config of Jupyter Lab
$ jupytext-config list-default-viewer
# we add the default viewer for 2 doctypes
$ jupytext-config set-default-viewer python markdown
# we check what was done
$ jupytext-config list-default-viewer
python: Jupytext Notebook
markdown: Jupytext Notebook
# we can now remove the default viewer for markdown
$ jupytext-config unset-default-viewer markdown
# and check again
$ jupytext-config list-default-viewer
python: Jupytext Notebook
$
```

### From Jupyter Lab settings dialog

Alternatively to using `jupytext-config`, you can also find the configuration of the default viewers from Jupyter Lab interactively; to do so, go to _Settings_, _Advanced Settings Editor_, and in the JSON view for the `Document Manager` copy-paste the following settings (or the subset that matches your use case):

```json
{
  "defaultViewers": {
    "markdown": "Jupytext Notebook",
    "myst": "Jupytext Notebook",
    "r-markdown": "Jupytext Notebook",
    "quarto": "Jupytext Notebook",
    "julia": "Jupytext Notebook",
    "python": "Jupytext Notebook",
    "r": "Jupytext Notebook"
  }
}
```

Here is a screencast of the steps to follow:

![](images/jupyterlab_default_viewer.gif)

```{include} ../README.md
:relative-docs: docs/
:start-after: <!-- INDEX-START -->
```

## Table of Contents

```{toctree}
:maxdepth: 1
install.md
text-notebooks.md
paired-notebooks.md
jupyterlab-extension.md
config.md
advanced-options.md
formats-scripts.md
formats-markdown.md
languages.md
using-cli.md
using-pre-commit.md
faq.md
tutorials.md
contributing.md
developing.md
changelog.md
```

# Pre-commit hook

Jupytext includes a hook for the [pre-commit](https://pre-commit.com/) framework.

## Do I need to use this hook?

You don't need Jupytext's pre-commit hook if you commit only the `.py` (or `.md`) representation of notebooks in your Git repository.

In that case, a possible pre-commit `.pre-commit-config.yaml` configuration that works well with `.py:percent` notebooks (and does not include a `jupytext` pre-commit hook!) is the following:

```yaml
repos:
- repo: https://github.com/pycqa/isort
    rev: 5.11.2
    hooks:
    - id: isort
      args: [--treat-comment-as-code, "# %%", --float-to-top]

- repo: https://github.com/astral-sh/ruff-pre-commit
  rev: v0.0.275
  hooks:
    - id: ruff
      args: [--fix, --exit-non-zero-on-fix]

- repo: https://github.com/psf/black
    rev: 23.3.0
    hooks:
    - id: black
      language_version: python3
```

## What is the point of having a `jupytext` pre-commit hook?

Jupyter keeps paired `.py` and `.ipynb` files in sync, but the synchronization happens only when you _save_ the notebook in Jupyter. If you edit the `.py` file manually, then the `.ipynb` file will be outdated until you reload and save the notebook in Jupyter, or execute `jupytext --sync`.

Jupytext's pre-commit hook can enforce this synchronization on commits:
```yaml
repos:
-   repo: https://github.com/mwouts/jupytext
    rev: v1.14.7  # CURRENT_TAG/COMMIT_HASH
    hooks:
    - id: jupytext
      args: [--sync]
```

If you combine Jupytext with other pre-commit hooks, you must ensure that all hooks will pass on any files you generate. For example, if you have a hook for using `black` to format all your python code, then you should use Jupytext's `--pipe` option to also format newly generated Python scripts before writing them:

```yaml
repos:
-   repo: https://github.com/mwouts/jupytext
    rev: v1.14.7  # CURRENT_TAG/COMMIT_HASH
    hooks:
    - id: jupytext
      args: [--sync, --pipe, black]
      additional_dependencies:
        - black==23.3.0 # Matches hook

-   repo: https://github.com/psf/black
    rev: 23.3.0
    hooks:
    - id: black
      language_version: python3
```

Tested examples of how to use the pre-commit hook are available in our [tests](https://github.com/mwouts/jupytext/tree/main/tests/external/pre_commit) -
see for instance [test_pre_commit_1_sync_with_config.py](https://github.com/mwouts/jupytext/blob/main/tests/external/pre_commit/test_pre_commit_1_sync_with_config.py).

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .code}
``` {.python}
%%time

print('asdf')
```
:::

::: {.cell .markdown}
Thanks for jupytext!
:::

::: {.cell .code}
``` {.python}
```
:::

---
jupyter:
  kernelspec:
    display_name: C++14
    language: C++14
    name: xeus-cling-cpp14
---

[![xeus-cling](images/xeus-cling.png)](https://github.com/QuantStack/xeus-cling/)

A Jupyter kernel for C++ based on the `cling` C++ interpreter and the `xeus` native implementation of the Jupyter protocol, xeus.

- GitHub repository: https://github.com/QuantStack/xeus-cling/
- Online documentation: https://xeus-cling.readthedocs.io/


## Usage

<div style="background: #efffed;
            border: 1px solid grey;
            margin: 8px 0 8px 0;
            text-align: center;
            padding: 8px; ">
    <i class="fa-play fa" 
       style="font-size: 40px;
              line-height: 40px;
              margin: 8px;
              color: #444;">
    </i>
    <div>
    To run the selected code cell, hit <pre style="background: #efffed">Shift + Enter</pre>
    </div>
</div>


## Output and error streams

`std::cout` and `std::cerr` are redirected to the notebook frontend.

```c++
#include <iostream>

std::cout << "some output" << std::endl;
```

```c++
std::cerr << "some error" << std::endl;
```

```c++
#include <stdexcept>
```

```c++
throw std::runtime_error("Unknown exception");
```

Omitting the `;` in the last statement of a cell results in an output being printed

```c++
int j = 5;
```

```c++
j
```

# Interpreting the C++ programming language

`cling` has a broad support of the features of C++. You can define functions, classes, templates, etc ...


## Functions

```c++
double sqr(double a)
{
    return a * a;
}
```

```c++
double a = 2.5;
double asqr = sqr(a);
asqr
```

## Classes

```c++
class Foo
{
public:

    virtual ~Foo() {}
    
    virtual void print(double value) const
    {
        std::cout << "Foo value = " << value << std::endl;
    }
};
```

```c++
Foo bar;
bar.print(1.2);
```

## Polymorphism

```c++
class Bar : public Foo
{
public:

    virtual ~Bar() {}
    
    virtual void print(double value) const
    {
        std::cout << "Bar value = " << 2 * value << std::endl;
    }
};
```

```c++
Foo* bar2 = new Bar;
bar2->print(1.2);
delete bar2;
```

## Templates

```c++
#include <typeinfo>

template <class T>
class FooT
{
public:
    
    explicit FooT(const T& t) : m_t(t) {}
    
    void print() const
    {
        std::cout << typeid(T).name() << " m_t = " << m_t << std::endl;
    }
    
private:
    
    T m_t;
};

template <>
class FooT<int>
{
public:
    
    explicit FooT(const int& t) : m_t(t) {}
    
    void print() const
    {
        std::cout << "m_t = " << m_t << std::endl;
    }
    
private:
    
    int m_t;
};
```

```c++
FooT<double> foot1(1.2);
foot1.print();
```

```c++
FooT<int> foot2(4);
foot2.print();
```

## C++11 / C++14 support

```c++
class Foo11
{
public:
    
    Foo11() { std::cout << "Foo11 default constructor" << std::endl; }
    Foo11(const Foo11&) { std::cout << "Foo11 copy constructor" << std::endl; }
    Foo11(Foo11&&) { std::cout << "Foo11 move constructor" << std::endl; }
};
```

```c++
Foo11 f1;
Foo11 f2(f1);
Foo11 f3(std::move(f1));
```

```c++
#include <vector>

std::vector<int> v = { 1, 2, 3};
auto iter = ++v.begin();
v
```

```c++
*iter
```

... and also lambda, universal references, `decltype`, etc ...


## Documentation and completion

 - Documentation for types of the standard library is retrieved on cppreference.com.
 - The quick-help feature can also be enabled for user-defined types and third-party libraries. More documentation on this feature is available at https://xeus-cling.readthedocs.io/en/latest/inline_help.html.


```c++
?std::vector
```

## Using the `display_data` mechanism


For a user-defined type `T`, the rich rendering in the notebook and JupyterLab can be enabled by by implementing the function `xeus::xjson mime_bundle_repr(const T& im)`, which returns the JSON mime bundle for that type.

More documentation on the rich display system of Jupyter and Xeus-cling is available at https://xeus-cling.readthedocs.io/en/latest/rich_display.html


### Image example

```c++
#include <string>
#include <fstream>

#include "xtl/xbase64.hpp"
#include "xeus/xjson.hpp"

namespace im
{
    struct image
    {   
        inline image(const std::string& filename)
        {
            std::ifstream fin(filename, std::ios::binary);   
            m_buffer << fin.rdbuf();
        }
        
        std::stringstream m_buffer;
    };
    
    xeus::xjson mime_bundle_repr(const image& i)
    {
        auto bundle = xeus::xjson::object();
        bundle["image/png"] = xtl::base64encode(i.m_buffer.str());
        return bundle;
    }
}
```

```c++
im::image marie("images/marie.png");
marie
```

### Audio example

```c++
#include <string>
#include <fstream>

#include "xtl/xbase64.hpp"
#include "xeus/xjson.hpp"

namespace au
{
    struct audio
    {   
        inline audio(const std::string& filename)
        {
            std::ifstream fin(filename, std::ios::binary);   
            m_buffer << fin.rdbuf();
        }
        
        std::stringstream m_buffer;
    };
    
    xeus::xjson mime_bundle_repr(const audio& a)
    {
        auto bundle = xeus::xjson::object();
        bundle["text/html"] =
           std::string("<audio controls=\"controls\"><source src=\"data:audio/wav;base64,")
           + xtl::base64encode(a.m_buffer.str()) +
            "\" type=\"audio/wav\" /></audio>";
        return bundle;
    }
}
```

```c++
au::audio drums("audio/audio.wav");
drums
```

### Display

```c++
#include "xcpp/xdisplay.hpp"
```

```c++
xcpp::display(drums);
```

### Update-display

```c++
#include <string>
#include "xcpp/xdisplay.hpp"

namespace ht
{
    struct html
    {   
        inline html(const std::string& content)
        {
            m_content = content;
        }
        std::string m_content;
    };

    xeus::xjson mime_bundle_repr(const html& a)
    {
        auto bundle = xeus::xjson::object();
        bundle["text/html"] = a.m_content;
        return bundle;
    }
}

// A red rectangle
ht::html rect(R"(
<div style='
    width: 90px;
    height: 50px;
    line-height: 50px;
    background-color: blue;
    color: white;
    text-align: center;'>
Original
</div>)");
```

```c++
xcpp::display(rect, "some_display_id");
```

```c++
// Update the rectangle to be blue
rect.m_content = R"(
<div style='
    width: 90px;
    height: 50px;
    line-height: 50px;
    background-color: red;
    color: white;
    text-align: center;'>
Updated
</div>)";

xcpp::display(rect, "some_display_id", true);
```

## Magics

Magics are special commands for the kernel that are not part of the C++ language.

They are defined with the symbol `%` for a line magic and `%%` for a cell magic.

More documentation for magics is available at https://xeus-cling.readthedocs.io/en/latest/magics.html.

```c++
#include <algorithm>
#include <vector>
```

```c++
std::vector<double> to_shuffle = {1, 2, 3, 4};
```

```c++
%timeit std::random_shuffle(to_shuffle.begin(), to_shuffle.end());
```

[![xtensor](images/xtensor.png)](https://github.com/QuantStack/xtensor/)

- GitHub repository: https://github.com/QuantStack/xtensor/
- Online documentation: https://xtensor.readthedocs.io/
- NumPy to xtensor cheat sheet: http://xtensor.readthedocs.io/en/latest/numpy.html

`xtensor` is a C++ library for manipulating N-D arrays with an API very similar to that of numpy.

```c++
#include <iostream>

#include "xtensor/xarray.hpp"
#include "xtensor/xio.hpp"
#include "xtensor/xview.hpp"

xt::xarray<double> arr1
  {{1.0, 2.0, 3.0},
   {2.0, 5.0, 7.0},
   {2.0, 5.0, 7.0}};

xt::xarray<double> arr2
  {5.0, 6.0, 7.0};

xt::view(arr1, 1) + arr2
```

Together with the C++ Jupyter kernel, `xtensor` offers a similar experience as `NumPy` in the Python Jupyter kernel, including broadcasting and universal functions.

```c++
#include <iostream>
#include "xtensor/xarray.hpp"
#include "xtensor/xio.hpp"
```

```c++
xt::xarray<int> arr
  {1, 2, 3, 4, 5, 6, 7, 8, 9};

arr.reshape({3, 3});

std::cout << arr;
```

```c++
#include "xtensor-blas/xlinalg.hpp"
```

```c++
xt::xtensor<double, 2> m = {{1.5, 0.5}, {0.7, 1.0}};
std::cout << "Matrix rank: " << std::endl << xt::linalg::matrix_rank(m) << std::endl;
std::cout << "Matrix inverse: " << std::endl << xt::linalg::inv(m) << std::endl;
std::cout << "Eigen values: " << std::endl << xt::linalg::eigvals(m) << std::endl;
```

```c++
xt::xarray<double> arg1 = xt::arange<double>(9);
xt::xarray<double> arg2 = xt::arange<double>(18);

arg1.reshape({3, 3});
arg2.reshape({2, 3, 3});

std::cout << xt::linalg::dot(arg1, arg2) << std::endl;
```

```c++

```

# Advanced options

## Metadata filtering

The metadata that is included in the text notebooks is governed by the two options `notebook_metadata_filter` and `cell_metadata_filter`. The default value for these options are
- `notebook_metadata_filter="kernelspec,jupytext"`, i.e. by default, only the Jupytext and the kernel metadata are included:
- `cell_metadata_filter=all,-autoscroll,-collapsed,-scrolled,-trusted,-ExecuteTime`, i.e. by default all the cell metadata are included, except those listed with a negative sign.

Suppose you want to keep all the notebook metadata but `widgets` and `varInspector` in the YAML header, and that for cell metadata, you want to allow `ExecuteTime` and `autoscroll`, but not `hide_output`. Then, you could either add
```python
notebook_metadata_filter="all,-widgets,-varInspector"
cell_metadata_filter="ExecuteTime,autoscroll,-hide_output"
```
to your [`jupytext.toml`](config.md) file, or set these options for one notebook using the [Jupytext CLI](using-cli.md) with
```
jupytext --opt notebook_metadata_filter=all,-widgets,-varInspector --opt cell_metadata_filter=ExecuteTime,autoscroll,-hide_output notebook.py
```

If you wanted no notebook or cell metadata at all in the text notebooks, you could add this to your [`jupytext.toml`](config.md) file:
```python
notebook_metadata_filter="-all"
cell_metadata_filter="-all"
```

It is possible to filter nested metadata - use a dot to represent the nested fields. For example, if you wanted to include the Jupytext metadata, but not the Jupytext version number, you can use:
```python
notebook_metadata_filter="-jupytext.text_representation.jupytext_version"
```

Finally, note that you can _hide_ the notebook metadata in an HTML comment in `.md` files - just set `hide_notebook_metadata=true` either at the command line or in the `jupytext.toml` file.

## Magic commands

In the `percent` and `light` script formats, magic commands (Jupyter commands prefixed by `%` or `%%`) are commented out in scripts. You can change this by using the `comment_magics` option, either in the `jupytext.toml` file or at the command line with `jupytext --opt`.

## Active and inactive cells

You might want to make some cell active only when the notebook is run in Jupyter, or active only when the `.py` file is interpreted by Python. To do so, add an `active-ipynb` tag to the cells that should only be executed in the `.ipynb` file, and an `active-py` tag to the cells that should be executed only in the Python script.

## More options

There are a couple more options available - please have a look at the `JupytextConfiguration` class in [config.py](https://github.com/mwouts/jupytext/blob/main/src/jupytext/config.py).

---
kernelspec:
  display_name: .NET (F#)
  language: F#
  name: .net-fsharp
---

This notebook was inspired by [Plottting with XPlot](https://github.com/dotnet/interactive/blob/master/NotebookExamples/fsharp/Docs/Plotting%20with%20Xplot.ipynb).

```{code-cell} fsharp
open XPlot.Plotly
```

```{code-cell} fsharp
let bar =
    Bar(
        name = "Bar 1",
        x = ["A"; "B"; "C"],
        y = [1; 3; 2])

[bar]
|> Chart.Plot
|> Chart.WithTitle "A sample bar plot"
```

# Developing Jupytext

## How to test development versions from GitHub

If you want to test a feature that has been integrated in `main` but not delivered yet to `pip` or `conda`, use
```
HATCH_BUILD_HOOKS_ENABLE=true pip install git+https://github.com/mwouts/jupytext.git
```

The above requires `node`. You can install it with e.g.
```
conda install 'nodejs>=20' -c conda-forge
```

Alternatively you can build only Jupytext core (e.g. skip the JupyterLab extension). To do so, remove `HATCH_BUILD_HOOKS_ENABLE=true` in the above.

Finally, if you want to test a development branch, use
```
HATCH_BUILD_HOOKS_ENABLE=true pip install git+https://github.com/mwouts/jupytext.git@branch
```
where `branch` is the name of the branch you want to test.

## Install and develop Jupytext locally

Most of Jupytext's code is written in Python. To develop the Python part of Jupytext, you should clone Jupytext, then create a dedicated Python env:
```
conda env create --file environment.yml  # or conda env update --file ...
conda activate jupytext-dev
```

Install the `jupytext` package in development mode with
```
HATCH_BUILD_HOOKS_ENABLE=true pip install -e '.[dev]'
```

We use the [pre-commit](https://pre-commit.com) package to run pre-commit scripts like `black` and `ruff` on the code.
Install it with
```
pre-commit install
```

Tests are executed with `pytest`. You can run them in parallel with for instance
```
pytest -n 5
```

Some tests require a Jupyter kernel pointing to the current environment:
```
python -m ipykernel install --name jupytext-dev --user
```

## Jupytext's extension for JupyterLab

Our extension for JupyterLab adds a series of Jupytext commands to JupyterLab. The code is in `packages/labextension`. See the `README.md` there for instructions on how to develop that extension.

## Jupytext's documentation

Install the documentation tools with
```
conda env create --file docs/environment.yml
conda activate jupytext-docs
cd docs
```
and build the HTML documentation locally with
```
rm -rf _build
make html
```

# Notebooks as code

## The `percent` format

The `percent` format is a representation of Jupyter notebooks as scripts, in which all cells are explicitly delimited with a commented double percent sign `# %%`. The `percent` format is currently available for these [languages](https://github.com/mwouts/jupytext/blob/main/src/jupytext/languages.py).

The format was introduced by Spyder in 2013, and is now supported by many editors, including
- [Spyder IDE](https://docs.spyder-ide.org/editor.html#defining-code-cells),
- [Hydrogen](https://nteract.gitbooks.io/hydrogen/docs/Usage/NotebookFiles.html#notebook-export), a package for Atom,
- [VS
  Code](https://code.visualstudio.com/docs/python/jupyter-support-py#_jupyter-code-cells),
- [Python Tools for Visual Studio](https://docs.microsoft.com/en-us/visualstudio/python/python-interactive-repl-in-visual-studio?view=vs-2019#work-with-code-cells),
- and [PyCharm Professional](https://www.jetbrains.com/help/pycharm/editing-jupyter-notebook-files.html#edit-content).

Our implementation of the `percent` format is as follows: cells can have
- a title
- a cell type (`markdown`, `md` or `raw`, omitted for code cells)
- and cell metadata
like in this example:

```python
# %% Optional title [cell type] key="value"
```

In the `percent` format, our previous example becomes:
```python
# %% [markdown]
# This is a multiline
# Markdown cell

# %% [markdown]
# Another Markdown cell


# %%
# This is a code cell
class A():
    def one():
        return 1

    def two():
        return 2
```

In the case of Python scripts, Markdown cells do accept multiline comments:
```python
# %% [markdown]
"""
This is a Markdown cell
that uses multiline comments
"""
```

By default Jupytext will use line comments when it converts your Jupyter notebooks for `percent` scripts. If you prefer to use multiline comments for all text cells, add a `{"jupytext": {"cell_markers": "\"\"\""}}` metadata to your notebook, either with the notebook metadata editor in Jupyter, or at the command line:
```bash
jupytext --update-metadata '{"jupytext": {"cell_markers": "\"\"\""}}' notebook.ipynb --to py:percent
```

If you want to use multiline comments for all your paired notebooks, you could also add
```python
cell_markers = '"""'
```
to your [`jupytext.toml` configuration file](config.md).

See how our `World population.ipynb` notebook is [represented](https://github.com/mwouts/jupytext/blob/main/demo/World%20population.pct.py) in the `percent` format.

## The `hydrogen` format

By default, [Jupyter magics](advanced-options.md#magic-commands) are commented in the `percent` representation. If you run the percent scripts in Hydrogen, use the `hydrogen` format, a variant of the `percent` format that does not comment Jupyter magic commands.

## The `light` format

The `light` format was introduced by Jupytext. That format can represent any script in one of these [languages](https://github.com/mwouts/jupytext/blob/main/src/jupytext/languages.py) as a Jupyter notebook.

When a script in the `light` format is converted to a notebook, Jupytext code paragraphs are turned into code cells, and comments that are not adjacent to code are converted to Markdown cells. Cell breaks occurs on blank lines outside of functions, classes or multiline comments.

For instance, in this example we have three cells:
```python
# This is a multiline
# Markdown cell

# Another Markdown cell


# This is a code cell
class A():
    def one():
        return 1

    def two():
        return 2
```

Code cells can contain multiple code paragraphs. In that case Jupytext uses an explicit start-of-cell delimiter that is, by default, `# +` (`// +` in C++, etc). The default end of cell delimiter is `# -`, and can be omitted when followed by another explicit start of cell marker, or the end of the file:

```python
# +
# A single code cell made of two paragraphs
a = 1


def f(x):
    return x+a
```

Metadata can be associated to a given cell using a key/value representation:
```python
# + key="value"
# A code cell with metadata

# + [markdown] key="value"
# A Markdown cell with metadata
```

The `light` format can use custom cell markers instead of `# +` or `# -`. If you prefer to mark cells with VS Code/PyCharm (resp. Vim) folding markers, set `"cell_markers": "region,endregion"` (resp. `"{{{,}}}"`) in the jupytext section of the notebook metadata. If you want to configure this as a global default, add either
```python
cell_markers = "region,endregion"  # Use VS Code/PyCharm region folding delimiters
```
or
```python
cell_markers = "{{{,}}}"           # Use Vim region folding delimiters
```
to your [`jupytext.toml` configuration file](config.md#).

See how our `World population.ipynb` notebook is [represented](https://github.com/mwouts/jupytext/blob/main/demo/World%20population.lgt.py) in that format.

## The `nomarker` format

The `nomarker` format is a variation of the `light` format with no cell marker at all. Please note that this format does not provide round-trip consistency - code cells are split on code paragraphs. By default, the `nomarker` format still includes a YAML header - if you prefer to also remove the header, set `"notebook_metadata_filter": "-all"` in the jupytext section of your notebook metadata.

## Sphinx-gallery scripts

Another popular notebook-like format for Python scripts is the Sphinx-gallery [format](https://sphinx-gallery.github.io/stable/syntax.html). Scripts that contain at least two lines with more than twenty hash signs are classified as Sphinx-Gallery notebooks by Jupytext.

Comments in Sphinx-Gallery scripts are formatted using reStructuredText rather than markdown. They can be converted to markdown for a nicer display in Jupyter by adding a `sphinx_convert_rst2md = True` line to your Jupytext configuration file. Please note that this is a non-reversible transformation—use this only with Binder. Revert to the default value `sphinx_convert_rst2md = False` when you edit Sphinx-Gallery files with Jupytext.

Turn a GitHub repository containing Sphinx-Gallery scripts into a live notebook repository with [Binder](https://mybinder.org/) and Jupytext by adding only two files to the repo:
- `binder/requirements.txt`, a list of the required packages (including `jupytext`)
- a [`jupytext.toml` configuration file](config.md#) with the following contents:
```
preferred_jupytext_formats_read = "py:sphinx"
sphinx_convert_rst2md = true
```

Our sample notebook is also represented in `sphinx` format [here](https://github.com/mwouts/jupytext/blob/main/demo/World%20population.spx.py).

# Jupytext CLI

## Command line conversion

Jupytext provides command line interface for converting notebooks between the different formats.

```bash
jupytext --to py notebook.ipynb                 # convert notebook.ipynb to a .py file
jupytext --to py:percent notebook.ipynb         # convert notebook.ipynb to a .py file in the double percent format
jupytext --to py:percent --opt comment_magics=false notebook.ipynb   # same as above + do not comment magic commands
jupytext --to markdown notebook.ipynb           # convert notebook.ipynb to a .md file
jupytext --output script.py notebook.ipynb      # convert notebook.ipynb to a script.py file

jupytext --to notebook notebook.py              # convert notebook.py to an .ipynb file with no outputs
jupytext --update --to notebook notebook.py     # update the input cells in the .ipynb file and preserve outputs and metadata

jupytext --to md --test notebook.ipynb          # Test round trip conversion

jupytext --to md --output - notebook.ipynb      # display the markdown version on screen
jupytext --from ipynb --to py:percent           # read ipynb from stdin and write double percent script on stdout
```

Jupytext has a `--sync` mode that updates all the paired representations of a notebook based on timestamps:
```bash
jupytext --set-formats ipynb,py notebook.ipynb  # Turn notebook.ipynb into a paired ipynb/py notebook
jupytext --sync notebook.ipynb                  # Update whichever of notebook.ipynb/notebook.py is outdated
```

You may also find useful to `--pipe` the text representation of a notebook into tools like `black`:
```bash
jupytext --sync --pipe black notebook.ipynb    # read most recent version of notebook, reformat with black, save
```

To reorder the imports in your notebook, use
```bash
jupytext --pipe 'isort - --treat-comment-as-code "# %%" --float-to-top' notebook.ipynb
```
(remove the `--float-to-top` argument if you prefer to run `isort` per cell).

For programs that don't accept pipes, use `{}` as a placeholder for the name of a temporary file that will contain the text representation of the notebook. For instance, run `pytest` on your notebook with:
```bash
jupytext --check 'pytest {}' notebook.ipynb    # export the notebook in format py:percent in a temp file, run pytest
```
Read more about running `pytest` on notebooks in our example [`Tests in a notebook.md`](https://github.com/mwouts/jupytext/blob/main/demo/Tests%20in%20a%20notebook.md#).
Note also that on Windows you need to use double quotes instead of single quotes and type e.g. `jupytext --check "pytest {}" notebook.ipynb`.

Execute `jupytext --help` to access the full documentation.

### Execute notebook cells

For convenience, when creating a notebook from text you can execute it:

```bash
jupytext --set-kernel - notebook.md             # create a YAML header with kernel metadata matching the current python executable
jupytext --set-formats md:myst notebook.md      # create a YAML header with an explicit jupytext format
jupytext --to notebook --execute notebook.md    # convert notebook.md to an .ipynb file and run it
```

If you wanted to convert a collection of Markdown files to paired notebooks, and execute them in the current Python environment, you could run:
```bash
jupytext --set-formats ipynb,md --execute *.md
```

#### Advanced usage: error tolerance

If any notebook cell errors, execution will terminate and `jupytext` will not save the notebook. This can cause headaches as the details of any error would be encoded in the notebook, which would not have been saved. But there's an error-tolerant way to execute a notebook: `jupyter nbconvert` has a mode which will still save a notebook if a cell errors, producing something akin to what would happen if you ran all cells manually in Jupyter's notebook UI.

```bash
# First, convert script (py/sh/R/jl etc) -> notebook. May need additional args to define input format etc as above.
jupytext --to ipynb script.py
# Then, execute notebook in place and allowing cells to produce errors
jupyter nbconvert --to ipynb --inplace --execute --allow-errors script.ipynb
# One can also combine these to a single command using jupytext --pipe
jupytext --to ipynb --pipe-fmt ipynb \
  --pipe 'jupyter nbconvert --to ipynb --execute --allow-errors --stdin --stdout' \
  script.py
```

In each of the above, `jupyter nbconvert` could be replaced with any alternative tool to execute a jupyter notebook non-interactively, including [papermill](https://github.com/nteract/papermill) which would allow notebook parameterisation (see [@mwouts' post on the topic here](https://github.com/CFMTech/jupytext_papermill_post/blob/master/README.md)).

## Testing the round-trip conversion

Representing Jupyter notebooks as scripts requires a solid round trip conversion. You don't want your notebooks (nor your scripts) to change because you are converting them to the other form. Our test suite includes a few hundred tests to ensure that round trip conversion is safe.

You can test yourself that the round trip conversion preserves your Jupyter notebooks and scripts. Run for instance:
```bash
# Test the ipynb -> py:percent -> ipynb round trip conversion
jupytext --test notebook.ipynb --to py:percent

# Test the ipynb -> (py:percent + ipynb) -> ipynb (à la paired notebook) conversion
jupytext --test --update notebook.ipynb --to py:percent
```

Note that `jupytext --test` compares the resulting notebooks according to its expectations. If you wish to proceed to a strict comparison of the two notebooks, use `jupytext --test-strict`, and use the flag `-x` to report with more details on the first difference, if any.

## Cell and notebook metadata

When a scripts is converted to an `.ipynb` notebook, Jupytext will set empty notebook and cell [metadata filters](advanced-options.md) to avoid having notebook or cell metadata added back to the script. Remove these filters if you want to store Jupytext's settings, or the kernel information, in the text file.

Cell metadata are available in the `light` and `percent` formats, as well as in the MyST Markdown, R Markdown and Jupytext Markdown formats. R scripts in `spin` format support cell metadata for code cells only. Sphinx Gallery scripts in `sphinx` format do not support cell metadata.

A few cell metadata are not included in the text representation of the notebook, and only the most standard notebook metadata are exported - see the section on [metadata filters](advanced-options.md).

# Frontend extension

Recent versions of Jupytext (`>=1.16.0`) ships frontend extension that enables users
to create text notebooks and pair notebooks from main menu of JupyterLab 4 and
Notebook 7. In addition, the frontend extension adds selected Jupytext text
notebook formats to launcher in the `Jupytext` section so that users can launch text
notebooks as they launch a regular notebook from JupyterLab launcher.

## Launcher icons

After installing Jupytext extension, users will have a new category in the launcher
called Jupytext as shown below:

![](../jupyterlab/packages/jupyterlab-jupytext-extension/ui-tests/tests/jupytext-launcher.spec.ts-snapshots/launcher-category-jupytext-linux.png)

Users can remove and/or add new formats to the Jupytext section _via_ `Settings>Jupytext`.

![](../jupyterlab/packages/jupyterlab-jupytext-extension/ui-tests/tests/jupytext-settings.spec.ts-snapshots/jupytext-settings-panel-jupytext-linux.png)

By (un)selecting different formats, users can filter the items in launcher and main menu. **Note** that users need to refresh the current browser tab when they modify the settings for them to take effect.

## Main menu

It is also possible to create new text notebooks and/or pair existing notebooks from main menu and dedicated Jupytext main menu, respectively.

Following screenshot shows the `New Text Notebook` submenu available in `File` menu.

![](../jupyterlab/packages/jupyterlab-jupytext-extension/ui-tests/tests/jupytext-menu.spec.ts-snapshots/opened-jupytext-menu-file-new-text-notebook-jupytext-linux.png)

Similarly, to pair existing notebooks, users can go to `Jupytext` menu on main menu as shown below:

![](../jupyterlab/packages/jupyterlab-jupytext-extension/ui-tests/tests/jupytext-menu.spec.ts-snapshots/opened-jupytext-menu-jupytext-pair-notebook-jupytext-linux.png)

All the options are greyed out in the above screenshot as there is no notebook widget currently active. Once the user opens a new notebook, the options will become available.

# Paired notebooks

Both classical Jupyter Notebooks in the `.ipynb` format, and [text notebooks](text-notebooks.md), have great qualities. The former is a well established standard, contains all the notebook outputs, while the latter is lighter, easier to edit, and well suited for version control.

_Paired notebooks_ give you the best of both worlds.

They work as follows:
- When a paired notebook is opened, the inputs are loaded from the most recent file in the pair, while the outputs are loaded from the `.ipynb` file, if it exists
- When a paired notebook is saved, all the files in the pair are updated (or recreated) with the new notebook content.

This means, in particular, that you can put under version control only the `.py` or `.md` representation of the notebook. When your collaborators
check-out the updates on the text notebook, open it, then save it in Jupyter, the corresponding `.ipynb` file will be updated or even re-created if necessary.

## How to pair a notebook

In JupyterLab, pair your notebook to one or more text formats with the [Jupytext commands](install.md#jupytext-commands-in-jupyterlab):

![](images/pair_commands.png)

These commands simply add a `"jupytext": {"formats": "ipynb,md"}` entry to the notebook metadata.

You can also configure the notebook pairing [globally](config.md) for all your notebooks.

## Can I edit a notebook simultaneously in Jupyter and in a text editor?

When saving a paired notebook, Jupyter updates both the `.ipynb` and its text representation. The text representation can be edited outside of Jupyter. When the notebook is refreshed in Jupyter, the input cells are read from the text file, and the output cells from the `.ipynb` file.

It is possible (and convenient) to leave the notebook open in Jupyter while you edit its text representation. However, you don't want the two editors to save the notebook simultaneously. To avoid this:
- deactivate Jupyter's autosave, and
- make sure you reload the notebook when you switch back from the editor to Jupyter.

In case you forgot to reload, and saved the Jupyter notebook while the text representation had changed, no worries: Jupyter will ask you which version you want to keep:

![](https://github.com/mwouts/jupytext-screenshots/raw/master/JupytextDocumentation/NotebookChanged.png)

If that happens, simply select the version that has the most recent changes (or: make a copy of the `.py` notebook on disk, click on _overwrite_ in Jupyter, and reconcile manually the two `.py` files).

# Notebooks as Markdown

## MyST Markdown

[MyST (Markedly Structured Text)][myst-parser] is a markdown flavor that "implements the best parts of reStructuredText". It provides a way to call Sphinx directives and roles from within Markdown,
using a *slight* extension of CommonMark markdown.
[MyST-NB][myst-nb] and [Jupyter Book][jupyter-book] builds on this markdown flavor, to offer direct conversion of Jupyter Notebooks into Sphinx documents.

Similar to the jupytext Markdown format, MyST Markdown uses code blocks to contain code cells.
The difference though, is that the metadata is contained in a YAML block:

````md
```{code-cell} ipython3
---
other:
  more: true
tags: [hide-output, show-input]
---

print("Hallo!")
```
````

The `ipython3` here is purely optional, as an aide for syntax highlighting.
In the round-trip, it is copied from `notebook.metadata.language_info.pygments_lexer`.

Also, where possible the conversion will use the short-hand metadata format
(see the [MyST guide](https://myst-parser.readthedocs.io/en/latest/using/syntax.html#parameterizing-directives)):

````md
```{code-cell} ipython3
:tags: [hide-output, show-input]

print("Hallo!")
```
````

Raw cells are also represented in a similar fashion:

````md
```{raw-cell}
:raw_mimetype: text/html

<b>Bold text<b>
```
````

Markdown cells are not wrapped. If a markdown cell has metadata, or
directly proceeds another markdown cell, then a [block break] will be inserted
above it, with an (optional) single line JSON representation of the metadata:

```md
+++ {"slide": true}

This is a markdown cell with metadata

+++

This is a new markdown cell with no metadata
```

See for instance how our `World population.ipynb` notebook is [represented](https://github.com/mwouts/jupytext/blob/main/demo/World%20population.myst.md#) in the `myst` format.

**Note**: The `myst` format requires Python >= 3.6

**Tip**: You can use the [myst-highlight] VS Code extension to provide better syntax highlighting for this format.

[myst-parser]: https://myst-parser.readthedocs.io
[myst-nb]: https://myst-nb.readthedocs.io
[jupyter-book]: https://jupyterbook.org
[block break]: https://myst-parser.readthedocs.io/en/latest/using/syntax.html#block-breaks
[myst-highlight]: https://marketplace.visualstudio.com/items?itemName=ExecutableBookProject.myst-highlight

## Quarto

[Quarto](https://quarto.org/) is a scientific and technical publishing system built on Pandoc. If you have `quarto` installed, Jupytext lets you edit `.qmd` documents as notebooks in Jupyter, and pair `.ipynb` notebooks with `.qmd` notebooks.

The conversion from `.ipynb` to `.qmd` and back directly calls `quarto convert`, and consequently requires an installation of Quarto v0.2.134 or higher.

Note that the round trip of `.ipynb` to `.qmd` to `.ipynb` has the effect of concatenating consecutive Markdown cells and turning raw cells into Markdown cells (since `.qmd` files represent all content as either Markdown or code cells).

## R Markdown

[R Markdown](https://rmarkdown.rstudio.com/authoring_quick_tour.html) is [RStudio](https://www.rstudio.com/)'s format for notebooks, with support for R, Python, and many [other languages](https://bookdown.org/yihui/rmarkdown/language-engines.html).

Jupytext's implementation of R Markdown is very similar to that of the Markdown format. The major difference is on code cells, which use R Markdown's convention, i.e. the language and options are surrounded by curly brackets, and the cell metadata are encoded as R objects. For instance our cell with the `parameters` tags would be represented as:

    ```{python tags=c("parameters")}
    param = 5
    ```

Python and R notebooks represented in the R Markdown format can run both in Jupyter and RStudio. Note that you can change the default Python environment in RStudio with `RETICULATE_PYTHON` in a `.Renviron` file, see [here](https://github.com/mwouts/jupytext/issues/267#issuecomment-506994930).

See how our `World population.ipynb` notebook in the [demo folder](https://github.com/mwouts/jupytext/tree/main/demo) is represented in [R Markdown](https://github.com/mwouts/jupytext/blob/main/demo/World%20population.Rmd).

## Jupytext Markdown

Jupytext can save notebooks as [Markdown](https://daringfireball.net/projects/markdown/syntax) documents. This format is well adapted to tutorials, books, or more generally notebooks that contain more text than code. Notebooks represented in this form are well rendered by most Markdown editors or renderers, including GitHub.

Like all the Jupytext formats, Jupytext Markdown notebooks start with an (optional) YAML header. This header is used to store selected notebook metadata like the kernel information, together with Jupytext's format and version information.
```
---
jupyter:
  jupytext:
    text_representation:
      extension: .md
      format_name: markdown
      format_version: '1.1'
      jupytext_version: 1.1.0
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---
```

You can add custom notebook metadata like `author` or `title` under the `jupyter:` section, it will be synchronized with the notebook metadata.
And if you wish to export more metadata from the notebook, have a look at the paragraph on [metadata filtering](advanced-options.md#metadata-filtering).

In the Markdown format, markdown cells are inserted verbatim and separated with two blank lines.

If you'd like that cell breaks also occurs on Markdown headers, add a `split_at_heading: true` entry in the `jupytext` section in the YAML header, or if you want that option to be the default for all Markdown documents in Jupyter, activate the option in the [`jupytext.toml` configuration file](config.md):

```
split_at_heading = true
```

Code cells are encoded using the classical triple backticks, followed by the notebook language. Cell metadata are appended after the language information, with a `key=value` syntax, where `value` is encoded in JSON format. For instance, in a Python notebook, a simple code cell with a `parameters` tag is represented as:

    ```python tags=["parameters"]
    param = 5
    ```

Code snippets are turned into code cells in Jupyter as soon as they have an explicit language, when that language is supported in Jupyter. Thus, you have a code snippet that you don't want to execute in Jupyter, you can either
- remove the language information,
- or, start the code snippet with a triple tilde, e.g. `~~~python`, instead of ` ```python`
- or, add an `active="md"` cell metadata, or a `.noeval` attribute after the language information, e.g. ` ```python .noeval `
- or, surround the code snippet with explicit Markdown cell markers (see below).

Raw cells are delimited with HTML comments, and accept cell metadata in the same key=value format:

    <!-- #raw -->
    raw text
    <!-- #endraw -->

    <!-- #raw key="value"-->
    raw cell with metadata
    <!-- #endraw -->

Markdown cells can also have explicit markers: use one of `<!-- #md -->` or `<!-- #markdown -->` or `<!-- #region -->` and the corresponding `<!-- #end... -->` counterpart. Note that the `<!-- #region -->` and `<!-- #endregion -->` cells markers are [foldable](https://code.visualstudio.com/docs/editor/codebasics#_folding) in VS Code, and that you can also insert a title there, e.g. `<!-- #region This is a title for my protected cell -->`. Cell metadata are accepted in the format `key="value"` (`"value"` being encoded in JSON) as for the other cell types.

For a concrete example, see how our `World population.ipynb` notebook in the [demo folder](https://github.com/mwouts/jupytext/tree/main/demo) is represented in [Markdown](https://github.com/mwouts/jupytext/blob/main/demo/World%20population.md#).

## Pandoc Markdown

Pandoc, the _Universal document converter_,  can read and write Jupyter notebooks - see [Pandoc's documentation](https://pandoc.org/MANUAL.html#creating-jupyter-notebooks-with-pandoc).

In Pandoc Markdown, all cells are marked with pandoc divs (`:::`). The format is therefore slightly more verbose than the Jupytext Markdown format.

See for instance how our `World population.ipynb` notebook is [represented](https://github.com/mwouts/jupytext/blob/main/demo/World%20population.pandoc.md#) in the `md:pandoc` format.

If you wish to use that format, please install `pandoc` in version 2.7.2 or above, with e.g. `conda install pandoc -c conda-forge`.

# VS Code

## The Jupytext Sync Extension

You can get the same pairing and synchronization functionality in VS Code as in Jupyter, thanks to the [Jupytext Sync](https://marketplace.visualstudio.com/items?itemName=caenrigen.jupytext-sync) extension for VS Code. The extension is developed by Victor Negîrneac on [GitHub](https://github.com/caenrigen/vscode-jupytext-sync) under a MIT license.

### Installation

Install the extension from the [VS Code Marketplace](https://marketplace.visualstudio.com/items?itemName=caenrigen.jupytext-sync) or search for "Jupytext Sync" in the VS Code Extensions view.

### Usage

With the Jupytext Sync extension active, open both the `.ipynb` and `.py` paired files in your editor. When you save changes to either file, they are automatically propagated to the other paired file(s).

💡 **Tip:** Save your changes before switching editors. If a file has unsaved edits, VS Code will not auto-reload it when the paired file is saved, until you either save (overwrite) or revert your changes.

![](images/paired_notebook_in_vs_code.png)

### Configuration

The Jupytext Sync extension is aware of your `jupytext.toml` or `pyproject.toml` [configuration files](config.md), so you can use those to pair your notebooks or control which metadata you want in the text notebooks.

The extension also gives you the option to pair the notebooks individually. Read more about these features in the extension's [documentation](https://marketplace.visualstudio.com/items?itemName=caenrigen.jupytext-sync).

### Requirements

The Jupytext Sync extension requires Jupytext 1.17.3 or later to properly identify which files are paired. Additionally, the `jupytext --sync` command gained the ability to detect simultaneous modifications in Jupytext 1.18.0, so we recommend updating to the latest version if possible.

# Blog posts and talks

Over the course of the years I wrote a few different blog posts about Jupytext, about text notebooks, their integration with the most popular IDEs, etc. They might help you get started with Jupytext:

- Read the original [announcement](https://towardsdatascience.com/introducing-jupytext-9234fdff6c57) in _Towards Data Science_ (Sept. 2018),
- Watch the [PyParis talk](https://github.com/mwouts/jupytext_pyparis_2018/blob/master/README.md) (Nov. 2018),
- Read our article on [Jupytext and Papermill](https://medium.com/capital-fund-management/automated-reports-with-jupyter-notebooks-using-jupytext-and-papermill-619e60c37330) in _CFM Insights_ (Sept. 2019)
- See how you can edit [Jupyter Notebooks in VS Code or PyCharm](https://towardsdatascience.com/jupyter-notebooks-in-the-ide-visual-studio-code-versus-pycharm-5e72218eb3e8) with (or without!) Jupytext (Jan. 2020)
- Watch the [JupyterCon 2020 talk](https://github.com/mwouts/jupytext_jupytercon2020/blob/master/README.md) on Jupytext (Oct. 2020),
- or, try Jupytext online with [binder](https://mybinder.org/v2/gh/mwouts/jupytext/main?urlpath=lab/tree/demo/get_started.ipynb)!

# Supported Languages

Jupytext works with notebooks in any of the following languages:

- Bash
- C#
- C++
- Clojure
- Coconut
- F#
- Gnuplot
- Go
- Groovy
- Haskell
- IDL
- Java
- Javascript
- Julia
- Logtalk
- Lua
- Matlab
- OCaml
- Octave
- PowerShell
- Python
- q/kdb+
- R
- Robot Framework
- Rust/Evxcr
- Sage
- SAS
- Scala
- Scheme
- Script of Script
- Stata
- Tcl
- TypeScript
- Wolfram Language
  - Note that Jupytext uses the non-standard `.wolfram` file extension for Wolfram Language files to avoid conflicts with Matlab.
- Xonsh

Extending Jupytext to more languages should be easy, see the sections on [contributing to](contributing.md) and [developing](developing.md) Jupytext.

---
jupyter:
  kernelspec:
    display_name: Apache Toree - Scala
    language: scala
    name: apache_toree_scala
---

```{scala}
// This is just a simple scala notebook

object SampleObject {
    def calculation(x: Int, y: Int): Int = x + y
}

val result = SampleObject.calculation(1, 2)
```

```{scala}
println(result * 10)
```

---
jupyter:
  kernelspec:
    display_name: Logtalk
    language: logtalk
    name: logtalk_kernel
---

# An implementation of the Ackermann function

```logtalk vscode={"languageId": "logtalk"}
%%load ack.lgt

:- object(ack).

:- info([
	version is 1:0:0,
	author is 'Paulo Moura',
	date is 2008-3-31,
	comment is 'Ackermann function (general recursive function).'
]).

:- public(ack/3).
:- mode(ack(+integer, +integer, -integer), one).
:- info(ack/3, [
	comment is 'Ackermann function.',
	argnames is ['M', 'N', 'V']
]).

ack(0, N, V) :-
	!,
	V is N + 1.
ack(M, 0, V) :-
	!,
	M2 is M - 1,
	ack(M2, 1, V).
ack(M, N, V) :-
	M2 is M - 1,
	N2 is N - 1,
	ack(M, N2, V2),
	ack(M2, V2, V).

:- end_object.
```

## Sample query

```logtalk vscode={"languageId": "logtalk"}
ack::ack(2, 4, V).
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```{python}
1 + 1
```

A markdown cell
And below, the cell for function f has non trivial cell metadata. And the next cell as well.

```{python attributes={'classes': [], 'id': '', 'n': '10'}}
def f(x):
    return x
```

```{python attributes={'classes': [], 'id': '', 'n': '10'}}
f(5)
```

More text

```{python}
2 + 2
```

---
jupyter:
  jupytext:
    formats: ipynb,md
    text_representation:
      extension: .md
      format_name: markdown
      format_version: '1.1'
      jupytext_version: 1.1.6
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

# Getting started with Jupytext

This small notebook shows you how to activate Jupytext in the JupyterLab
environment. We'll show you a few things that you can do with Jupytext and
a bit of what happens under the hood.

**Note: to run this notebook locally, you need to first follow the Jupytext
installation instructions and activate the JupyterLab plugin. If you're on
Binder, it should already work.**


## Enabling Jupytext in a new notebook

This notebook is brand new - it hasn't had any special extra metadata added
to it.

If we want Jupytext to save files in multiple formats automatically,
we can use the JupyterLab **command palette** to do so.

* In the _View_ menu, click on _Activate Command Palette_
* Then type **`Jupytext`**. You should see a number of commands come up. Each
  one tells Jupytext to save the notebook in a different
  file format automatically.
* Select **Pair notebook with MyST Markdown**

That's it! If you have Jupytext installed, it will now save your notebook in
markdown format automatically when you save this `.ipynb` file
**in addition to** saving the `.ipynb` file itself.

After you've done this, save the notebook. You should now see a new file called
**`get_started.md`** in the same directory as this notebook.


## How does Jupytext know to do this?

Jupytext uses notebook-level metadata to keep track of what formats are paired
with a notebook. Below we'll print the metadata of this notebook so you can see
what the Jupytext metadata looks like.

```python
import nbformat as nbf
from IPython.display import JSON
notebook = nbf.read('./get_started.ipynb', nbf.NO_CONVERT)
JSON(notebook['metadata'])
```

As you select different formats from the command palette (following the instructions
above) and save the notebook, you'll see this metadata change.


## That's it!

Play around with different kinds of code and outputs to see how each is
converted into its corresponding text format. Here's a little Python code
to get you started:

```python
import numpy as np
import matplotlib.pyplot as plt

plt.scatter(*np.random.randn(2, 100), c=np.random.randn(100), s=np.random.rand(100)*100)
```

# Experiment with the demo notebook!

In the *`demo/`* folder for `jupytext` there is a notebook called **`World population.ipynb`**.
By default, saving the demo notebook will also create *many* possible Jupytext
outputs so you can see what each looks like and which you prefer.

---
title: A sample document
---

This document is a plain Markdown document that was not created from a notebook.
We use this document to test that inputing a Markdown file into Jupytext, and then converting the
resulting notebook to a Markdown file using nbconvert, is the identity

Another paragraph

# A header

Indented code

    def f(x):
        return 1


    def h(x):
        return f(x)+2


A Python code snippet

```python
"""This code cell starts with ` ```python`"""
1 + 1
```

Code snippet without an explicit language
```
echo 'Hello world'
```

Markdown comments
<!-- #comment -->

VS Code region markers

<!-- #region -->
This Markdown cell has two consecutive blank lines


And continues here
<!-- #endregion -->

---
jupyter:
  kernel_info:
    name: python3
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```python inputHidden=false outputHidden=false tags=["parameters"]
param = 4
```

```python inputHidden=false outputHidden=false
import pandas as pd
```

```python inputHidden=false outputHidden=false
df = pd.DataFrame({'A': [1, 2], 'B': [3 + param, 4]},
                  index=pd.Index(['x0', 'x1'], name='x'))
df
```

```python inputHidden=false outputHidden=false
%matplotlib inline
df.plot(kind='bar')
```

---
jupytext:
  formats: ipynb:markdown,md:myst
kernelspec:
  display_name: OCaml default
  language: OCaml
  name: ocaml-jupyter
---

# Example of an OCaml notebook

```{code-cell} OCaml
let sum x y = x + y
```

Let's try our function:

```{code-cell} OCaml
sum 3 4 = 7 + 0
```

---
jupyter:
  kernelspec:
    display_name: Robot Framework
    language: robotframework
    name: robotkernel
---

```robotframework
*** Settings ***

Library  Collections
```

```robotframework
*** Keywords ***

Head
    [Arguments]  ${list}
    ${value}=  Get from list  ${list}  0
    [Return]  ${value}
```

```robotframework
*** Tasks ***

Get head
    ${array}=  Create list  1  2  3  4  5
    ${head}=  Head  ${array}
    Should be equal  ${head}  1
```

---
kernelspec:
  display_name: Stata
  language: stata
  name: stata
---

```{code-cell}
// This notebook uses the stata_kernel: https://github.com/kylebarron/stata_kernel
```

```{code-cell}
use http://www.stata-press.com/data/r13/auto
```

```{code-cell}
summarize
```

```{code-cell}
scatter weight length
```

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

# A quick insight at world population

## Collecting population data

In the below we retrieve population data from the
[World Bank](http://www.worldbank.org/)
using the [wbdata](https://github.com/OliverSherouse/wbdata) python package

```{code-cell} ipython3
import pandas as pd
import wbdata as wb

pd.options.display.max_rows = 6
pd.options.display.max_columns = 20
```

Corresponding indicator is found using search method - or, directly,
the World Bank site.

```{code-cell} ipython3
wb.search_indicators('Population, total')  # SP.POP.TOTL
# wb.search_indicators('area')
# => https://data.worldbank.org/indicator is easier to use
```

Now we download the population data

```{code-cell} ipython3
indicators = {'SP.POP.TOTL': 'Population, total',
              'AG.SRF.TOTL.K2': 'Surface area (sq. km)',
              'AG.LND.TOTL.K2': 'Land area (sq. km)',
              'AG.LND.ARBL.ZS': 'Arable land (% of land area)'}
data = wb.get_dataframe(indicators, convert_date=True).sort_index()
data
```

World is one of the countries

```{code-cell} ipython3
data.loc['World']
```

Can we classify over continents?

```{code-cell} ipython3
data.loc[(slice(None), '2017-01-01'), :]['Population, total'].dropna(
).sort_values().tail(60).index.get_level_values('country')
```

Extract zones manually (in order of increasing population)

```{code-cell} ipython3
zones = ['North America', 'Middle East & North Africa',
         'Latin America & Caribbean', 'Europe & Central Asia',
         'Sub-Saharan Africa', 'South Asia',
         'East Asia & Pacific'][::-1]
```

And extract population information (and check total is right)

```{code-cell} ipython3
population = data.loc[zones]['Population, total'].swaplevel().unstack()
population = population[zones]
assert all(data.loc['World']['Population, total'] == population.sum(axis=1))
```

## Stacked area plot with matplotlib

```{code-cell} ipython3
import matplotlib.pyplot as plt
```

```{code-cell} ipython3
plt.clf()
plt.figure(figsize=(10, 5), dpi=100)
plt.stackplot(population.index, population.values.T / 1e9)
plt.legend(population.columns, loc='upper left')
plt.ylabel('Population count (B)')
plt.show()
```

## Stacked bar plot with plotly

+++

Stacked area plots (with cumulated values computed depending on
selected legends) are
[on their way](https://github.com/plotly/plotly.js/pull/2960) at Plotly. For
now we just do a stacked bar plot.

```{code-cell} ipython3
import plotly.offline as offline
import plotly.graph_objs as go

offline.init_notebook_mode()
```

```{code-cell} ipython3
bars = [go.Bar(x=population.index, y=population[zone], name=zone)
        for zone in zones]
fig = go.Figure(data=bars,
                layout=go.Layout(title='World population',
                                 barmode='stack'))
offline.iplot(fig)
```

---
jupytext:
  formats: ipynb,md:myst
  text_representation:
    extension: .md
    format_name: myst
    format_version: 0.13
    jupytext_version: 1.11.5
kernelspec:
  display_name: Python 3 (ipykernel)
  language: python
  name: python3
---
Et voilą!

---
jupyter:
  kernelspec:
    display_name: Python 2
    language: python
    name: python2
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .markdown}
# A notebook with R cells

This notebook shows the use of R cells to generate plots
:::

::: {.cell .code}
``` {.python}
%load_ext rpy2.ipython
```
:::

::: {.cell .code}
``` {.python}
%%R
suppressMessages(require(tidyverse))
```
:::

::: {.cell .code}
``` {.python}
%%R
ggplot(iris, aes(x = Sepal.Length, y = Petal.Length, color=Species)) + geom_point()
```
:::

::: {.cell .markdown}
The default plot dimensions are not good for us, so we use the -w and -h parameters in %%R magic to set the plot size
:::

::: {.cell .code}
``` {.python}
%%R -w 400 -h 240
ggplot(iris, aes(x = Sepal.Length, y = Petal.Length, color=Species)) + geom_point()
```
:::

---
kernelspec:
  display_name: Typescript 3.5
  language: typescript
  name: typescript
---

```{code-cell}
let x: number = 5;
const y: number = 6;
var z: string = "hi";
console.log(z);
x + y;
```

```{code-cell}
function add(num1: number, num2: number): number {
    return num1 + num2
}
add(x, y);
```

```{code-cell}
const arrowAdd = (num1: number, num2: number) => num1 + num2;
arrowAdd(x, y);
```

```{code-cell}
class User {
  constructor(private name: string) {
    this.name = name;
  }
  sayHello(): string {
    return "Hello, I'm " + this.name;
  }
}
let John: User;
John = new User("John");
John.sayHello();
```

---
jupyter:
  kernelspec:
    display_name: Q 3.5
    language: q
    name: qpk
---

```{q}
plt: .p.import`matplotlib.pyplot
```

```{q}
filter: {
    t: ([] x: `float $ x; xh: `float $ x; p: (count x) # R: var x);
    (first t), iterate[R; R]\[first t; 1 _ t] 
    }

iterate: {[Q; R; x; y]
    x[`p]+: Q;
    k: x[`p] % R + x[`p];
    `x`xh`p ! (y[`x]; x[`xh] + k * y[`x] - x[`xh]; (1 - k) * x[`p])
    }
```

```{q}
price: 100 + sums 0.5 - (n:50)?1.
```

```{q}
output:filter price
```

```{q}
plt[`:plot][til n; output`x; `label pykw "price"];
plt[`:plot][til n; output`xh;`label pykw "forecast"];
plt[`:legend][];
plt[`:show][];
```

```{q}

```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .markdown}
# Jupyter notebook

This notebook is a simple jupyter notebook. It only has markdown and code cells. And it does not contain consecutive markdown cells. We start with an addition:
:::

::: {#cell-1 .cell .code}
``` python
a = 1
b = 2
a + b
```
:::

::: {.cell .markdown}
Now we return a few tuples
:::

::: {#cell-2 .cell .code}
``` python
a, b
```
:::

::: {#cell-3 .cell .code}
``` python
a, b, a+b
```
:::

::: {.cell .markdown}
And this is already the end of the notebook
:::

---
jupyter:
  kernelspec:
    display_name: R
    language: R
    name: ir
---

This notebook was created with IRKernel 0.8.12, and is not completely valid, as the code cell below contains an unexpected 'source' entry. This did cause https://github.com/mwouts/jupytext/issues/234. Note that the problem is solved when one upgrades to IRKernel 1.0.0.

```R
library("ggplot2")
ggplot(mtcars, aes(mpg)) + stat_ecdf()
```

---
jupyter:
  kernelspec:
    display_name: Rust
    language: rust
    name: rust
---

# Tour of the EvCxR Jupyter Kernel
For those not already familiar with Jupyter notebook, it lets you write code into "cells" like the box below. Cells can alternatively contain markdown, like this text here. Each code cell is compiled and executed separately, but variables, defined functions etc persist between cells.

## Printing to outputs and evaluating expressions
Lets print something to stdout and stderr then return a final expression to see how that's presented. Note that stdout and stderr are separate streams, so may not appear in the same order is their respective print statements.

```{rust}
println!("Hello world");
eprintln!("Hello error");
format!("Hello {}", "world")
```

## Assigning and making use of variables
We define a variable `message`, then in the subsequent cell, modify the string and finally print it out. We could also do all this in the one cell if we wanted.

```{rust}
let mut message = "Hello ".to_owned();
```

```{rust}
message.push_str("world!");
```

```{rust}
message
```

## Defining and redefining functions
Next we'll define a function

```{rust}
pub fn fib(x: i32) -> i32 {
    if x <= 2 {0} else {fib(x - 2) + fib(x - 1)}
}
```

```{rust}
(1..13).map(fib).collect::<Vec<i32>>()
```

Hmm, that doesn't look right. Lets redefine the function. In practice, we'd go back and edit the function above and reevalute it, but here, lets redefine it in a separate cell.

```{rust}
pub fn fib(x: i32) -> i32 {
    if x <= 2 {2} else {fib(x - 2) + fib(x - 1)}
}
```

```{rust}
let values = (1..13).map(fib).collect::<Vec<i32>>();
values
```

## Spawning a separate thread and communicating with it
We can spawn a thread to do stuff in the background, then continue executing code in other cells.

```{rust}
use std::sync::{Mutex, Arc};
let counter = Arc::new(Mutex::new(0i32));
std::thread::spawn({
    let counter = Arc::clone(&counter);
    move || {
        for i in 1..300 {
            *counter.lock().unwrap() += 1;
            std::thread::sleep(std::time::Duration::from_millis(100));
        }
}});
```

```{rust}
*counter.lock().unwrap()
```

```{rust}
*counter.lock().unwrap()
```

## Loading external crates
We can load external crates. This one takes a while to compile, but once it's compiled, subsequent cells shouldn't need to recompile it, so it should be much quicker.

```{rust}
// :dep base64 = "0.10.1"
base64::encode(&vec![1, 2, 3, 4])
```

## Customizing how types are displayed
We can also customize how our types are displayed, including presenting them as HTML. Here's an example where we define a custom display function for a type `Matrix`.

```{rust}
use std::fmt::Debug;
pub struct Matrix<T> {pub values: Vec<T>, pub row_size: usize}
impl<T: Debug> Matrix<T> {
    pub fn evcxr_display(&self) {
        let mut html = String::new();
        html.push_str("<table>");
        for r in 0..(self.values.len() / self.row_size) {
            html.push_str("<tr>");
            for c in 0..self.row_size {
                html.push_str("<td>");
                html.push_str(&format!("{:?}", self.values[r * self.row_size + c]));
                html.push_str("</td>");
            }
            html.push_str("</tr>");            
        }
        html.push_str("</table>");
        println!("EVCXR_BEGIN_CONTENT text/html\n{}\nEVCXR_END_CONTENT", html);
    }
}
```

```{rust}
let m = Matrix {values: vec![1,2,3,4,5,6,7,8,9], row_size: 3};
m
```

We can also return images, we just need to base64 encode them. First, we set up code for displaying RGB and grayscale images.

```{rust}
extern crate image;
extern crate base64;
pub trait EvcxrResult {fn evcxr_display(&self);}
impl EvcxrResult for image::RgbImage {
    fn evcxr_display(&self) {
        let mut buffer = Vec::new();
        image::png::PNGEncoder::new(&mut buffer).encode(&**self, self.width(), self.height(),
            image::ColorType::RGB(8)).unwrap();
        let img = base64::encode(&buffer);
        println!("EVCXR_BEGIN_CONTENT image/png\n{}\nEVCXR_END_CONTENT", img);        
    }
}
impl EvcxrResult for image::GrayImage {
    fn evcxr_display(&self) {
        let mut buffer = Vec::new();
        image::png::PNGEncoder::new(&mut buffer).encode(&**self, self.width(), self.height(),
            image::ColorType::Gray(8)).unwrap();
        let img = base64::encode(&buffer);
        println!("EVCXR_BEGIN_CONTENT image/png\n{}\nEVCXR_END_CONTENT", img);        
    }
}
```

```{rust}
image::ImageBuffer::from_fn(256, 256, |x, y| {
    if (x as i32 - y as i32).abs() < 3 {
        image::Rgb([0, 0, 255])
    } else {
        image::Rgb([0, 0, 0])
    }
})
```

## Display of compilation errors
Here's how compilation errors are presented. Here we forgot an & and passed a String instead of an &str.

```{rust}
let mut s = String::new();
s.push_str(format!("foo {}", 42));
```

## Seeing what variables have been defined
We can print a table of defined variables and their types with the :vars command.

```{rust}
// :vars
```

Other built-in commands can be found via :help

```{rust}
// :help
```

```{rust}

```

---
jupyter:
  kernelspec:
    display_name: SAS
    language: sas
    name: sas
---

# SAS Notebooks with jupytext

```{sas}
proc sql;
    select *
    from sashelp.cars (obs=10)
    ;
quit; 
```

```{sas}
%let name = "Jupytext";
```

```{sas}
%put &name;
```

```{sas}
/* Note when defining macros "%macro" cannot be the first line of text in the cell */
%macro test;
    data temp;
        set sashelp.cars;
        name = "testx";
    run; 
    proc print data = temp (obs=10);
    run; 
%mend test;

%test
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .markdown slideshow="{\"slide_type\":\"slide\"}"}
A markdown cell
:::

::: {.cell .code slideshow="{\"slide_type\":\"\"}"}
``` {.python}
1+1
```
:::

::: {.cell .markdown cell_style="center" slideshow="{\"slide_type\":\"fragment\"}"}
Markdown cell two
:::

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

# Markdown, code and raw cells

## Markdown cells

This is a Markdown cell. Markdown cells end with either a code cell, or two consecutive blank lines in the text.

If you prefer that Markdown headings define new cells, have a look at the `split_at_heading` option.

Indented code is accepted, and consecutive blank lines there do not break Markdown cells:

    def f(x):
        return 1


    def h(x):
        return f(x)+2


## Code cells

```python
"""This code cell starts with ` ```python`"""
1 + 1
```

## Raw cells

Raw cells are delimited with `<!-- #raw -->` and <!-- #endraw -->, like here:
<!-- #raw -->
this is a raw cell
<!-- #endraw -->

# Protected Markdown cells

If you want to include code blocks (or two consecutive blank lines) in a Markdown cell, use explicit Markdown cell delimiters `<!-- #region -->` and `<!-- #endregion -->`.

<!-- #region -->
This Markdown cell has two consecutive blank lines


And then a code block which is not a Jupyter code cell:
```python
2 + 2
```
<!-- #endregion -->

# Metadata

Metadata are supported for all cell types.

## Markdown cells

<!-- #region Region title key="value" -->
A cell with a title and additional metadata.
<!-- #endregion -->

## Code cells

```python tags=["parameters"]
a = 2
```

---
kernelspec:
  display_name: Bash
  language: bash
  name: bash
---

```{code-cell}
ls
```

```{code-cell}
# https://coderwall.com/p/euwpig/a-better-git-log
git config --global alias.lg "log --color --graph --pretty=format:'%Cred%h%Creset -%C(yellow)%d%Creset %s %Cgreen(%cr) %C(bold blue)<%an>%Creset' --abbrev-commit"
```

```{code-cell}
git lg
```

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{code-cell} ipython3
# This is an unfrozen cell. Works as usual.
print("I'm a regular cell so I run and print!")
```

```{code-cell} ipython3
---
deletable: false
editable: false
run_control:
  frozen: true
---
# This is an frozen cell
print("I'm frozen so Im not executed :(")
```

---
jupyter:
  jupytext:
    formats: ipynb:markdown,md
  kernelspec:
    display_name: OCaml default
    language: OCaml
    name: ocaml-jupyter
---

# Example of an OCaml notebook

```{ocaml}
let sum x y = x + y
```

Let's try our function:

```{ocaml}
sum 3 4 = 7 + 0
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```python
1 + 1
```

A markdown cell
And below, the cell for function f has non trivial cell metadata. And the next cell as well.

```python attributes={"classes": [], "id": "", "n": "10"}
def f(x):
    return x
```

```python attributes={"classes": [], "id": "", "n": "10"}
f(5)
```

More text

```python
2 + 2
```

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{code-cell} ipython3
%%html
<p><a href="https://github.com/mwouts/jupytext", style="color: rgb(0,0,255)">Jupytext</a> on GitHub</p>
```

```{code-cell} ipython3
%%latex
$\frac{\pi}{2}$
```

```{code-cell} ipython3
%load_ext rpy2.ipython
```

```{code-cell} ipython3
%%R
library(ggplot2)
ggplot(data=data.frame(x=c('A', 'B'), y=c(5, 2)), aes(x,weight=y)) + geom_bar()
```

```{code-cell} ipython3
%matplotlib inline
import pandas as pd
pd.Series({'A':5, 'B':2}).plot(figsize=(3,2), kind='bar')
```

---
jupyter:
  kernelspec:
    display_name: Javascript (Node.js)
    language: javascript
    name: javascript
---

## A notebook that uses IJavascript kernel

```{javascript}
let x = 5;
const y = 6;
var z = 10;
```

```{javascript}
x + y;
```

```{javascript}
function add(num1, num2) {
    return num1 + num2
}
```

```{javascript}
add(x, y);
```

```{javascript}
const arrowAdd = (num1, num2) => num1 + num2;
```

```{javascript}
arrowAdd(x, y);
```

```{javascript}
const myCar = {
    color: "blue",
    weight: 850,
    model: "fiat",
    start: () => "car started!",
    doors: [1,2,3,4]
}
```

```{javascript}
console.log("color:", myCar.color);
```

```{javascript}
console.log("start:", myCar.start());
```

```{javascript}
for (let door of myCar.doors) {
    console.log("I'm door", door)
}
```

```{javascript}
myCar;
```

```{javascript}
class User {
  constructor(name){
    this.name = name;
  }
  sayHello(){
    return "Hello, I'm " + this.name;
  }
}
```

```{javascript}
let John = new User("John");
John.sayHello();
```

---
jupyter:
  kernelspec:
    display_name: R
    language: R
    name: ir
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .markdown}
This is a jupyter notebook that uses the IR kernel.
:::

::: {.cell .code}
``` {.R}
sum(1:10)
```
:::

::: {.cell .code}
``` {.R}
plot(cars)
```
:::

::: {.cell .code}
``` {.R}
```
:::

---
jupyter:
  kernelspec:
    display_name: Lua
    language: lua
    name: lua
---

Source: https://www.lua.org/pil/19.3.html


# Sort


Another useful function on arrays is table.sort, which we have seen before. It receives the array to be sorted, plus an optional order function. This order function receives two arguments and must return true if the first argument should come first in the sorted array. If this function is not provided, sort uses the default less-than operation (corresponding to the `<´ operator).


A common mistake is to try to order the indices of a table. In a table, the indices form a set, and have no order whatsoever. If you want to order them, you have to copy them to an array and then sort the array. Let us see an example. Suppose that you read a source file and build a table that gives, for each function name, the line where that function is defined; something like this:

```{lua}
lines = {
    luaH_set = 10,
    luaH_get = 24,
    luaH_present = 48,
}
```

 Now you want to print these function names in alphabetical order. If you traverse this table with pairs, the names appear in an arbitrary order. However, you cannot sort them directly, because these names are keys of the table. However, when you put these names into an array, then you can sort them. First, you must create an array with those names, then sort it, and finally print the result:

```{lua}
a = {}
for n in pairs(lines) do table.insert(a, n) end
table.sort(a)
for i,n in ipairs(a) do print(n) end
```

Note that, for Lua, arrays also have no order. But we know how to count, so we get ordered values as long as we access the array with ordered indices. That is why you should always traverse arrays with ipairs, rather than pairs. The first imposes the key order 1, 2, ..., whereas the latter uses the natural arbitrary order of the table.


As a more advanced solution, we can write an iterator that traverses a table following the order of its keys. An optional parameter f allows the specification of an alternative order. It first sorts the keys into an array, and then iterates on the array. At each step, it returns the key and value from the original table:

```{lua}
function pairsByKeys (t, f)
    local a = {}
    for n in pairs(t) do table.insert(a, n) end
    table.sort(a, f)
    local i = 0               -- iterator variable
    local iter = function ()  -- iterator function
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[a[i]]
        end
    end
    return iter
end
```

 With this function, it is easy to print those function names in alphabetical order. The loop

```{lua}
for name, line in pairsByKeys(lines) do
    print(name, line)
end
```

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

+++ {"slideshow": {"slide_type": "slide"}}

A markdown cell

```{code-cell} ipython3
---
slideshow:
  slide_type: ''
---
1+1
```

+++ {"cell_style": "center", "slideshow": {"slide_type": "fragment"}}

Markdown cell two

---

This is a complex paragraph
that is split over multiple lines.

It also includes blank lines.


jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```{python}
print("Hello, World!")
```

# Fenced code

## No language

```
# a generic code instruction
1 + 1
```

## Python

```python
1 + 1
```

## Bash

```python
echo Hi
```

# Code cells

```{code-cell} ipython3
# This code gets executed in notebooks
1 + 1
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 5
---

::: {#b32297a4 .cell .raw}
```{=ipynb}
---

This is a complex paragraph
that is split over multiple lines.

It also includes blank lines.


---
```
:::

::: {#0b3bde0a .cell .code}
``` python
print("Hello, World!")
```
:::

---
jupyter:
  kernelspec:
    display_name: Calysto Scheme (Python)
    language: scheme
    name: calysto_scheme
---

<img src="images/logo-64x64.png"/>
<h1>Reference Guide for Calysto Scheme</h1>

[Calysto Scheme](https://github.com/Calysto/calysto_scheme) is a real Scheme programming language, with full support for continuations, including call/cc. It can also use all Python libraries. Also has some extensions that make it more useful (stepper-debugger, choose/fail, stack traces), or make it better integrated with Python.

In Jupyter notebooks, because Calysto Scheme uses [MetaKernel](https://github.com/Calysto/metakernel/blob/master/README.rst), it has a fully-supported set of "magics"---meta-commands for additional functionality. This includes running Scheme in parallel. See all of the [MetaKernel Magics](https://github.com/Calysto/metakernel/blob/master/metakernel/magics/README.md).

Calysto Scheme is written in Scheme, and then translated into Python (and other backends). The entire functionality lies in a single Python file: https://github.com/Calysto/calysto_scheme/blob/master/calysto_scheme/scheme.py However, you can easily install it (see below).

Please see [Calysto Scheme Language](Calysto%20Scheme%20Language.ipynb) for more details on the Calysto Scheme language.

## Installation

You can install Calysto Scheme with Python3:

```
pip3 install --upgrade calysto-scheme --user -U
python3 -m calysto_kernel install --user
```

or in the system kernel folder with:

```
sudo pip3 install --upgrade calysto-scheme -U
sudo python3 -m calysto_kernel install
```

Change pip3/python3 to use a different pip or Python. The version of Python used will determine how Calysto Scheme is run.

Use it in the console, qtconsole, or notebook with IPython 3:

```
ipython console --kernel calysto_scheme
ipython qtconsole --kernel calysto_scheme
ipython notebook --kernel calysto_scheme
```

In addition to all of the following items, Calysto Scheme also has access to all of Python's builtin functions, and all of Python's libraries. For example, you can use `(complex 3 2)` to create a complex number by calling Python's complex function.

## Jupyter Enhancements

When you run Calysto Scheme in Jupyter (console, notebook, qtconsole, etc.) you get:

* TAB completions of Scheme functions and variable names
* display of rich media
* stepper/debugger
* magics (% macros)
* shell commands (! command)
* LaTeX equations
* LaTeX-style variables
* Python integration


### LaTeX-style variables

Calysto Scheme allows you to use LaTeX-style variables in code. For example, if you type:

```
\beta
```

with the cursor right after the 'a' in beta, and then press TAB, it will turn into the unicode character:

```
β
```

There are nearly 1300 different symbols defined (thanks to the Julia language) and documented here:

http://docs.julialang.org/en/release-0.4/manual/unicode-input/#man-unicode-input

Calysto Scheme may not implement all of those. Some useful and suggestive ones:

* \pi - π
* \Pi - Π
* \Sigma - Σ
* \_i - subscript i, such as vectorᵢ

```{scheme}
(define α 67)
```

```{scheme}
α
```

```{scheme}
(define i 2)
(define vectorᵢ (vector-ref (vector 0 6 3 2) i))
vectorᵢ
```

### Rich media

```{scheme}
(import "calysto.display")
```

```{scheme}
(calysto.display.HTML "This is <b>bold</b>, <i>italics</i>, <u>underlined</u>.")
```

```{scheme}
(import "calysto.graphics")
```

```{scheme}
(define canvas (calysto.graphics.Canvas))
```

```{scheme}
(define ball (calysto.graphics.Circle '(150 150) 100))
```

```{scheme}
(ball.draw canvas)
```

### Shell commands

```{scheme}
! ls /tmp
```

### Stepper/Debugger

Here is what the debugger looks like:

<img src="images/stepper_debugger.png">

It has breakpoints (click in left margin). You must press Stop to exit the debugger.


```scheme
%%debug

(begin
 (define x 1)
 (set! x 2)
)
```


### Python Integration

You can import and use any Python library in Calysto Scheme.

In addition, if you wish, you can execute expressions and statements in a Python environment:

```{scheme}
(python-eval "1 + 2")
```

```{scheme}
(python-exec 
"
def mypyfunc(a, b):
    return a * b
")
```

This is a shared environment with Scheme:

```{scheme}
(mypyfunc 4 5)
```

You can use `func` to turn a Scheme procedure into a Python function, and `define!` to put it into the shared environment with Python:

```{scheme}
(define! mypyfunc2 (func (lambda (n) n)))
```

```{scheme}
(python-eval "mypyfunc2(34)")
```

# Differences Between Languages

## Major differences between Scheme and Python

1. In Scheme, double quotes are used for strings and may contain newlines
1. In Scheme, a single quote is short for (quote ...) and means "literal"
1. In Scheme, everything is an expression and has a return value
1. Python does not support macros (e.g., extending syntax)
1. In Python, "if X" is false if X is None, False, [], (,) or 0. In Scheme, "if X" is only false if X is #f or 0
1. Calysto Scheme uses continuations, not the call stack. However, for debugging there is a pseudo-stack when an error is raised. You can turn that off with (use-stack-trace #f)
1. Scheme procedures are not Python functions, but there are means to use one as the other.

## Major Differences Between Calysto Scheme and other Schemes

1. define-syntax works slightly differently
1. In Calysto Scheme, #(...) is short for '#(...)
1. Calysto Scheme is missing many standard functions (see list at bottom)
1. Calysto Scheme has a built-in amb operator called `choose`
1. For debugging there is a pseudo-stack when errors are raised in Calysto Scheme. You can turn that off with (use-stack-trace #f)

### Stack Trace

Calysto Scheme acts as if it has a call stack, for easier debugging. For example:

```{scheme}
(define fact
    (lambda (n)
      (if (= n 1)
           q
           (* n (fact (- n 1))))))
```

```{scheme}
(fact 5)
```

To turn off the stack trace on error:

```scheme
(use-stack-trace #f)
```
That will allow infinite recursive loops without keeping track of the "stack".


# Calysto Scheme Variables

## SCHEMEPATH
SCHEMEPATH is a list of search directories used with (load NAME). This is a reference, so you should append to it rather than attempting to redefine it.

```{scheme}
SCHEMEPATH
```

```{scheme}
(set-cdr! (cdr SCHEMEPATH) (list "/var/modules"))
```

```{scheme}
SCHEMEPATH
```

## Getting Started

Note that you can use the word `lambda` or \lambda and then press [TAB]

```{scheme}
(define factorial
  (λ (n)
     (cond
      ((zero? n) 1)
      (else (* n (factorial (- n 1)))))))
```

```{scheme}
(factorial 5)
```

## define-syntax
(define-syntax NAME RULES): a method for creating macros

```{scheme}
(define-syntax time 
  [(time ?exp) (let ((start (current-time)))
                 ?exp
                 (- (current-time) start))])
```

```{scheme}
(time (car '(1 2 3 4)))
```

```{scheme}
;;---------------------------------------------------------------------
;; collect is like list comprehension in Python

(define-syntax collect
  [(collect ?exp for ?var in ?list)
   (filter-map (lambda (?var) ?exp) (lambda (?var) #t) ?list)]
  [(collect ?exp for ?var in ?list if ?condition)
   (filter-map (lambda (?var) ?exp) (lambda (?var) ?condition) ?list)])

(define filter-map
  (lambda (f pred? values)
    (if (null? values)
      '()
      (if (pred? (car values))
          (cons (f (car values)) (filter-map f pred? (cdr values)))
          (filter-map f pred? (cdr values))))))
```

```{scheme}
(collect (* n n) for n in (range 10))
```

```{scheme}
(collect (* n n) for n in (range 5 20 3))
```

```{scheme}
(collect (* n n) for n in (range 10) if (> n 5))
```

```{scheme}
;;---------------------------------------------------------------------
;; for loops

(define-syntax for
  [(for ?exp times do . ?bodies)
   (for-repeat ?exp (lambda () . ?bodies))]
  [(for ?var in ?exp do . ?bodies)
   (for-iterate1 ?exp (lambda (?var) . ?bodies))]
  [(for ?var at (?i) in ?exp do . ?bodies)
   (for-iterate2 0 ?exp (lambda (?var ?i) . ?bodies))]
  [(for ?var at (?i ?j . ?rest) in ?exp do . ?bodies)
   (for ?var at (?i) in ?exp do
     (for ?var at (?j . ?rest) in ?var do . ?bodies))])

(define for-repeat
  (lambda (n f)
    (if (< n 1)
      'done
      (begin
        (f)
        (for-repeat (- n 1) f)))))

(define for-iterate1
  (lambda (values f)
    (if (null? values)
      'done
      (begin
        (f (car values))
        (for-iterate1 (cdr values) f)))))

(define for-iterate2
  (lambda (i values f)
    (if (null? values)
      'done
      (begin
        (f (car values) i)
        (for-iterate2 (+ i 1) (cdr values) f)))))
```

```{scheme}
(define matrix2d
  '((10 20)
    (30 40)
    (50 60)
    (70 80)))

(define matrix3d
  '(((10 20 30) (40 50 60))
    ((70 80 90) (100 110 120))
    ((130 140 150) (160 170 180))
    ((190 200 210) (220 230 240))))
```

```{scheme}
(begin 
 (define hello 0)
 (for 5 times do (set! hello (+ hello 1)))
 hello
 )
```

```{scheme}
(for sym in '(a b c d) do (define x 1) (set! x sym) (print x))
```

```{scheme}
(for n in (range 10 20 2) do (print n))
```

```{scheme}
(for n at (i j) in matrix2d do (print (list n 'coords: i j)))
```

```{scheme}
(for n at (i j k) in matrix3d do (print (list n 'coords: i j k)))
```

```{scheme}
(define-syntax scons
  [(scons ?x ?y) (cons ?x (lambda () ?y))])

(define scar car)

(define scdr
  (lambda (s)
    (let ((result ((cdr s))))
      (set-cdr! s (lambda () result))
      result)))

(define first
  (lambda (n s)
    (if (= n 0)
      '()
      (cons (scar s) (first (- n 1) (scdr s))))))

(define nth
  (lambda (n s)
    (if (= n 0)
      (scar s)
      (nth (- n 1) (scdr s)))))

(define smap
  (lambda (f s)
    (scons (f (scar s)) (smap f (scdr s)))))

(define ones (scons 1 ones))

(define nats (scons 0 (combine nats + ones)))

(define combine
  (lambda (s1 op s2)
    (scons (op (scar s1) (scar s2)) (combine (scdr s1) op (scdr s2)))))

(define fibs (scons 1 (scons 1 (combine fibs + (scdr fibs)))))

(define facts (scons 1 (combine facts * (scdr nats))))

(define ! (lambda (n) (nth n facts)))
```

```{scheme}
(! 5)
```

```{scheme}
(nth 10 facts)
```

```{scheme}
(nth 20 fibs)
```

```{scheme}
(first 30 fibs)
```

## for-each
(for-each PROCEDURE LIST): apply PROCEDURE to each item in LIST; like `map` but don't return results

```{scheme}
(for-each (lambda (n) (print n)) '(3 4 5))
```

## format
(format STRING ITEM ...): format the string with ITEMS as arguments

```{scheme}
(format "This uses formatting ~a ~s ~%" 'apple 'apple)
```

## func

Turns a lambda into a Python function.

(func (lambda ...))

```{scheme}
(func (lambda (n) n))
```

## There's more!

Please see [Calysto Scheme Language](Calysto%20Scheme%20Language.ipynb) for more details on the Calysto Scheme language.

---
kernelspec:
  display_name: R
  language: R
  name: ir
---

This notebook was created with IRKernel 0.8.12, and is not completely valid, as the code cell below contains an unexpected 'source' entry. This did cause https://github.com/mwouts/jupytext/issues/234. Note that the problem is solved when one upgrades to IRKernel 1.0.0.

```{code-cell} r
library("ggplot2")
ggplot(mtcars, aes(mpg)) + stat_ecdf()
```

---
kernelspec:
  display_name: Tcl
  language: tcl
  name: tcljupyter
---

# Assign Values

```{code-cell}
set a 1
puts "a = $a"
```

# Loop

```{code-cell}
for {set i 0} {$i < 10} {incr i} {
    puts "I inside first loop: $i"
}
```

```{code-cell}

```

---
jupyter:
  kernelspec:
    display_name: Python 2
    language: python
    name: python2
---

# A notebook with R cells

This notebook shows the use of R cells to generate plots

```{python}
# %load_ext rpy2.ipython
```

```{r}
suppressMessages(require(tidyverse))
```

```{r}
ggplot(iris, aes(x = Sepal.Length, y = Petal.Length, color=Species)) + geom_point()
```

The default plot dimensions are not good for us, so we use the -w and -h parameters in %%R magic to set the plot size

```{r magic_args="-w 400 -h 240"}
ggplot(iris, aes(x = Sepal.Length, y = Petal.Length, color=Species)) + geom_point()
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

<!-- #region {"slideshow": {"slide_type": "slide"}} -->
A markdown cell
<!-- #endregion -->

```python slideshow={"slide_type": ""}
1+1
```

<!-- #region {"cell_style": "center", "slideshow": {"slide_type": "fragment"}} -->
Markdown cell two
<!-- #endregion -->

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {#cell-1 .cell .code}
``` python
%load_ext rpy2.ipython
import pandas as pd

df = pd.DataFrame(
    {
        "Letter": ["a", "a", "a", "b", "b", "b", "c", "c", "c"],
        "X": [4, 3, 5, 2, 1, 7, 7, 5, 9],
        "Y": [0, 4, 3, 6, 7, 10, 11, 9, 13],
        "Z": [1, 2, 3, 1, 2, 3, 1, 2, 3],
    }
)
```
:::

::: {#cell-2 .cell .code}
``` python
%%R -i df
library("ggplot2")
ggplot(data = df) + geom_point(aes(x = X, y = Y, color = Letter, size = Z))
```
:::

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

# Part one - various cells

<!-- #region -->
Here we have a markdown cell


with two blank lines
<!-- #endregion -->

Now we have a markdown cell
with a code block inside it

```python
1 + 1
```

After that cell we'll have a code cell

```{python}
2 + 2


3 + 3
```

Followed by a raw cell

```{python active="", eval=FALSE}
This is 
the content
of the raw cell
```

# Part two - cell metadata

<!-- #region key="value" -->
This is a markdown cell with cell metadata `{"key": "value"}`
<!-- #endregion -->

```{python .class=None, tags=c("parameters")}
"""This is a code cell with metadata `{"tags":["parameters"], ".class":null}`"""
```

```{python key="value", active="", eval=FALSE}
This is a raw cell with cell metadata `{"key": "value"}`
```

---
kernelspec:
  display_name: Coconut
  language: coconut
  name: coconut
---

Taken fron [coconut-lang.org](coconut-lang.org)

+++

pipeline-style programming

```{code-cell} coconut
"hello, world!" |> print
```

 prettier lambdas

```{code-cell} coconut
x -> x ** 2
```

partial application

```{code-cell} coconut
range(10) |> map$(pow$(?, 2)) |> list
```

pattern-matching

```{code-cell} coconut
match [head] + tail in [0, 1, 2, 3]:
    print(head, tail)
```

destructuring assignment

```{code-cell} coconut
{"list": [0] + rest} = {"list": [0, 1, 2, 3]}
```

infix notation

```{code-cell} coconut
# 5 `mod` 3 == 2
```

operator functions

```{code-cell} coconut
product = reduce$(*)
```

function composition

```{code-cell} coconut
# (f..g..h)(x, y, z)
```

lazy lists

```{code-cell} coconut
# (| first_elem() |) :: rest_elems()
```

parallel programming

```{code-cell} coconut
range(100) |> parallel_map$(pow$(2)) |> list
```

tail call optimization

```{code-cell} coconut
def factorial(n, acc=1):
    case n:
        match 0:
            return acc
        match _ is int if n > 0:
            return factorial(n-1, acc*n)
```

algebraic data types

```{code-cell} coconut
data Empty()
data Leaf(n)
data Node(l, r)

def size(Empty()) = 0

addpattern def size(Leaf(n)) = 1

addpattern def size(Node(l, r)) = size(l) + size(r)
```

and much more!

Like what you see? Don't forget to star Coconut on GitHub!

```{code-cell} coconut

```

---
kernelspec:
  display_name: Octave
  language: octave
  name: octave
---

A markdown cell

```{code-cell}
1 + 1
```

```{code-cell}
% a code cell with comments
2 + 2
```

```{code-cell}
% a simple plot
x = -10:0.1:10;
plot (x, sin (x));
```

```{code-cell}
%plot -w 800
% a simple plot with a magic instruction
x = -10:0.1:10;
plot (x, sin (x));
```

And to finish with, a Python cell

```{code-cell}
%%python
a = 1
```

```{code-cell}
%%python
a + 1
```

---
jupyter:
  kernelspec:
    display_name: PowerShell
    language: PowerShell
    name: powershell
---

This is an extract from
https://github.com/Jaykul/Jupyter-PowerShell/blob/master/LiterateDevOps.ipynb

```powershell
$imageUrl = 'https://upload.wikimedia.org/wikipedia/commons/2/2f/PowerShell_5.0_icon.png'
$ImageData = @{ "png" = (Invoke-WebRequest $imageUrl -UseBasicParsing).RawContentStream.GetBuffer() }
# $ImageData

Write-Jupyter -InputObject $ImageData -Metadata @{ "image/png" = @{ 'width' = 32 } }
Write-Jupyter -InputObject $ImageData -Metadata @{ "image/png" = @{ 'width' = 64 } }
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .raw}
```{=ipynb}
---
title: "Quick test"
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
     chunk_output_type console
---
```
:::

::: {.cell .code}
``` {.python}
1+2+3
```
:::

::: {.cell .code}
``` {.python}
```
:::

---
kernelspec:
  display_name: Xonsh
  language: xonsh
  name: xonsh
---

```{code-cell} xonsh
len($(curl -L https://xon.sh))
```

```{code-cell} xonsh
for filename in `.*`:
    print(filename)
    du -sh @(filename)
```

---
jupyter: python3
---

```{python}
# This is an unfrozen cell. Works as usual.
print("I'm a regular cell so I run and print!")
```

```{python}
#| deletable: false
#| editable: false
#| run_control: {frozen: true}
# This is an frozen cell
print("I'm frozen so Im not executed :(")
```

---
jupyter:
  kernelspec:
    display_name: Bash
    language: bash
    name: bash
---

```bash
ls
```

```bash
# https://coderwall.com/p/euwpig/a-better-git-log
git config --global alias.lg "log --color --graph --pretty=format:'%Cred%h%Creset -%C(yellow)%d%Creset %s %Cgreen(%cr) %C(bold blue)<%an>%Creset' --abbrev-commit"
```

```bash
git lg
```

---
jupyter:
  kernelspec:
    display_name: Xonsh
    language: xonsh
    name: xonsh
---

```{xonsh}
len($(curl -L https://xon.sh))
```

```{xonsh}
for filename in `.*`:
    print(filename)
    du -sh @(filename)
```

---
jupyter:
  kernelspec:
    display_name: gnuplot
    language: gnuplot
    name: gnuplot
---

# Sample gnuplot notebook


## Simple plotting

```gnuplot
# Plot sin and cos with different linetypes

f(x) = sin(x)
g(x) = cos(x)
set xrange[0:2*pi]
set xtics(0, "{/Symbol p}" pi , "2{/Symbol p}" 2*pi)
set ytics 1
plot f(x) linewidth 2 title "sin(x)", \
    g(x) linewidth 2 dashtype "--" title "cos(x)"
```

## Example of line magic

```gnuplot
%gnuplot inline pngcairo enhanced background rgb "#EEEEEE" size 600, 600
# Parametric plot without border

reset
set parametric
set size ratio -1
unset border
unset tics
plot f(t), g(t) linewidth 2 notitle
```

---
jupyter:
  kernelspec:
    display_name: ROOT C++
    language: c++
    name: root
---

```c++
#include <iostream>
#include <string>
```

```c++
int k = 4;
std::string foo = "This string says \"foo\"";
```

```c++
std::cout << "k = " << k << '\n' << foo << '\n';
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

<!-- #region slideshow={"slide_type": "slide"} -->
A markdown cell
<!-- #endregion -->

```python slideshow={"slide_type": ""}
1+1
```

<!-- #region cell_style="center" slideshow={"slide_type": "fragment"} -->
Markdown cell two
<!-- #endregion -->

---
jupyter:
  kernelspec:
    display_name: Maxima
    language: maxima
    name: maxima
---

## maxima misc

```maxima
kill(all)$
```

```maxima
f(x) := 1/(x^2+l^2)^(3/2);
```

```maxima
integrate(f(x), x);
```

```maxima
tex(%)$
```

```maxima

```

---
kernelspec:
  display_name: IDL [conda env:gdl] *
  language: IDL
  name: conda-env-gdl-idl
---

## GDL demo notebook

+++

Demonstration of GDL [(gnudatalanguage)](https://github.com/gnudatalanguage/gdl)

This notebook creates a Shepp-Logan phantom, projects it and then performs an FBP reconstruction.

```{code-cell}
;; L.A. Shepp and B.F. Logan, “The Fourier reconstruction of a head section,”
;; IEEE Trans. Nucl. Sci. 21(3), 21–43 (1974).
function shepplogan, size = size

  if NOT keyword_set(size) then size = 256

  phantom = fltarr(size,size)

  tmp  = (findgen(size)-((size-1)/2.0)) / (size/2.0)
  xcor = rebin(tmp,size,size)
  ycor = rebin(transpose(tmp),size,size)
  tmp  = fltarr(size,size)
  
  aa={cx: 0.0,  cy: 0.0,    maj:0.69,   min:0.92,  theta:  0.0, val: 2.0 }
  bb={cx: 0.0,  cy:-0.0184, maj:0.6624, min:0.874, theta:  0.0, val:-0.98}
  cc={cx: 0.22, cy: 0.0,    maj:0.11,   min:0.31,  theta:-18.0, val:-0.02}
  dd={cx:-0.22, cy: 0.0,    maj:0.16,   min:0.41,  theta: 18.0, val:-0.02}
  ee={cx: 0.0,  cy: 0.35,   maj:0.21,   min:0.25,  theta:  0.0, val:-0.01}
  ff={cx: 0.0,  cy: 0.1,    maj:0.046,  min:0.046, theta:  0.0, val:-0.01}
  gg={cx: 0.0,  cy:-0.1,    maj:0.046,  min:0.046, theta:  0.0, val:-0.01}
  hh={cx:-0.08, cy:-0.605,  maj:0.046,  min:0.023, theta:  0.0, val:-0.01}
  ii={cx: 0.0,  cy:-0.605,  maj:0.023,  min:0.023, theta:  0.0, val:-0.01}
  jj={cx: 0.06, cy:-0.605,  maj:0.023,  min:0.046, theta:  0.0, val:-0.01}

  list = [aa,bb,cc,dd,ee,ff,gg,hh,ii,jj]
  for n = 0, n_elements(list)-1 do begin

     tmp = ((xcor-list[n].cx) / list[n].maj)^2 $
           + ((ycor-list[n].cy) / list[n].min)^2
     
     if list[n].theta NE 0 then begin
        nx = (size-1) * (list[n].cx + 1) / 2
        ny = (size-1) * (list[n].cy + 1) / 2
        tmp = rot(tmp, -list[n].theta, 1, nx, ny, /interp, /pivot)
     endif
     
     phantom[where(tmp LE 1.0)] += list[n].val
     
  endfor
  
  return, phantom < 1.1
  
end
```

```{code-cell}
;; Enable inline plotting
!inline=1
```

```{code-cell}
phantom = shepplogan()
window, 0, xsize=256, ysize=256
tvscl, phantom > 0.95
```

Now we define simple forward and backprojection functions:

```{code-cell}
function proj, image, angle

    sino_size_x = max(size(image,/dim))
    sino_size_y = n_elements(angle)

    sino = fltarr(sino_size_x, sino_size_y)
    
    for aa=0, n_elements(angle)-1 do begin
    
        sino[*,aa] = total(rot(image, angle[aa], /interp), 2)
    
    endfor

    return, sino
    
end
```

```{code-cell}
function back, sino, angle

    image_size = n_elements(sino[*,0])
    image = fltarr(image_size,image_size)

    for aa=0, n_elements(angle)-1 do begin
    
        image += rot(rebin(sino[*,aa],[image_size,image_size]), -angle[aa], /interp)
    
    endfor

    return, image / n_elements(angle)

end
```

This allows us to create a sinogram:

```{code-cell}
angles = findgen(360)
sino = proj(phantom, angles)
window, 0, xsize=256, ysize=360
tvscl, sino
```

On this we can apply a simple FBP reconstruction:

```{code-cell}
;; G.L. Zeng, “Revisit of the Ramp Filter,”
;; IEEE Trans. Nucl. Sci. 62(1), 131–136 (2015).
function fbp, sino, angles
  
  ntot = n_elements(sino[*,0])
  nang = n_elements(sino[0,*])
  npos = ntot / 2 + 1           ; integer division needed !
  nneg = ntot - npos

  freq = findgen(ntot)
  freq[npos:ntot-1] = REVERSE(freq[1:nneg])
  freq[0] = 1

  filter = -1 / (!pi * freq)^2
  filter[where(freq mod 2 EQ 0)] *= -0.0
  filter[0] = 0.25

  filter = abs(fft(filter)) * ntot
  filter[ntot/4:ntot/4+ntot/2-1] *= 0.0
  filter = rebin(filter,ntot,nang)

  ;; apply filter to the sinogram
  fsino  = fft(sino,  dim=1)
  fsino *= filter
  fsino  = fft(fsino, dim=1, /overwrite, /inverse)
  fsino  = !pi * real_part(fsino)

  ;; backproject the filtered sinogram
  return, back(fsino, angles)

end
```

```{code-cell}
reconstruction = fbp(sino, angles)
window, 0, xsize=512, ysize=256

tvscl, [phantom, reconstruction] > 0.8
```

### The end

---
kernelspec:
  display_name: Haskell
  language: haskell
  name: haskell
---

# Example Haskell Notebook

+++

Define a function to add two numbers.

```{code-cell} Haskell
f :: Num a => a -> a -> a
f x y = x + y
```

Try to use the function

```{code-cell} Haskell
f 1 2 
```

---
kernelspec:
  display_name: Wolfram Language 13.1
  language: Wolfram Language
  name: wolframlanguage13.1
---

**Note:** The `language_info` `file_extension` in this notebook should be `.m`, but it was deliberately changed to `.wolfram` to avoid conflicts with Matlab which is using the same extension.

+++

We start with...

```{code-cell} mathematica
Print["Hello, World!"];
```

Then we draw the first example plot from the [ListPlot](https://reference.wolfram.com/language/ref/ListPlot.html) reference:

```{code-cell} mathematica
ListPlot[Prime[Range[25]]]
```

We also test the math outputs as in the [Simplify](https://reference.wolfram.com/language/ref/Simplify.html) example:

```{code-cell} mathematica
D[Integrate[1/(x^3 + 1), x], x]
```

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{code-cell} ipython3
c = '''
title: "Quick test"
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
     chunk_output_type console
'''
```

```{code-cell} ipython3
import yaml
print(yaml.dump(yaml.load(c)))
```

```{code-cell} ipython3
?next
```

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{raw-cell}

---

This is a complex paragraph
that is split over multiple lines.

It also includes blank lines.


---
```

```{code-cell}
print("Hello, World!")
```

---
jupyter:
  kernelspec:
    display_name: Clojure
    language: clojure
    name: clojure
---

# Clojupyter Demo

This example notebook is from the [Clojupyter](https://github.com/clojupyter/clojupyter/blob/1637f6b2557f01db1e35bae5389bc38522eefe9a/examples/html-demo.ipynb) project.
This notebook demonstrates some of the more advanced features of Clojupyter.


## Displaying HTML

To display HTML, you'll need to require a clojupyter helper function to change the cell output

```{clojure}
(require '[clojupyter.misc.display :as display])
```

```{clojure}
(println ">> should print some text")
;; displaying html
(display/hiccup-html 
    [:ul 
     [:li "a " [:i "emphatic"] " idea"]
     [:li "a " [:b "bold"] " idea"]
     [:li "an " [:span {:style "text-decoration: underline;"} "important"] " idea"]])
```

We can also use this to render SVG:

```{clojure}
(display/hiccup-html
    [:svg {:height 100 :width 100 :xmlns "http://www.w3.org/2000/svg"}
            [:circle {:cx 50 :cy 40 :r 40 :fill "red"}]])
```

## Adding External Clojure Dependencies 

You can fetch external Clojure dependcies using the `clojupyter.misc.helper` namespace. 

```{clojure}
(require '[clojupyter.misc.helper :as helper])
```

```{clojure}
(helper/add-dependencies '[org.clojure/data.json "0.2.6"])
(require '[clojure.data.json :as json])
```

```{clojure}
(json/write-str {:a 1 :b [2, 3] :c "c"})
```

## Adding External Javascript Dependency

Since you can render arbitrary HTML using `display/hiccup-html`, it's pretty easy to use external Javascript libraries to do things like generate charts. Here's an example using [Highcharts](https://www.highcharts.com/).

First, we use a cell to add javascript to the running notebook:

```{clojure}
(helper/add-javascript "https://code.highcharts.com/highcharts.js")
```

Now we define a function which takes Clojure data and returns hiccup HTML to display:

```{clojure}
(defn plot-highchart [highchart-json]
  (let [id (str (java.util.UUID/randomUUID))
        code (format "Highcharts.chart('%s', %s );" id, (json/write-str highchart-json))]
      (display/hiccup-html 
        [:div [:div {:id id :style {:background-color "red"}}]
                   [:script code]])))
```

Now we can make generate interactive plots (try hovering over plot):

```{clojure}
(def raw-data (map #(+ (* 22 (+ % (Math/random)) 78)) (range)))
(def data-1 (take 500 raw-data))
(def data-2 (take 500 (drop 500 raw-data)))

(plot-highchart {:chart {:type "line"}
                 :title {:text "Plot of random data"}
                 :series [{:data data-1} {:data data-2}]})
```

```{clojure}

```

---
kernelspec:
  display_name: SoS
  language: sos
  name: sos
---

+++ {"Collapsed": "false", "kernel": "SoS"}

# Text SOS-kernel with Jupytext

## What is SOS kernel

SoS consists of a ployglot notebook that allows the use of multiple kernels in one Jupyter notebook, and a workflow system that is designed for daily computational research. Basically,

- SoS Polyglot Notebook is a Jupyter Notebook with a SoS kernel.
- SoS Notebook serves as a super kernel to all other Jupyter kernels and allows the use of multiple kernels in one Jupyter notebook.
- SoS Workflow System is a Python based workflow system that is designed to be readable, sharable, and suitable for daily data analysis.
- SoS Workflow System can be used from command line or use SoS Notebook as its IDE.

![](https://vatlab.github.io/sos-docs/doc/media/SoS_Notebook_and_Workflow.png)

### How to install SOS-kernel

Please follow this [link](https://vatlab.github.io/sos-docs/running.html#Conda-installation) to setup SOS

I run some issue with the latest version of R on my Mac, so I had to install an earlier version of R

```
conda install -c r r=3.5.1
conda install sos-notebook jupyterlab-sos sos-papermill -c conda-forge
```

## Related issue with Jupytext

Jupytext works fine with Python/R kernel but converts code cells into markdown cells when using the SOS kernel.

cf the image below. It is a code cell. After saving the notebook and restart it, it converted the code cell into markdown

<img width="734" alt="Screenshot 2020-03-13 at 10 51 18" src="https://user-images.githubusercontent.com/33351426/76610049-9e704600-6518-11ea-861e-b4f691d1a478.png">

+++ {"Collapsed": "false", "kernel": "SoS"}

## Step 1

Please, choose SOS Kernel and then, in the cell code, choose SOS (or any other kernel available), the outcome is the same.

![](https://drive.google.com/uc?export=view&id=1OtyxfwoRyVK23XHnmd9JR-crBgHBL5mt)

```{code-cell} sos
:Collapsed: 'false'
:kernel: SoS

import pandas as pd 
import numpy as np

pd.DataFrame({
    'x': np.random.random(10),
    'y': np.random.random(10),
})
```

+++ {"Collapsed": "false", "kernel": "python3"}

## Step 2

Now, pair it with Jupytex

![](https://drive.google.com/uc?export=view&id=1Wtx-YPAXY8HWHqzCcy4iIgHpzt_9emEn)

+++ {"Collapsed": "false", "kernel": "python3"}

### Step 3

Save the notebook, restart and clear all, **save**, then Shut down kernel. Close the notebook and reopen

+++ {"Collapsed": "false", "kernel": "python3"}

### Step 4

Reopen the notebook. Here is the outcome

![](https://drive.google.com/uc?export=view&id=12C70unbSPv0gHCZaCICEUy7kO7wM93JH)

---
jupyter:
  kernelspec:
    display_name: .NET (C#)
    language: C#
    name: .net-csharp
---

We start with...

```csharp
Console.WriteLine("Hello World!");
```

Then we do a plot with Plotly, following the [Plotting with XPlot](https://github.com/dotnet/interactive/blob/master/NotebookExamples/csharp/Docs/Plotting%20with%20Xplot.ipynb) example from `dotnet/interactive`:

```csharp
using XPlot.Plotly;

var bar = new Graph.Bar
{
    name = "Bar",
    x = new[] {'A', 'B', 'C'},
    y = new[] {1, 3, 2}
};

var chart = Chart.Plot(new[] {bar});
chart.WithTitle("A bar plot");
display(chart);
```

We also test the math outputs as in the [Math and Latex](https://github.com/dotnet/interactive/blob/master/NotebookExamples/csharp/Docs/Math%20and%20LaTeX.ipynb) example:

```csharp
(LaTeXString)@"\begin{align} e^{i \pi} = -1\end{align}"
```

```csharp
(MathString)@"e^{i \pi} = -1"
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

# Jupyter notebook

This notebook is a simple jupyter notebook. It only has markdown and code cells. And it does not contain consecutive markdown cells. We start with an addition:

```{python}
a = 1
b = 2
a + b
```

Now we return a few tuples

```{python}
a, b
```

```{python}
a, b, a+b
```

And this is already the end of the notebook

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .code}
``` {.python}
# This is an unfrozen cell. Works as usual.
print("I'm a regular cell so I run and print!")
```
:::

::: {.cell .code deletable="false" editable="false" run_control="{\"frozen\":true}"}
``` {.python}
# This is an frozen cell
print("I'm frozen so Im not executed :(")
```
:::

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .code}
``` python
c = '''
title: "Quick test"
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
     chunk_output_type console
'''
```
:::

::: {.cell .code}
``` python
import yaml
print(yaml.dump(yaml.load(c)))
```
:::

::: {.cell .code}
``` python
?next
```
:::

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```html
<p><a href="https://github.com/mwouts/jupytext", style="color: rgb(0,0,255)">Jupytext</a> on GitHub</p>
```

```latex
$\frac{\pi}{2}$
```

```python
%load_ext rpy2.ipython
```

```R
library(ggplot2)
ggplot(data=data.frame(x=c('A', 'B'), y=c(5, 2)), aes(x,weight=y)) + geom_bar()
```

```python
%matplotlib inline
import pandas as pd
pd.Series({'A':5, 'B':2}).plot(figsize=(3,2), kind='bar')
```

---
jupyter:
  kernelspec:
    display_name: Coconut
    language: coconut
    name: coconut
---

Taken fron [coconut-lang.org](coconut-lang.org)


pipeline-style programming

```{coconut}
"hello, world!" |> print
```

 prettier lambdas

```{coconut}
x -> x ** 2
```

partial application

```{coconut}
range(10) |> map$(pow$(?, 2)) |> list
```

pattern-matching

```{coconut}
match [head] + tail in [0, 1, 2, 3]:
    print(head, tail)
```

destructuring assignment

```{coconut}
{"list": [0] + rest} = {"list": [0, 1, 2, 3]}
```

infix notation

```{coconut}
# 5 `mod` 3 == 2
```

operator functions

```{coconut}
product = reduce$(*)
```

function composition

```{coconut}
# (f..g..h)(x, y, z)
```

lazy lists

```{coconut}
# (| first_elem() |) :: rest_elems()
```

parallel programming

```{coconut}
range(100) |> parallel_map$(pow$(2)) |> list
```

tail call optimization

```{coconut}
def factorial(n, acc=1):
    case n:
        match 0:
            return acc
        match _ is int if n > 0:
            return factorial(n-1, acc*n)
```

algebraic data types

```{coconut}
data Empty()
data Leaf(n)
data Node(l, r)

def size(Empty()) = 0

addpattern def size(Leaf(n)) = 1

addpattern def size(Node(l, r)) = size(l) + size(r)
```

and much more!

Like what you see? Don't forget to star Coconut on GitHub!

```{coconut}

```

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{raw-cell}

---
title: "Quick test"
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
     chunk_output_type console
---
```

```{code-cell} ipython3
1+2+3
```

```{code-cell} ipython3

```

---
kernelspec:
  display_name: Python 2
  language: python
  name: python2
---

# A notebook with R cells

This notebook shows the use of R cells to generate plots

```{code-cell} ipython2
%load_ext rpy2.ipython
```

```{code-cell} ipython2
%%R
suppressMessages(require(tidyverse))
```

```{code-cell} ipython2
%%R
ggplot(iris, aes(x = Sepal.Length, y = Petal.Length, color=Species)) + geom_point()
```

The default plot dimensions are not good for us, so we use the -w and -h parameters in %%R magic to set the plot size

```{code-cell} ipython2
%%R -w 400 -h 240
ggplot(iris, aes(x = Sepal.Length, y = Petal.Length, color=Species)) + geom_point()
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .markdown}
This notebook contains outputs of many different types: text, HTML, plots and errors.
:::

::: {.cell .markdown}
# Text outputs

Using `print`, `sys.stdout` and `sys.stderr`
:::

::: {.cell .code}
``` {.python}
import sys
print('using print')
sys.stdout.write('using sys.stdout.write')
sys.stderr.write('using sys.stderr.write')
```
:::

::: {.cell .code}
``` {.python}
import logging
logging.debug('Debug')
logging.info('Info')
logging.warning('Warning')
logging.error('Error')
```
:::

::: {.cell .markdown}
# HTML outputs

Using `pandas`. Here we find two representations: both text and HTML.
:::

::: {.cell .code}
``` {.python}
import pandas as pd
pd.DataFrame([4])
```
:::

::: {.cell .code}
``` {.python}
from IPython.display import display
display(pd.DataFrame([5]))
display(pd.DataFrame([6]))
```
:::

::: {.cell .markdown}
# Images
:::

::: {.cell .code}
``` {.python}
%matplotlib inline
```
:::

::: {.cell .code}
``` {.python}
# First plot
from matplotlib import pyplot as plt
import numpy as np
w, h = 3, 3
data = np.zeros((h, w, 3), dtype=np.uint8)
data[0,:] = [0,255,0]
data[1,:] = [0,0,255]
data[2,:] = [0,255,0]
data[1:3,1:3] = [255, 0, 0]
plt.imshow(data)
plt.axis('off')
plt.show()
# Second plot
data[1:3,1:3] = [255, 255, 0]
plt.imshow(data)
plt.axis('off')
plt.show()
```
:::

::: {.cell .markdown}
# Errors
:::

::: {.cell .code}
``` {.python}
undefined_variable
```
:::

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

# Part one - various cells

+++

Here we have a markdown cell


with two blank lines

+++

Now we have a markdown cell
with a code block inside it

```python
1 + 1
```

After that cell we'll have a code cell

```{code-cell} ipython3
2 + 2


3 + 3
```

Followed by a raw cell

```{raw-cell}
This is 
the content
of the raw cell
```

# Part two - cell metadata

+++ {"key": "value"}

This is a markdown cell with cell metadata `{"key": "value"}`

```{code-cell} ipython3
---
.class: null
tags: [parameters]
---
"""This is a code cell with metadata `{"tags":["parameters"], ".class":null}`"""
```

```{raw-cell}
:key: value

This is a raw cell with cell metadata `{"key": "value"}`
```

---
jupyter:
  kernelspec:
    display_name: Haskell
    language: haskell
    name: haskell
---

# Example Haskell Notebook


Define a function to add two numbers.

```{haskell}
f :: Num a => a -> a -> a
f x y = x + y
```

Try to use the function

```{haskell}
f 1 2 
```

---
jupyter:
  kernel_info:
    name: python3
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```{python inputHidden=FALSE, outputHidden=FALSE, tags=c("parameters")}
param = 4
```

```{python inputHidden=FALSE, outputHidden=FALSE}
import pandas as pd
```

```{python inputHidden=FALSE, outputHidden=FALSE}
df = pd.DataFrame({'A': [1, 2], 'B': [3 + param, 4]},
                  index=pd.Index(['x0', 'x1'], name='x'))
df
```

```{python inputHidden=FALSE, outputHidden=FALSE}
# %matplotlib inline
df.plot(kind='bar')
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```python
c = '''
title: "Quick test"
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
     chunk_output_type console
'''
```

```python
import yaml
print(yaml.dump(yaml.load(c)))
```

```python
?next
```

---
jupytext:
  encoding: '// -*- coding: utf-8 -*-'
  formats: ipynb,java:light
kernelspec:
  display_name: Java
  language: java
  name: java
---

Let's define some class.

```{code-cell}
class A {
    public void hello() {
        System.out.println("Hello World");
    }   
}
```

And now we call its method.

```{code-cell}
new A().hello();
```

You can run it e.g. with `jshell`

* from command line, as `jshell simple-helloworld.java`
* from jshell's shell with `/open simple-helloworld.java`

---
jupyter:
  kernelspec:
    display_name: Stata
    language: stata
    name: stata
---

```{stata}
// This notebook uses the stata_kernel: https://github.com/kylebarron/stata_kernel
```

```{stata}
use http://www.stata-press.com/data/r13/auto
```

```{stata}
summarize
```

```{stata}
scatter weight length
```

---
kernelspec:
  display_name: SAS
  language: sas
  name: sas
---

# SAS Notebooks with jupytext

```{code-cell}
proc sql;
    select *
    from sashelp.cars (obs=10)
    ;
quit; 
```

```{code-cell}
%let name = "Jupytext";
```

```{code-cell}
%put &name;
```

```{code-cell}
/* Note when defining macros "%macro" cannot be the first line of text in the cell */
%macro test;
    data temp;
        set sashelp.cars;
        name = "testx";
    run; 
    proc print data = temp (obs=10);
    run; 
%mend test;

%test
```

---
kernel_info:
  name: python3
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{code-cell} ipython3
:inputHidden: false
:outputHidden: false
:tags: [parameters]

param = 4
```

```{code-cell} ipython3
:inputHidden: false
:outputHidden: false

import pandas as pd
```

```{code-cell} ipython3
:inputHidden: false
:outputHidden: false

df = pd.DataFrame({'A': [1, 2], 'B': [3 + param, 4]},
                  index=pd.Index(['x0', 'x1'], name='x'))
df
```

```{code-cell} ipython3
:inputHidden: false
:outputHidden: false

%matplotlib inline
df.plot(kind='bar')
```

---
title: "Quick ioslides"
subtitle: "Slides generated using R, python and ioslides"
author: "Marc Wouts"
date: "June 15, 2018"
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
  chunk_output_type: console
---

## What is ioslides?

This is the default format in rstudio for building interactive HTML presentations.

Enjoy the [manual](https://rmarkdown.rstudio.com/ioslides_presentation_format.html)!

These slides can be turned to a single HTML file with either a click on 'knitr' in rstudio, or, command line:
```bash
R -e 'rmarkdown::render("ioslides.Rmd")'
```

## A sample plot

<div style="float: left; width: 30%;">
Here we create a sample data set for plotting.

```{python echo=TRUE}
import pandas as pd
x = pd.Series({'A':1, 'B':3, 'C':2})
```

Then, in another column we plot. The R notebook code chunks have many [options](https://yihui.name/knitr/options/).
For this plot I chose not to display the source code.
</div>

<div style="float: right; width: 70%;">
```{python echo=FALSE, fig.height=5, fig.width=8}
x.plot(kind='bar', title='Sample plot')
```
<div>

---
jupyter:
  jupytext:
    encoding: '// -*- coding: utf-8 -*-'
    formats: ipynb,java:light
  kernelspec:
    display_name: Java
    language: java
    name: java
---

Let's define some class.

```java
class A {
    public void hello() {
        System.out.println("Hello World");
    }   
}
```

And now we call its method.

```java
new A().hello();
```

You can run it e.g. with `jshell`

* from command line, as `jshell simple-helloworld.java`
* from jshell's shell with `/open simple-helloworld.java`

---
jupyter:
  kernelspec:
    display_name: Julia 1.1.1
    language: julia
    name: julia-1.1
  nbformat: 4
  nbformat_minor: 1
---

::: {.cell .code}
``` {.julia}
# IJulia rocks! So does Plotly. Check it out

using Plotly
api_key = "" # visit https://plot.ly/api to generate an API username and password
username = ""

Plotly.signin(username, api_key)
```
:::

::: {.cell .code}
``` {.julia}
# Following data taken from http://julialang.org/ frontpage 
benchmarks = ["fib", "parse_int", "quicksort3", "mandel", "pi_sum", "rand_mat_stat", "rand_mat_mul"]
platforms = ["Fortran", "Julia", "Python", "R", "Matlab", "Mathematica", "Javascript", "Go"]

data = {
        platforms[1] => [0.26, 5.03, 1.11, 0.86, 0.80, 0.64, 0.96],
        platforms[2] => [0.91, 1.60, 1.14, 0.85, 1.00, 1.66, 1.01],
        platforms[3] => [30.37, 13.95, 31.98, 14.19, 16.33, 13.52, 3.41 ],
        platforms[4] => [411.36, 59.40, 524.29, 106.97, 15.42, 10.84, 3.98  ],
        platforms[5] => [1992.00, 1463.16, 101.84, 64.58, 1.29, 6.61, 1.10   ],
        platforms[6] => [64.46, 29.54, 35.74, 6.07, 1.32, 4.52, 1.16 ],
        platforms[7] => [2.18, 2.43, 3.51, 3.49, 0.84, 3.28, 14.60],
        platforms[8] => [1.03, 4.79, 1.25, 2.36, 1.41, 8.12, 8.51]
        }

pdata = [ {"x"=>benchmarks,"y"=>data[k],"bardir"=>"h","type"=>"bar","name"=>k} for k = platforms ]

layout = {
          "title"=> "Julia benchmark comparison (smaller is better, C performance = 1.0)",
          "barmode"=> "group",
          "autosize"=> false,
          "width"=> 900,
          "height"=> 900,
          "titlefont"=>
          {
           "family"=> "Open Sans",
           "size"=> 18,
           "color"=> "rgb(84, 39, 143)"
           },
          "margin"=> {"l"=>160, "pad"=>0},
          "xaxis"=> {
                     "title"=> "Benchmark log-time",
                     "type"=> "log"
                     },
          "yaxis"=> {"title"=> "Benchmark Name"}
          }

response = Plotly.plot(pdata,["layout"=>layout])

# Embed in an iframe within IJulia
s = string("<iframe height='750' id='igraph' scrolling='no' seamless='seamless' src='",
            response["url"],
            "/700/700' width='750'></iframe>")
display("text/html", s)
```
:::

::: {.cell .code}
``` {.julia}
# checkout https://plot.ly/api/ for more Julia examples!
# But to show off some other Plotly features:
x = 1:1500
y1 = sin(2*pi*x/1500.) + rand(1500)-0.5
y2 = sin(2*pi*x/1500.)

fish = {"x"=>x,"y"=> y1,
	"type"=>"scatter","mode"=>"markers",
	"marker"=>{"color"=>"rgb(0, 0, 255)","opacity"=>0.5 } }

fit = {"x"=> x,"y"=> y2,
	"type"=>"scatter", "mode"=>"markers", "opacity"=>0.8,
	"marker"=>{"color"=>"rgb(255, 0, 0)"} }

layout = {"autosize"=> false,
    "width"=> 650, "height"=> 550,
    "title"=>"Fish School",
	"xaxis"=>{ "ticks"=> "",
        "gridcolor"=> "white",
        "zerolinecolor"=> "white",    
        "linecolor"=> "white",
        "autorange"=> false,
        "range"=>[0,1500] },
	"yaxis"=>{ "ticks"=> "",
        "gridcolor"=> "white",
        "zerolinecolor"=> "white",
		"linecolor"=> "white",
        "autorange"=> false,
        "range"=>[-2.2,2.2] },
	"plot_bgcolor"=> "rgb(245,245,247)",
    "showlegend"=> false,
    "hovermode"=> "closest"}

response = Plotly.plot([fish, fit],["layout"=>layout])
s = string("<iframe height='750' id='igraph' scrolling='no' seamless='seamless' src='",
            response["url"],
            "/700/700' width='750'></iframe>")
display("text/html", s)
```
:::

---
jupyter:
  kernel_info:
    name: python3
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .code inputHidden="false" outputHidden="false" tags="[\"parameters\"]"}
``` {.python}
param = 4
```
:::

::: {.cell .code inputHidden="false" outputHidden="false"}
``` {.python}
import pandas as pd
```
:::

::: {.cell .code inputHidden="false" outputHidden="false"}
``` {.python}
df = pd.DataFrame({'A': [1, 2], 'B': [3 + param, 4]},
                  index=pd.Index(['x0', 'x1'], name='x'))
df
```
:::

::: {.cell .code inputHidden="false" outputHidden="false"}
``` {.python}
%matplotlib inline
df.plot(kind='bar')
```
:::

---
title: Quick test
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
  chunk_output_type: console
kernelspec:
  display_name: Python 3
  language: python
  name: python3
jupytext:
  root_level_metadata_filter: -title,-output,-editor_options
---

```{code-cell} ipython3
1+2+3
```

```{code-cell} ipython3

```

This documents contains a code cell to make sure it is recognized as a MyST document.

```{code-cell} ipython3
1 + 1
```

This is a [reference-link to the issue][].

:::{note}
This note is key... not sure why.
:::

[reference-link to the issue]: <https://github.com/mwouts/jupytext/issues/789>

---
jupytext:
  encoding: '// -*- coding: utf-8 -*-'
  formats: ipynb,groovy:light
kernelspec:
  display_name: Groovy
  language: groovy
  name: groovy
---

# TailRecursive annotation

Let's check what is the effect of `@TailRecursive` annotation on the simple recursive definition of factorial function.

```{code-cell}
import groovy.transform.CompileStatic
import groovy.transform.TailRecursive
import groovy.transform.TypeChecked

@CompileStatic
@TypeChecked
class X {
    static final BigInteger factorial0(int n) {
        (n <= 1) ? 1G : factorial0(n-1).multiply(BigInteger.valueOf(n))
    }

    static final BigInteger factorial1(int n, BigInteger acc = 1G) {
        (n <= 1) ? acc : factorial1(n-1, acc.multiply(BigInteger.valueOf(n)))
    }

    @TailRecursive
    static final BigInteger factorial2(int n, BigInteger acc = 1G) {
        (n <= 1) ? acc : factorial2(n-1, acc.multiply(BigInteger.valueOf(n)))
    }
}

x = new X()
```

Although we can time the execution of the calls, it is not very accurate; such micro benchmarks should be performed in more controlled environment, such us under [JMH](https://openjdk.java.net/projects/code-tools/jmh/).

For example, see [blog posts of Szymon Stępniak](https://e.printstacktrace.blog/tail-recursive-methods-in-groovy/).

```{code-cell}
%%timeit

x.factorial0(19_000).toString().length()
```

```{code-cell}
%%timeit

x.factorial1(19_000).toString().length()
```

```{code-cell}
%%timeit

x.factorial2(19_000).toString().length()
```

The real difference is the use of stack. Non-tail recursive calls exhaust the stack space at some point, whereas tail recursive calls don't add frames to the stack.

```{code-cell}
factSize = { n, cl ->
    println "Factorial of ${n} has ${cl(n).toString().length()} digits"
}

factSize 2_000, x.&factorial0
factSize 2_000, x.&factorial1
factSize 2_000, x.&factorial2

factSize 100_000, x.&factorial2
```

```{code-cell}
try {
    factSize 100_000, x.&factorial1
} catch (Throwable e) {
    assert e instanceof StackOverflowError
    println e
}
```

---
jupyter:
  kernelspec:
    display_name: Stata
    language: stata
    name: stata
---

```stata
// This notebook uses the stata_kernel: https://github.com/kylebarron/stata_kernel
```

```stata
use http://www.stata-press.com/data/r13/auto
```

```stata
summarize
```

```stata
scatter weight length
```

# This is a plain markdown file

```python
1+1
```

And more comments

Another comment separated by one line


This is another cell, separated by two or more lines from the previous one.


And a last markdown cell, followed by a code cell
```python
1+1
```

---
kernelspec:
  display_name: ROOT C++
  language: c++
  name: root
---

```{code-cell}
#include <iostream>
#include <string>
```

```{code-cell}
int k = 4;
std::string foo = "This string says \"foo\"";
```

```{code-cell}
std::cout << "k = " << k << '\n' << foo << '\n';
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

This notebook contains complex outputs, including plotly javascript graphs.


# Interactive plots


We use Plotly's connected mode to make the notebook lighter - when connected, the notebook downloads the `plotly.js` library from the web.

```python
import plotly.offline as offline
offline.init_notebook_mode(connected=True)
```

```python
import plotly.graph_objects as go
fig = go.Figure(
    data=[go.Bar(y=[2, 3, 1])],
    layout=go.Layout(title="bar plot"))
fig.show()
fig.data[0].marker = dict(color='purple')
fig
```

---
kernelspec:
  display_name: Maxima
  language: maxima
  name: maxima
---

## maxima misc

```{code-cell} maxima
kill(all)$
```

```{code-cell} maxima
f(x) := 1/(x^2+l^2)^(3/2);
```

```{code-cell} maxima
integrate(f(x), x);
```

```{code-cell} maxima
tex(%)$
```

```{code-cell} maxima

```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

This cell uses no particular cell marker

$$
\begin{align}
\dot{x} & = \sigma(y-x)\\
\dot{y} & = \rho x - y - xz \\
\dot{z} & = -\beta z + xy
\end{align}
$$


This cell uses no particular cell marker, and a single slash in the $\LaTeX$ equation

$$
\begin{align}
\dot{x} & = \sigma(y-x) \
\dot{y} & = \rho x - y - xz \
\dot{z} & = -\beta z + xy
\end{align}
$$


This cell uses the triple quote cell markers introduced at https://github.com/mwouts/jupytext/issues/305

$$
\begin{align}
\dot{x} & = \sigma(y-x)\\
\dot{y} & = \rho x - y - xz \\
\dot{z} & = -\beta z + xy
\end{align}
$$

---
jupyter:
  kernelspec:
    display_name: Maxima
    language: maxima
    name: maxima
---

## maxima misc

```{maxima}
kill(all)$
```

```{maxima}
f(x) := 1/(x^2+l^2)^(3/2);
```

```{maxima}
integrate(f(x), x);
```

```{maxima}
tex(%)$
```

```{maxima}

```

---
jupyter:
  kernelspec:
    display_name: Tcl
    language: tcl
    name: tcljupyter
---

# Assign Values

```{tcl}
set a 1
puts "a = $a"
```

# Loop

```{tcl}
for {set i 0} {$i < 10} {incr i} {
    puts "I inside first loop: $i"
}
```

```{tcl}

```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```{python raw_mimetype="text/latex", active="", eval=FALSE}
$1+1$
```

```{python raw_mimetype="text/restructuredtext", active="", eval=FALSE}
:math:`1+1`
```

```{python raw_mimetype="text/html", active="", eval=FALSE}
<b>Bold text<b>
```

```{python raw_mimetype="text/markdown", active="", eval=FALSE}
**Bold text**
```

```{python raw_mimetype="text/x-python", active="", eval=FALSE}
1 + 1
```

```{python active="", eval=FALSE}
Not formatted
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .raw}
```{=ipynb}
---
title: Quick test
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
  chunk_output_type: console
---
```
:::

::: {#cell-1 .cell .code}
``` python
1+2+3
```
:::

::: {#cell-2 .cell .code}
``` python
```
:::

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {#cell-1 .cell .code}
``` python
1+2+3
```
:::

::: {.cell .raw}
```{=ipynb}
This is a raw cell
```
:::

::: {.cell .markdown}
This is a markdown cell
:::

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

<!-- #raw raw_mimetype="text/latex" -->
$1+1$
<!-- #endraw -->

<!-- #raw raw_mimetype="text/restructuredtext" -->
:math:`1+1`
<!-- #endraw -->

<!-- #raw raw_mimetype="text/html" -->
<b>Bold text<b>
<!-- #endraw -->

<!-- #raw raw_mimetype="text/markdown" -->
**Bold text**
<!-- #endraw -->

<!-- #raw raw_mimetype="text/x-python" -->
1 + 1
<!-- #endraw -->

<!-- #raw -->
Not formatted
<!-- #endraw -->

---
jupyter:
  kernelspec:
    display_name: Go (gonb)
    language: go
    name: gonb
---

A notebook that use [GoNB](https://github.com/janpfeifer/gonb)


the code below comes from [tutorial.ipynb](https://github.com/janpfeifer/gonb/blob/main/examples/tutorial.ipynb)

```{go}
func main() {
    fmt.Printf("Hello World!")
}
```

```{go}
%%
fmt.Printf("Hello World!")
```

%% --who=world can pass flags to main func

```{go}
import (
    "flag"
    "fmt"
)

var flagWho = flag.String("who", "", "Your name!")

%% --who=world
fmt.Printf("Hello %s!\n", *flagWho)
```

%args also can pass flags

```{go}
// %args --who=Wally

func main() {
    flag.Parse()
    fmt.Printf("Where is %s?", *flagWho)
}
```

```{go}
import "github.com/janpfeifer/gonb/gonbui"

%%
gonbui.DisplayHtml(`<span style="background:pink; color:#111; border-radius: 3px; border: 3px solid orange; font-size: 18px;">I 🧡 GoNB!</span>`)
```

```{go}
%%
gonbui.DisplayMarkdown("#### Objective\n\n1. Have fun coding **Go**;\n1. Profit...\n"+
                       `$$f(x) = \int_{-\infty}^{\infty} e^{-x^2} dx$$`)
```

```{go}
func init_a() {
    fmt.Println("init_a")
}
%%
fmt.Println("main")
```

---
title: "Quick test"
output:
  ioslides_presentation:
    widescreen: true
    smaller: true
editor_options:
     chunk_output_type console
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```{python}
1+2+3
```

```{python}

```

---
kernelspec:
  display_name: R
  language: R
  name: ir
---

This is a jupyter notebook that uses the IR kernel.

```{code-cell} r
sum(1:10)
```

```{code-cell} r
plot(cars)
```

```{code-cell} r

```

---
jupyter:
  kernelspec:
    display_name: R
    language: R
    name: ir
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .markdown}
This is a jupyter notebook that uses the IR kernel.
:::

::: {#cell-1 .cell .code}
``` R
sum(1:10)
```
:::

::: {#cell-2 .cell .code}
``` R
plot(cars)
```
:::

::: {#cell-3 .cell .code}
``` R
```
:::

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{code-cell} ipython3
1 + 1
```

A markdown cell
And below, the cell for function f has non trivial cell metadata. And the next cell as well.

```{code-cell} ipython3
---
attributes:
  classes: []
  id: ''
  n: '10'
---
def f(x):
    return x
```

```{code-cell} ipython3
---
attributes:
  classes: []
  id: ''
  n: '10'
---
f(5)
```

More text

```{code-cell} ipython3
2 + 2
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```{python}
1+2+3
```

```{python active="", eval=FALSE}
This is a raw cell
```

This is a markdown cell

---
kernelspec:
  display_name: Apache Toree - Scala
  language: scala
  name: apache_toree_scala
---

```{code-cell} scala
// This is just a simple scala notebook

object SampleObject {
    def calculation(x: Int, y: Int): Int = x + y
}

val result = SampleObject.calculation(1, 2)
```

```{code-cell} scala
println(result * 10)
```

---
kernelspec:
  display_name: Python 3 (ipykernel)
  language: python
  name: python3
---

+++ {"@deathbeds/jupyterlab-fonts": {"styles": {"": {"body[data-jp-deck-mode='presenting'] &": {"right": "0", "top": "30%", "width": "25%", "z-index": 1}}}}, "jupyterlab-slideshow": {"layer": "slide"}}

> **Note**
> 
> `slide` layer with a `top` of `30%`

---
jupyter:
  kernelspec:
    display_name: Octave
    language: octave
    name: octave
---

A markdown cell

```{octave}
1 + 1
```

```{octave}
% a code cell with comments
2 + 2
```

```{octave}
% a simple plot
x = -10:0.1:10;
plot (x, sin (x));
```

```{octave}
%plot -w 800
% a simple plot with a magic instruction
x = -10:0.1:10;
plot (x, sin (x));
```

And to finish with, a Python cell

```{python}
a = 1
```

```{python}
a + 1
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
---

```{python}
# This is an unfrozen cell. Works as usual.
print("I'm a regular cell so I run and print!")
```

```{python deletable=FALSE, editable=FALSE, run_control={'frozen': True}, eval=FALSE}
# This is an frozen cell
print("I'm frozen so Im not executed :(")
```

---
title: "Test chunk options in Rmd/Jupyter conversion"
author: "Marc Wouts"
date: "June 16, 2018"
jupyter:
  kernelspec:
    display_name: Python
    language: python
    name: python3
---

```{r knitr_setup, include=FALSE}
knitr::opts_chunk$set(echo = FALSE, fig.width = 10, fig.height = 5)
```


```{python echo=TRUE}
import pandas as pd
x = pd.Series({'A':1, 'B':3, 'C':2})
```

```{python bar_plot, echo=FALSE, fig.height=5, fig.width=8}
x.plot(kind='bar', title='Sample plot')
```

---
jupyter:
  kernelspec:
    display_name: Julia 1.1.1
    language: julia
    name: julia-1.1
---

```{julia}
# This notebook is a semi top-down explanation. This cell needs to be
# executed first so that the operators and helper functions are defined
# All of this is explained in the later half of the notebook

using Compose, Interact
Compose.set_default_graphic_size(2inch, 2inch)

points_f = [
    (.1, .1),
    (.9, .1),
    (.9, .2),
    (.2, .2),
    (.2, .4),
    (.6, .4),
    (.6, .5),
    (.2, .5),
    (.2, .9),
    (.1, .9),
    (.1, .1)
]

f = compose(context(), stroke("black"), line(points_f))

rot(pic) = compose(context(rotation=Rotation(-deg2rad(90))), pic)
flip(pic) = compose(context(mirror=Mirror(deg2rad(90), 0.5w, 0.5h)), pic)
above(m, n, p, q) =
    compose(context(),
            (context(0, 0, 1, m/(m+n)), p),
            (context(0, m/(m+n), 1, n/(m+n)), q))

above(p, q) = above(1, 1, p, q)

beside(m, n, p, q) =
    compose(context(),
            (context(0, 0, m/(m+n), 1), p),
            (context(m/(m+n), 0, n/(m+n), 1), q))

beside(p, q) = beside(1, 1, p, q)

over(p, q) = compose(context(),
                (context(), p), (context(), q))

rot45(pic) =
    compose(context(0, 0, 1/sqrt(2), 1/sqrt(2),
        rotation=Rotation(-deg2rad(45), 0w, 0h)), pic)

# Utility function to zoom out and look at the context
zoomout(pic) = compose(context(),
                (context(0.2, 0.2, 0.6, 0.6), pic),
                (context(0.2, 0.2, 0.6, 0.6), fill(nothing), stroke("black"), strokedash([0.5mm, 0.5mm]),
                    polygon([(0, 0), (1, 0), (1, 1), (0, 1)])))

function read_path(p_str)
    tokens = [try parsefloat(x) catch symbol(x) end for x in split(p_str, r"[\s,]+")]
    path(tokens)
end

fish = compose(context(units=UnitBox(260, 260)), stroke("black"),
            read_path(strip(readall("fish.path"))))

rotatable(pic) = @manipulate for θ=0:0.001:2π
    compose(context(rotation=Rotation(θ)), pic)
end

blank = compose(context())

fliprot45(pic) = rot45(compose(context(mirror=Mirror(deg2rad(-45))),pic))

# Hide this cell.
display(MIME("text/html"), """<script>
var cell = \$(".container .cell").eq(0), ia = cell.find(".input_area")
if (cell.find(".toggle-button").length == 0) {
ia.after(
    \$('<button class="toggle-button">Toggle hidden code</button>').click(
        function (){ ia.toggle() }
        )
    )
ia.hide()
}
</script>""")
```

# Functional Geometry
*Functional Geometry* is a paper by Peter Henderson ([original (1982)](users.ecs.soton.ac.uk/peter/funcgeo.pdf), [revisited (2002)](https://cs.au.dk/~hosc/local/HOSC-15-4-pp349-365.pdf)) which deconstructs the MC Escher woodcut *Square Limit*

![Square Limit](http://i.imgur.com/LjRzmNM.png)


> A picture is an example of a complex object that can be described in terms of its parts.
Yet a picture needs to be rendered on a printer or a screen by a device that expects to
be given a sequence of commands. Programming that sequence of commands directly is
much harder than having an application generate the commands automatically from the
simpler, denotational description.


A `picture` is a *denotation* of something to draw.

e.g. The value of f here denotes the picture of the letter F


Original at http://nbviewer.jupyter.org/github/shashi/ijulia-notebooks/blob/master/funcgeo/Functional%20Geometry.ipynb


## In conclusion

We described Escher's *Square Limit* from the description of its smaller parts, which in turn were described in terms of their smaller parts.

This seemed simple because we chose to talk in terms of an *algebra* to describe pictures. The primitives `rot`, `flip`, `fliprot45`, `above`, `beside` and `over` fit the job perfectly.

We were able to describe these primitives in terms of `compose` `contexts`, which the Compose library knows how to render.

Denotation can be an easy way to describe a system as well as a practical implementation method.

[Abstraction barriers](https://mitpress.mit.edu/sicp/full-text/sicp/book/node29.html) are useful tools that can reduce the cognitive overhead on the programmer. It entails creating layers consisting of functions which only use functions in the same layer or layers below in their own implementation. The layers in our language were:

    ------------------[ squarelimit ]------------------
    -------------[ quartet, cycle, nonet ]-------------
    ---[ rot, flip, fliprot45, above, beside, over ]---
    -------[ compose, context, line, path,... ]--------
    
Drawing this diagram out is a useful way to begin building any library.

---
jupyter:
  kernelspec:
    display_name: Python 3 (ipykernel)
    language: python
    name: python3
---

<!-- #region @deathbeds/jupyterlab-fonts={"styles": {"": {"body[data-jp-deck-mode='presenting'] &": {"right": "0", "top": "30%", "width": "25%", "z-index": 1}}}} jupyterlab-slideshow={"layer": "slide"} -->
> **Note**
> 
> `slide` layer with a `top` of `30%`
<!-- #endregion -->

---
kernelspec:
  display_name: Python 3
  language: python
  name: python3
---

```{raw-cell}
:raw_mimetype: text/latex

$1+1$
```

```{raw-cell}
:raw_mimetype: text/restructuredtext

:math:`1+1`
```

```{raw-cell}
:raw_mimetype: text/html

<b>Bold text<b>
```

```{raw-cell}
:raw_mimetype: text/markdown

**Bold text**
```

```{raw-cell}
:raw_mimetype: text/x-python

1 + 1
```

```{raw-cell}
Not formatted
```

---
jupyter:
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  nbformat: 4
  nbformat_minor: 2
---

::: {.cell .markdown}
This notebook contains complex outputs, including plotly javascript graphs.
:::

::: {.cell .markdown}
# Interactive plots
:::

::: {.cell .markdown}
We use Plotly\'s connected mode to make the notebook lighter - when connected, the notebook downloads the `plotly.js` library from the web.
:::

::: {#cell-1 .cell .code}
``` python
import plotly.offline as offline
offline.init_notebook_mode(connected=True)
```
:::

::: {#cell-2 .cell .code}
``` python
import plotly.graph_objects as go
fig = go.Figure(
    data=[go.Bar(y=[2, 3, 1])],
    layout=go.Layout(title="bar plot"))
fig.show()
fig.data[0].marker = dict(color='purple')
fig
```
:::

The below derives from
https://github.com/yihui/knitr/blob/master/inst/examples/knitr-spin.R

This is a special R script which can be used to generate a report. You can
write normal text in roxygen comments.

First we set up some options (you do not have to do this):

```{r setup, include=FALSE}
library(knitr)
opts_chunk$set(fig.path = 'figure/silk-')
```

The report begins here.

```{r test-a, cache=FALSE}
# boring examples as usual
set.seed(123)
x = rnorm(5)
mean(x)
```

You can not use here the special syntax {{code}} to embed inline expressions, e.g.
```{r}
{{mean(x) + 2}}
```
is the mean of x plus 2.
The code itself may contain braces, but these are not checked.  Thus,
perfectly valid (though very strange) R code such as `{{2 + 3}} - {{4 - 5}}`
can lead to errors because `2 + 3}} - {{4 - 5` will be treated as inline code.

Now we continue writing the report. We can draw plots as well.

```{r test-b, fig.height=5, fig.width=5}
par(mar = c(4, 4, .1, .1)); plot(x)
```

Actually you do not have to write chunk options, in which case knitr will use
default options. For example, the code below has no options attached:

```{r}
var(x)
quantile(x)
```

And you can also write two chunks successively like this:

```{r test-chisq5}
sum(x^2) # chi-square distribution with df 5
```
```{r test-chisq4}
sum((x - mean(x))^2) # df is 4 now
```

Done. Call spin('knitr-spin.R') to make silk from sow's ear now and knit a
lovely purse.

```{r}
# /* you can write comments between /* and */ like C comments (the preceding #
# is optional)
Sys.sleep(60)
# */
```

```{r}
# /* there is no inline comment; you have to write block comments */
```
